#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll mod = 1000000007;

#define x first
#define y second

template<typename T>
istream& operator >> (istream& in, vector<T> &v) {
    for (int i = 0; i < v.size(); i++) {
        in >> v[i];
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v) {
    for (int i = 0; i < v.size(); i++) {
        out << v[i] << ' ';
    }
    return out;
}

struct node {
    int s, l, r;
};

vector<node> tree(100001, {0, 0, 0});
int last = 0;

int dfs(int a, int b) {
    if (!b && !a) return 0;
    int cur = last;
    last++;
    if (a % 2) {
        if (b % 2) {
            tree[cur].l = dfs(a / 2, b / 2);
            tree[cur].r = dfs((a + 1) / 2, b / 2);
            tree[cur].s = 2;
        } else {
            tree[cur].l = dfs(a / 2, b / 2);
            tree[cur].r = dfs(a / 2, b / 2);
            tree[cur].s = 1;
        }
    } else {
        if (b % 2) {
            tree[cur].l = dfs(a / 2, b / 2);
            tree[cur].r = dfs(a / 2, b / 2);
            tree[cur].s = 2;
        } else {
            if (!a) return -1;
            tree[cur].l = dfs((a - 1) / 2, b / 2);
            tree[cur].r = dfs(a / 2, b / 2);
            tree[cur].s = 1;
        }
    }

    if (tree[cur].l == -1 || tree[cur].r == -1) return -1;
    else return cur + 1;
}

void solve() {
    int a, b;
    cin >> a >> b;

    if (dfs(a, b) == -1) {
        cout << -1;
        return;
    }

    for (int i = 0; i < last; i++) {
        cout << tree[i].s << ' ' << tree[i].l << ' ' << tree[i].r << endl;
    }

    /*if (a + b > 2) {
        if (b) cout << "2 2 3\n";
        else cout << "1 2 3\n";
        int n = a + b;
        b--;
        for (int i = 2; i <= n; i++) {
            if (b) cout << 2;
            else if (a) cout << 1;
            if (i % 2) {
                cout << " 0 " << i + 2 << endl;
            } else {
                cout << " " << i + 2 << " 0" << endl;
            }
        }
    }*/
}

int main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//	cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}