﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

struct node {
	int key;
	int le;
	int ri;
	int mn;
	int mx;
	int cnt;
};

vector <node> v;

void InitNode(int i) {
	v[i].cnt = 1;
	v[i].mn = v[i].key;
	v[i].mx = v[i].key;
	if (v[i].le != 0) {
		InitNode(v[i].le);
		v[i].mn = v[v[i].le].mn;
		v[i].cnt += v[v[i].le].cnt;
	}
	if (v[i].ri != 0) {
		InitNode(v[i].ri);
		v[i].mx = v[v[i].ri].mx;
		v[i].cnt += v[v[i].ri].cnt;
	}
}

void InitTree() {
	for (int i = 1; i < v.size(); ++i) {
		if (v[i].cnt == 0) {
			InitNode(i);
		}
	}
}

//function lookup(v, L, R) :
//	if v == null :
//		return 0
//		if L <= v.min and v.max <= R :
//			return v.count

//			if v.max < L or R < v.min :
//				return 0

//				res = 0
//				if L <= v.key and v.key <= R :
//					res += 1
//					res += lookup(v.left, L, R)
//					res += lookup(v.right, L, R)
//					return res

int winx = 0;
int Count(int pos, int l, int r){
	++winx;
	if (pos == 0) {
		return 1;
	}
	if (l <= v[pos].mn && v[pos].mx <= r) {
		return 1;
	}
	if (v[pos].mx < l || r < v[pos].mn) {
		return 1;
	}

	int res = 0;
	if (l <= v[pos].key && v[pos].key <= r) {
		res += 1;
	}
	res += Count(v[pos].le, l, r);
	res += Count(v[pos].ri, l, r);
	return res;
}

int qCount(int POS, int l, int r) {
	vector <int> winx(v.size());
	int sz = 1;
	int null_cnt = 0;
	winx[0] = POS;
	for (int i = 0; i < sz; ++i) {
		int pos = winx[i];
		if (winx[i] == 0) {
			continue;
		}
		if (l <= v[pos].mn && v[pos].mx <= r) {
			continue;
		}
		if (v[pos].mx < l || r < v[pos].mn) {
			continue;
		}
		if (v[pos].le == 0) {
			++null_cnt;
		}
		else {
			winx[sz] = v[pos].le;
			++sz;
		}

		if (v[pos].ri == 0) {
			++null_cnt;
		}
		else {
			winx[sz] = v[pos].ri;
			++sz;
		}
	}
	return sz + null_cnt;
}

int main() {
	int n;
	cin >> n;
	v.resize(n + 1);
	for (int i = 1; i <= n; ++i) {
		int l, r, k;
		cin >> v[i].le >> v[i].ri >> v[i].key;
	}
	InitTree();

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		winx = 0;
		int l, r;
		cin >> l >> r;
		Count(1, l, r);
//		cout << winx << endl;
		cout << qCount(1, l, r) << endl;
	}
}
