#include <stack>
#include <string>
#include <bitset>
#include <unordered_map>
#include <cstdio>
#include <limits>
#include <vector>
#include <climits>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <numeric>
#include <sstream>
#include <cassert>
#include <iomanip>
#include <random>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <map>
#include <set>
#include <list>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <chrono>

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)(x.size())
#define endl "\n"
#define int long long

using namespace std;

typedef long long ll;

const int N = (int)(5e5) + 322;
const int mod = (int)(1e9) + 7;
const int inf = (int)(1e18);

int n;
vector <int> v[N];

bool check(int x) {
    unordered_map <int, int> last;
    for(int i = n; i >= 1; --i) {
        int mn = x + 1;
        for(auto it : v[i]) {
            if (last.count(it)) {
                mn = min(mn, last[it]);
            }
        }
        if (mn <= 1) return false;
        for(auto it : v[i]) last[it] = mn - 1;
    }
    return true;
}

void solve() {
    cin >> n;
    for(int i = 1; i <= n; ++i) {
        int k; cin >> k;
        for(int j = 1; j <= k; ++j) {
            int x; cin >> x;
            v[i].push_back(x);
        }
    }
    int l = 1, r = n;
    int ans = -1;
    while (l <= r) {
        int mid = (l + r) / 2;
        if (check(mid)) {
            ans = mid;
            r = mid - 1;
        }else {
            l = mid + 1;
        }
    }
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(false);cin.tie(0);
    int t = 1;
//    cin >> t;
    for(int tt = 0; tt < t; ++tt) {
        solve();
    }
    return 0;
}