#include <bits/stdc++.h>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
 
using namespace std;
using namespace __gnu_pbds;
 
typedef unsigned long long ull;
typedef long long ll;

#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define speedhack() ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define form(i, n) for (size_t i = 0; i < size_t(n); ++i)
#define forn(i, n) for (size_t i = 1; i <= size_t(n); ++i)

template<class T> using ordered_set=tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

ll mod(ll a, ll b) { return (a%b+b)%b; }
ll gcd(ll x, ll y) { return __gcd(x, y); }
ll lcm(ll x, ll y) { return x * 1ll * y / gcd(x, y); }
 
const ll MAXN = 1e18;
const ll SIZE = 2e5 + 5;
const ll MOD  = 1e9 + 7;
const ll MODY = 998244353;

ll a, b, cur, lef, pw = 1, color[2][1000001];
queue <pair<ll, ll>> q;
map<ll, ll> mp;
bool ok = true;

void bfs () {
    q.push ({1, a});
    while (!q.empty ()) {
        int v = q.front ().first;
        int A = q.front ().second;
        q.pop ();

        if (cur) {
            --cur;
            color[0][v] = color[1][v] = 2;
            q.push ({v * 2, A / 2});
            q.push ({v * 2 + 1, (A / 2) + (A % 2)});
        } else if (A) {
            --A;
            color[0][v] = color[1][v] = 1;
            q.push ({v * 2, A / 2});
            q.push ({v * 2 + 1, (A / 2) + (A % 2)});
        }
    }
}

void dfs (ll v) {
    if (color[1][v] == 0) return;
    dfs (v * 2);
    dfs (v * 2 + 1);
    color[0][v] += color[0][v * 2];
    color[0][v] += color[0][v * 2 + 1];

    ll diff = abs (color[0][v * 2] - color[0][v * 2 + 1]);
    if (diff > 1)
        ok = false;
}


int main() { speedhack()

    cin >> a >> b;
    while (cur + pw <= b) {
        cur += pw;
        pw *= 2;
    }
    b -= cur;
    lef = b;
    a += b;
    bfs ();

    for (ll i = 2; i <= 1000000; i++) {
        ll parent = i / 2;
        ll lch = parent * 2;
        ll rch = parent * 2 + 1;
        if (lch * 2LL <= 1000000) {
            if (lef > 0 && color[1][lch] == 1 && color[1][lch * 2] == 0 && color[1][lch * 2 + 1] == 0) {
                if (color[1][rch * 2] || color[1][rch * 2 + 1]) {
                    color[1][lch] = 2;
                    --lef;
                }
            } else if (lef > 0 && color[1][rch] == 1 && color[1][rch * 2] == 0 && color[1][rch * 2 + 1] == 0) {
                if (color[1][lch * 2] || color[1][lch * 2 + 1]) {
                    color[1][rch] = 2;
                    --lef;
                }
            }
        }
    }

    for (int i = 1, j = 1; i <= 1000000; i++) 
        if (color[i]) 
            mp[i] = j++;

    if (lef > 0 || ok == false) {
        cout << -1;
        return 0;
    } else {
        for (int i = 1; i <= 1000000; i++) {
            if (color[i]) {
                cout << color[1][i];
                if (color[1][i * 2]) cout << " " << mp[i * 2];
                else cout << " 0";
                if (color[1][i * 2 + 1]) cout << " " << mp[i * 2 + 1];
                else cout << " 0";
                cout << endl;
            }
        }
    }




    return 0;
}
