#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<algorithm>
#include<map>
#include<vector>
#include<set>
#include<stack>
#include<iostream>
#include<stdio.h>
#include<math.h>
#include<string>
#include<iomanip>
#include<unordered_set>
#include <random>
#include <time.h> 
#include<climits>
#pragma comment(linker, "/STACK:512777215")

using namespace std;

typedef long long ll;
const long double eps = 1e-8;
const int inf = 1e9;
const ll INF = 1e18;
const ll mod = inf + 7;
const double pi = 3.1415926535;
#define max_n 10000000
#define nl '\n'
#define cint(n) int n; cin >> n
#define cill(n) ll n; cin >> n
#define dbg(x) cout << (#x) << ": " << x << nl
#define elif else if

inline void io() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef NoSteam
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
}

ll gcd(ll a, ll b) {
    while (b != 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

struct node {
    int key;
    int left;
    int right;
    int min;
    int max;
    int count;
    int add;
};

node tree[200010];

void calc(int v) {
    if (v == -1) {
        return;
    }
    tree[v].max = tree[v].key;
    tree[v].min = tree[v].key;
    tree[v].count = 1;
    tree[v].add = 1;
    if (tree[v].left != -1) {
        calc(tree[v].left);
        tree[v].max = max(tree[v].max, tree[tree[v].left].max);
        tree[v].min = min(tree[v].min, tree[tree[v].left].min);
        tree[v].count += tree[tree[v].left].count;
    }
    else {
        tree[v].add++;
    }
    if (tree[v].right != -1) {
        calc(tree[v].right);
        tree[v].max = max(tree[v].max, tree[tree[v].right].max);
        tree[v].min = min(tree[v].min, tree[tree[v].right].min);
        tree[v].count += tree[tree[v].right].count;
    }
    else {
        tree[v].add++;
    }
}

int lookup(int v, int L, int R) {
    if (L <= tree[v].min && tree[v].max <= R)
        return 1;
    if (tree[v].max < L || R < tree[v].min)
        return 1;
    int res = tree[v].add;
    if(tree[v].left != -1)
        res += lookup(tree[v].left, L, R);
    if(tree[v].right != -1)
        res += lookup(tree[v].right, L, R);
    return res;
}

int main()
{
    io();
    cint(n);
    for (int i = 0; i < n; i++) {
        cin >> tree[i].left >> tree[i].right >> tree[i].key;
        tree[i].left--;
        tree[i].right--;
    }
    calc(0);
    cint(q);
    int l, r;
    for (int i = 0; i < q; i++) {
        cin >> l >> r;
        cout << lookup(0, l, r) << nl;
    }
}