#include <iostream>
#include <string>
#include <vector>

using namespace std;

const int kMaxN = 1e5 + 10;

int last_sign[kMaxN];

int main() {
    int n;
    cin >> n;

    int k, cur_sign = 1;
    for (auto i = 0; i < n; ++i) {
        cin >> k;
        vector<int> cur_day(k);
        auto change_sign = 0;
        for (auto j = 0; j < k; ++j) {
            cin >> cur_day[j];
            change_sign = change_sign || last_sign[cur_day[j]] == cur_sign;
        }
        cur_sign += change_sign;
        for (auto person : cur_day) {
            last_sign[person] = cur_sign;
        }
    }
    cout << cur_sign;
    return 0;
}
