#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include <functional>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<numeric>
#include <chrono>
#include<sstream>
#include <valarray> 

//by Skeef79

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#pragma warning(disable : 4996)
#pragma comment(linker, "/STACK:16777216")
#define pb push_back
#define en '\n'
#define for0(i,n) for(int i = 0;i<n;i++)
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define vec vector
#define pii pair<int,int>
#define pll pair<ll,ll>
#define what_is(x) cout<<#x<<" is "<<x<<en;
#define SZ(x) int(x.size())

using namespace std;

const int INF = 1000000000 + 1e8;
const ll LINF = 2000000000000000000;

template<typename T> void print(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
			cout << a[i][j] << ' ';
		cout << en;
	}
}

template <typename T> void input(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
		for (int j = 0; j < a[i].size(); j++)
			cin >> a[i][j];
}

int t[int(5e5)];
int sum[int(5e5)];

void printAns()
{
	map<int, int>mp;
	int sz = 1;
	for (int i = 0; i<int(5e5); i++)
		if (t[i] != -1)
		{
			if (!mp.count(i))
				mp[i] = sz++;

			if (t[2 * i + 1] != -1)
				mp[2 * i + 1] = sz++;

			if (t[2 * i + 2] != -1)
				mp[2 * i + 2] = sz++;
		}

	for (int i = 0; i<int(5e5); i++)
		if (t[i] != -1)
		{
			cout << t[i] << ' ';

			if (t[2 * i + 1] != -1)
				cout << mp[2 * i + 1] << ' ';
			else
				cout << 0 << ' ';
			if (t[2 * i + 2] != -1)
				cout << mp[2 * i + 2] << ' ';
			else
				cout << 0 << ' ';
			cout << en;
		}
}

void solve()
{
	int a, b;
	cin >> a >> b;
	int n = a + b;

	for (int i = 0; i<int(5e5); i++)
		t[i] = -1;

	if (a == 0 && b % 2 == 0)
	{
		cout << -1;
		return;
	}

	int bb = b, aa = a;
	if (b % 2)
	{
		t[0] = 2;
		b--;
	}
	else
	{
		t[0] = 1;
		a--;
	}

	int kk = 1;
	for (; kk < 20; kk++)
		if ((1 << (kk + 1)) - 1 > n)
			break;

	for (int k = 0; k < (1 << kk); k++)
	{
		vector<int>v;
		for (int i = (1 << k) - 1; i < (1 << (k + 1)) - 1; i++)
			v.pb(i);
		int mid = SZ(v) / 2;
		if (b == 0)
			break;

		if (mid == 0)
		{
			t[1] = 2;
			t[2] = 2;
			b -= 2;
			if (b == 0)
				break;
		}

		bool done = false;
		for (int i = 0; i < mid; i++)
		{
			if (b == 0)
			{
				done = true;
				break;
			}
			else
			{
				int v1 = v[i];
				int v2 = v[i] + mid;
				t[2 * v1 + 1] = 2;
				t[2 * v2 + 1] = 2;
				b -= 2;
			}
		}
		if (done)
			break;

		for (int i = 0; i < mid; i++)
		{
			if (b == 0)
			{
				done = true;
				break;
			}
			else
			{
				int v1 = v[i];
				int v2 = v[i] + mid;
				t[2 * v1 + 2] = 2;
				t[2 * v2 + 2] = 2;
				b -= 2;
			}
		}
		if (done)
			break;
	}

	for (int i = 0; i < (1 << (kk+1)) - 1; i++)
		if (t[i] == -1)
		{
			t[i] = 1;
			a--;
		}

	for (int i = 0; i<int(5e5); i++)
	{
		if (t[i] != -1)
		{
			sum[i] += t[i];
			if (t[2 * i + 1] != -1)
				sum[2 * i + 1] += sum[i];
			if (t[2 * i + 2] != -1)
				sum[2 * i + 2] += sum[i];
		}
	}

	a = abs(a);
	
	if (a == 0)
	{
		printAns();
		return;
	}

	int mx = -1;
	int mn = INF;

	for (int i = (1 << (kk)) - 1; i < (1 << (kk + 1)) - 1; i++)
	{
		mx = max(mx, sum[i]);
		mn = min(mn, sum[i]);
	}

	int ccnt = 0;
	for (int i = (1 << (kk)) - 1; i < (1 << (kk + 1)) - 1; i++)
		ccnt++;
	int mid = ccnt / 2;

	if (a == ccnt)
	{
		for (int i = (1 << (kk)) - 1; i < (1 << (kk + 1)) - 1; i++)
			t[i] = -1;
		printAns();
		return;
	}

	if (mx != mn)
	{
		//nepravda

		for (int i = (1 << (kk)) - 1; i < (1 << (kk + 1)) - 1; i++)
			if (t[i] == 2)
			{
				cout << -1;
				return;
			}

		for (int i = (1 << (kk)) - 1; i < (1 << (kk)) - 1 + mid; i += 2)
		{
			if (sum[i]==mx)
				if (a >= 2)
				{
					a -= 2;
					t[i] = -1;
					t[i + mid] = -1;
				}
				else
				{
					if (a == 1)
					{
						t[i] = -1;
						a = 0;
					}
					break;
				}
		}

		if (a != 0)
		{
			for (int i = (1 << (kk)); i < (1 << (kk)) - 1 + mid; i += 2)
			{
				if (sum[i]==mx)
					if (a >= 2)
					{
						a -= 2;
						t[i] = -1;
						t[i + mid] = -1;
					}
					else
					{
						if (a == 1)
						{
							t[i] = -1;
							a = 0;
						}
						break;
					}
			}
		}

		if (a != 0)
		{
			for (int i = (1 << (kk)) - 1; i < (1 << (kk)) - 1 + mid; i += 2)
			{
				if (sum[i] == mn)
					if (a >= 2)
					{
						a -= 2;
						t[i] = -1;
						t[i + mid] = -1;
					}
					else
					{
						if (a == 1)
						{
							t[i] = -1;
							a = 0;
						}
						break;
					}
			}

			if (a != 0)
			{
				for (int i = (1 << (kk)); i < (1 << (kk)) - 1 + mid; i += 2)
				{
					if (sum[i] == mn)
						if (a >= 2)
						{
							a -= 2;
							t[i] = -1;
							t[i + mid] = -1;
						}
						else
						{
							if (a == 1)
							{
								t[i] = -1;
								a = 0;
							}
							break;
						}
				}
			}
		}

		
	}
	else
	{
		for (int i = (1 << (kk)) - 1; i < (1 << (kk)) - 1 + mid; i += 2)
		{
			if (t[i] == 1)
				if (a >= 2)
				{
					a -= 2;
					t[i] = -1;
					t[i + mid] = -1;
				}
				else
				{
					if (a == 1)
					{
						t[i] = -1;
						a = 0;
					}
					break;
				}
		}

		if (a != 0)
		{
			for (int i = (1 << (kk)); i < (1 << (kk)) - 1 + mid; i += 2)
			{
				if (t[i] == 1)
					if (a >= 2)
					{
						a -= 2;
						t[i] = -1;
						t[i + mid] = -1;
					}
					else
					{
						if (a == 1)
						{
							t[i] = -1;
							a = 0;
						}
						break;
					}
			}
		}
	}

	if (a != 0)
	{
		cout << -1;
		return;
	}

	printAns();

	//for (int i = 0; i < 50; i++)
		//cout << t[i] << ' ';

}

int main()
{
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

#ifdef _DEBUG	
	freopen("input.txt", "r", stdin);
#endif
	//freopen("out.txt", "w", stdout);

	//freopen("igoreha.in", "r", stdin);
	//freopen("igoreha.out", "w", stdout);

	int tst = 1;
	//cin >> tst;

	while (tst--)
		solve();
}