#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include "stdio.h"
#include "stdlib.h"
#include "time.h"
#include <cmath>
#include <math.h>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <bitset>
#include <functional>
#include <intrin.h>
#include <stack>
#include <unordered_map>
#include <unordered_set>
#define fs first 
#define sc second 
#define pll pair<ll, ll>
#define pii pair<int,int>
#define pb push_back
#define forn(i,n) for(ll i=0;i<n;i++)
typedef long long ll;
typedef unsigned long long ul;
typedef long double ld;
using namespace std;
const ll maxn = 200001;

using namespace std;

int n, m, k = 0, a, b, g, timer = 0, sq = 317;
int L = 1;
unordered_map<ll, ll> val,p;
vector<int> adj[100001], depth(100001, 0), up[100001], tin(100001, 0), tout(100001, 0);



void dfs(int q, int p = 0) {
	up[q][0] = p;
	tin[q] = ++timer;
	depth[q] = depth[p] + 1;
	for (int i = 1; i < L; i++)
		up[q][i] = up[up[q][i - 1]][i - 1];

	for (auto& g : adj[q]) {
		if (g == p)continue;
		dfs(g, q);
	}
	tout[q] = ++timer;
}

bool anc(int c, int v) {
	return tin[c] <= tin[v] && tout[c] >= tout[v];
}

int lca(int c, int v) {
	if (anc(c, v))return c;
	if (anc(v, c))return v;
	for (int i = L - 1; i >= 0; --i)
		if (!anc(up[c][i], v))
			c = up[c][i];

	return up[c][0];
}

inline int distance(int c, int v) {
	return depth[c] + depth[v] - 2 * depth[lca(c, v)];
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	std::srand(time(NULL));
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n = 0, m = 1, l, r;
	cin >> n;
	vector<ll> q;

	int k = 1;

	while (k <= n) { L++; k *= 2; }

	for (int i = 0; i < n; i++) {
		up[i].resize(L + 1);
	}
	

	for(int i=0;i<n;i++){
		cin >>l >> r>> val[i] ;
		l--; r--;
		if(l!=-1)adj[i].pb(l);
		if(r!=-1)adj[i].pb(r);
		
		p[val[i]] = i;
		q.push_back(val[i]);
	}
	
	dfs(0);

	cin >> m;
	while (m--) {
		cin >> l >>r;
		l = p[*lower_bound(q.begin(), q.end(), l)];
		auto y  = upper_bound(q.begin(), q.end(), r);
		if (y == q.end())r = q.back();
		else r = p[*(y - 1)];
		cout << min(depth[l],depth[r]) + lca(l, r) << '\n';

	}



}