fun main() {
    val n = readInt()
    val uniqueSeen = IntArray(100_500) { 0 }
    for (day in n downTo 1) {
        val data = readInts()
        val k = data[0]
        val maxUniqueSeen = IntRange(1, k).map { uniqueSeen[data[it]] }.maxOrNull() ?: 0
        IntRange(1, k).forEach { uniqueSeen[data[it]] = maxUniqueSeen + 1 }
    }
    println(uniqueSeen.maxOrNull())
}


/**
 * IO functions
 */
private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLong() = readLn().toLong()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
private fun readLongs() = readStrings().map { it.toLong() }
private fun readDoubles() = readStrings().map { it.toDouble() }