class Sol:
    def __init__(self):
        self.count = 0
    
    def lookup(self, v, L, R):
        self.count += 1
        if v == None:
            return 0
        if L <= v.min and v.max <= R:
            return v.count
        if v.max < L or R < v.min:
            return 0
        res = 0
        if L <= v.key and v.key <= R:
            res += 1
        res += self.lookup(nodes[v.left], L, R)
        res += self.lookup(nodes[v.right], L, R)
        return res

class Node:
    def __init__(self, left, right, key):
        self.left = left
        self.right = right
        self.key = key
        self.max = None
        self.min = None
        self.count = 1

def build(root):
    if nodes[root.left] == None:
        root.min = root.key
    else:
        build(nodes[root.left])
        root.min = nodes[root.left].min
        root.count += nodes[root.left].count
    if nodes[root.right] == None:
        root.max = root.key
    else:
        build(nodes[root.right])
        root.max = nodes[root.right].max
        root.count += nodes[root.right].count



n = int(input())

nodes = [None]*(n+1)
for i in range(1, n+1):    
    l, r, key = [int(x) for x in input().split()]
    nodes[i] = Node(l, r, key)
build(nodes[1])

q = int(input())
for _ in range(q):
    s = Sol()
    l, r = [int(x) for x in input().split()]
    s.lookup(nodes[1], l, r)
    print(s.count)