#include <iomanip>
#include <iostream>
#include <cmath>
#include <string>
#include <vector>
#include <stack>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <bitset>
#include <functional>

using namespace std;
#define endl "\n"
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> v(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            v[i].push_back(a);
        }
    }

    int ans = 1;
    unordered_set<int> m;
    for (int i = n - 1; i >= 0; i--) {
        auto flag = 0;
        for (auto &x : v[i]) {
            flag = flag || m.find(x) != m.end();
            m.insert(x);
        }
        ans += flag;
    }

    cout << ans;

    return 0;
}
