#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 100500;
const int inf = 1e9;

vector<int> edge[maxn];
vector<int> cur;
vector<int> ans;
int color[maxn];

void Solve() {
    if (cur.empty()) {
        return;
    }
    // for (auto x : cur) {
    //     cout << x << ' ';
    // }
    // cout << endl;
    int v = cur.back();
    cur.pop_back();
    if (color[v]) {
        cur.insert(cur.end(), edge[v].begin(), edge[v].end());
    }
    Solve();
    if (color[v]) {
        for (int i = 0; i < edge[v].size(); ++i) {
            cur.pop_back();
        }
    } else {
        cur.insert(cur.end(), edge[v].begin(), edge[v].end());
    }
    color[v] ^= 1;
    ans.push_back(v);
    Solve();

    if (color[v]) {
        for (int i = 0; i < edge[v].size(); ++i) {
            cur.pop_back();
        }
    }

    cur.push_back(v);
}

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    // freopen("dome.in", "r", stdin);
    // freopen("dome.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        int anc;
        cin >> anc;
        edge[anc].push_back(i);
    }

    cur = edge[1];
    Solve();
    cout << ans.size() << endl;
    for (auto x : ans) {
        cout << x << ' ';
    } 
}