#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp> // Общий файл.
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

ll BinPow(ll a, ll b, ll mod) {
    ll result = 1;

    while (b) {
        if (b & 1) {
            result *= a;
            result %= mod;
        }

        a *= a;
        a %= mod;
        b >>= 1;
    }

    return result;
}

ll MulMod(ll a, ll b, ll mod) {
    ll result = 0;

    while (b) {
        if (b & 1) {
            result += a;
            result %= mod;
        }

        a *= 2;
        a %= mod;
        b >>= 1;
    }

    return result;
}

ll RevElement(ll a, ll mod) {
    return BinPow(a, mod - 2, mod);
}

ll calc(ll x, ll y) {
    return -x * y;
}

ll nextInt() {
    char c = getchar();
    ll res = 0;

    do {
        res *= 10;
        res += c - '0';
        c = getchar();
    } while (c >= '0' && c <= '9');

    return res;
}

const int INF = 1e9;
const int MAX_N = 200000;
int weight[MAX_N], child[2][MAX_N];
int cnt;

void construct(int v, int a, int b) {
    if (!a && !b) {
        return;
    }

    if (b > 0) {
        weight[v] = 2;
        b -=1;
    } else {
        weight[v] = 1;
        a -= 1;
    }

    int sum = a + 2*b;
    int nb = b / 2;
    int na = a / 2;
    int sum1 = na + 2 * nb;
    int sum2 = sum - sum1;

    while (sum2 - sum1 > 1 && na < a) {
        na++;
        sum2--;
        sum1++;
    }

    if (abs(sum1 - sum2) > 1) {
        cout << -1;
        exit(0);
    }

    nb = b / 2;
    if (sum1 > 0) {
        child[0][v] = cnt++;
        construct(child[0][v] - 1, na, nb);
    }
    if (sum2 > 0) {
        child[1][v] = cnt++;
        construct(child[1][v] - 1, a - na, b - nb);
    }
}

void Solve() {
    int a, b;
    cin >> a >> b;
    cnt = 2;
    construct(0, a, b);

    for (int i = 0; i < a + b; ++i) {
        cout << weight[i] << " " << child[0][i] << " " << child[1][i] << '\n';
    }
}

int main() {
    //    freopen("flow.in", "r", stdin);
    //    freopen("flow.out", "w", stdout);
    //freopen("../in", "r", stdin);
    //freopen("../out.txt", "w", stdout);
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    Solve();
    return 0;
}