#include <bits/stdc++.h>

using namespace std;

int ans;

struct vertex
{
    int key = 0;
    int minkey = 2147000000;
    int maxkey = -2147000000;
    int left = 0;
    int right = 0;
};

vertex a[200042];

void lookup(int v, int L, int R)
{
    ans++;
    if (v == 0) return;
    if (L <= a[v].minkey && a[v].maxkey <= R) return;
    if (R < a[v].minkey || a[v].maxkey < L) return;
    lookup(a[v].left, L, R);
    lookup(a[v].right, L, R);
    return;
}

void dfs(int v)
{
    if (v == 0) return;
    dfs(a[v].left);
    dfs(a[v].right);
    a[v].minkey = min(a[v].key, a[a[v].left].minkey);
    a[v].maxkey = max(a[v].key, a[a[v].right].maxkey);
}

int main()
{
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int l, r, x;
        cin >> l >> r >> x;
        a[i].key = x;
        a[i].left = l;
        a[i].right = r;
    }
    dfs(1);
    int q;
    cin >> q;
    while (q--)
    {
        int l, r;
        cin >> l >> r;
        ans = 0;
        lookup(1, l, r);
        cout << ans << '\n';
    }
    return 0;
}

