#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 3e5;

int n;
int arr[N];
int dp[N][1 << 8];

int calcDif(int x, int y) {
    return 8 - __builtin_popcount(x ^ y);
}

int solveDp(int u, int wins) {
    int& res = dp[u][wins];
    if (res != 0) {
        return res;
    }
    if (u == 0) {
        return res = (wins & 1) ? 1 : -1;
    }
    int prevWins = wins << 1;
    int v = u - 1;
    for (int dv = 1; dv <= 8 && v + dv < n; ++dv) {
        if (prevWins & (1 << dv)) {
            continue;
        }
        if (dv <= calcDif(arr[v], arr[v + dv])) {
            prevWins |= 1;
            break;
        }
    }
    return res = solveDp(v, prevWins & ((1 << 8) - 1));
}

void run() {

    cin >> n;
    for (int i = 0; i < n; ++i) {
        string line;
        cin >> line;
        for (int j = 0; j < 8; ++j) {
            arr[i] |= ((line[j] == 'W') << j);
        }
    }

    for (int pref = 0; pref < n; ++pref) {
        cout << (solveDp(pref, (1 << 8) - 2) == 1 ? 1 : 2);
    }

}

int main() {
    ios::sync_with_stdio(0);
    cout.tie(0), cin.tie(0);

    //freopen("input.txt", "r", stdin);

    int z = 1;
    /// cin >> z;

    while (z--) {
        run();
    }

    return 0;
}


