#include <iostream>
#include <cmath>

int a, b;

struct Node {
	int cnt;

	int left;
	int right;
};
Node node[100000];
int n = 0;

bool build(int one, int two) {
	int w = n;
	n++;
	if (two > 0) {
		node[w].cnt = 2;
		two--;
	} else if (one > 0) {
		node[w].cnt = 1;
		one--;
	} else {
		return false;
	}

	int left2 = two / 2;
	int right2 = two - left2;
	
	int left1 = one - one / 2;
	int right1 = one - left1;

	int leftS = 2 * left2 + left1;
	int rightS = 2 * right2 + right1;

	if (std::abs(leftS - rightS) > 1) {
		if (leftS > rightS) {
			if (left1 > 0) {
				left1--;
				right1++;
				leftS--;
				right1++;
			} else {
				return false;
			}
		} else {
			if (right1 > 0) {
				left1++;
				right1--;
				leftS++;
				right1--;
			} else {
				return false;
			}
		}
	}

	if (leftS > 0) {
		node[w].left = n;
		if (!build(left1, left2)) {
			return false;
		}
	}
	if (rightS > 0) {
		node[w].right = n;
		if (!build(right1, right2)) {
			return false;
		}
	}

	return true;
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> a >> b;

	for (int i = 0; i < a + b; i++) {
		node[i].cnt = 0;
		node[i].left = -1;
		node[i].right = -1;
	}

	if (!build(a, b)) {
		std::cout << -1 << std::endl;
	} else {
		for (int i = 0; i < a + b; i++) {
			std::cout << node[i].cnt << " " << node[i].left + 1 << " " << node[i].right + 1 << "\n";
		}
	}

	return 0;
}
