#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <time.h>
#include <chrono>
#include <random>
//#include <math.h>
#include <cmath>
#include <fstream>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <stdlib.h>
#include <cstring>
#include <iomanip>
#include <cstdio>
#include <cassert>
#include <bitset>

#pragma comment(linker, "/STACK:36777216")
using namespace std;

typedef long long ll;

const int INFi = 1e9;
const ll INFll = 1e18;

using ld = double;

double eps = 1e-9;
const ld pi = acos(-1);

const int maxn = 2e5+65;
vector<int> g[maxn];
int val[maxn];
int sum[maxn];
int newV = 0;
void build(int root, int size) {
    sum[root] = size;
    val[root] = 1;
    size--;
    int szL = size/2;
    int szR = size - size/2;

    if (szL!=0) {
        int v = newV++;
        g[root].push_back(v);
        build(v, szL);
    }

    if (szR!=0) {
        int v = newV++;
        g[root].push_back(v);
        build(v, szR);
    }
}

void push(int root, int pushVal) {
    if (pushVal==0) return;
    val[root]++;
    pushVal--;
    int szL = g[root].size()<=0 ? 0 : sum[g[root][0]];
    int szR = g[root].size()<=1 ? 0 : sum[g[root][1]];
    if (szL<szR) {
        swap(g[root][0], g[root][1]);
        swap(szL, szR);
    }
    //sum[l]>= sum[r]
    //в меньшее пушим большее
    int pushL = pushVal/2;
    int pushR = pushVal  -pushVal/2;

    int newSzL = szL + pushL;
    int newSzR = szR + pushR;
    if (abs(newSzL - newSzR) > 1) {
        cout << -1;
        exit(0);
    }
    if (pushL>0) {
        if (szL==0) {
            cout << -1;
            exit(0);
        }
        push(g[root][0], pushL);
    }
    if (pushR>0) {
        if (szR==0) {
            cout << -1;
            exit(0);
        }
        push(g[root][1], pushR);
    }
}
void solve() {
    ll a,b;
    cin >> a >> b;
    ll n = a+b;
    newV = 2;
    build(1, n);
    push(1, b);
    for (int i=1;i<=n;i++) {
        while (g[i].size()<2) {
            g[i].push_back(0);
        }
        cout << val[i];
        for (auto& it: g[i]) {
            cout << " " << it;
        }
        cout << "\n";
    }
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt","r",stdin);
    //freopen("output.txt","w",stdout);
    cout << setprecision(15) << fixed;
    //int t;
    //cin >> t;
    //for (int i=0;i<t;i++)
    solve();
    return 0;
}