#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <stack>
#include <iomanip>
#include <cmath>
#include <functional>
#include <random>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <chrono>
#include <climits>
//#include <ext/rope>

#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

using namespace std;
//using namespace __gnu_cxx;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef long long ll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<ll, ll> pll;
typedef double ld;
typedef vector<bool> vb;

const int MAXN = 200010;
const int INF = 2e9;
const ll INFLL = 4e18;
const ll MOD = 1e9 + 7;

int gcd (ll a, ll b, ll &x, ll &y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd (b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

bool find_solution (ll a, ll b, ll c, ll &x0, ll &y0, ll &g) {
    g = gcd (abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0)   x0 *= -1;
    if (b < 0)   y0 *= -1;
    return true;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);
    cout << fixed;

    int n;
    cin >> n;
    forn (i, n) {
        ll a, b, c, d, g;
        cin >> b >> d;

        //find_solution(d, b, b * b, a, c, g);

        if (!find_solution(d, b, b * b, a, c, g)) {
            cout << 0 << "\n";
            continue;
        }

        ll mink;
        if (a < 0) {
            mink = -a / (b / g) + 1;
        }
        else {
            mink = -a / (b / g);
            if (a % (b / g) == 0) mink++;
        }
        ll maxk;
        if (c > 0) {
            maxk = c / (d / g);
            if (c % (d / g) == 0) maxk--;
        }
        else {
            maxk = c / (d / g) - 1;
        }

        if (maxk < mink) cout << 0 << "\n";
        else cout << maxk - mink + 1 << "\n";
    }
}