#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>

using namespace std;

#define int long long
/* F
const int P = 1e9 + 7;

int32_t main() {
    int a, b, c, n;
    vector<bool> sieve(1e6);
    vector<int> primes;
    primes.reserve(1e6);
    map<int, int> prime_k;
    for (int i = 3; i * i < sieve.size(); i += 2) {
        if (sieve[i] == false) {
            primes.push_back(i);
            for (int k = 3; k * i < sieve.size(); k += 2) {
                sieve[i * k] = true;
            }
        }
    }
    cin >> a >> b >> c >> n;
    int i = 0;
    int p = 1;
    while (n-- >= 0) {
        p *= (((a * (n * n % P) % P) + (b * n % P)) % P + c) % P;
    }
    int t = 1;
    int k = 0;
    while (!(p & 1)) {
        p >>= 1;
        k++;
    }
    if (k & 1) {
        k--;
    }
    t = (static_cast<long long>(1) << k) % P;
    for (const auto& prime : primes) {
        k = 0;
        while (p % prime) {
            k++;
            p /= prime;
        }
        if (k & 1) {
            k--;
        }
        while (k--) t = (t * prime) % P;
    }
    cout << t;
}
*/

struct node {
    int sum = 0;
    int w = 0;
    int l = 0;
    int r = 0;
};

int32_t main() {
    int ka, kb;
    cin >> ka >> kb;
    vector<node> t(1e6);
    vector<node> ans;
    t[0].sum = ka + 2 * kb;
    for (int i = 0; 2*i + 2 < t.size(); i++) {
        if (kb > 0 && t[i].sum >= 2) {
            t[i].w = 2;
            int s = t[i].sum - 2;
            t[2 * i + 1].sum = s / 2;
            t[2 * i + 2].sum = (s + 1) / 2;
            kb--;
        }
        else if (ka > 0 && t[i].sum > 0) {
            t[i].w = 1;
            int s = t[i].sum - 1;
            t[2 * i + 1].sum = s / 2;
            t[2 * i + 2].sum = (s + 1) / 2;
            ka--;
        }
        if (t[2 * i + 1].sum > 0) {
            t[i].l = 2 * i + 1;
        }
        if (t[2 * i + 2].sum > 0) {
            t[i].r = 2 * i + 2;
        }
        if (t[i].w > 0) {
            ans.push_back(t[i]);
        }
    }
    if (ka > 0 || kb > 0) {
        cout << -1 << endl;
    }
    else {
        for (const auto& a : ans) {
            cout << a.w << " " << a.l << " " << a.r << endl;
        }
    }
    return 0;
}