var sets: Array<HashSet<Int>>? = null

fun build(index: Int): List<Int> {
    if(sets!![index].size==0) return Array(1){index+1}.toList()

    var result = build(sets!![index].first())
    for (dot in sets!![index]) {
        if(dot == sets!![index].first()) continue
        else result = compare(result, build(dot))
    }
    return if(index == 1) result else Array(1+result.size){ if(it==0) index+1 else result[it-1]}.toList()
}

fun compare(A: List<Int>, B:List<Int>) : List<Int> {
    var newLength = B.size
    for (i in A.indices) {
        newLength+=B.size
    }
    newLength+=A.size
    val result = Array(newLength){0}
    var forward = false
    for (i in B.indices) {
        result[i] = B[i]
    }
    var index = B.size
    for (a in A) {
        result[index] = a
        index++
        if(forward) {
            for (i in B.indices) {
                result[index] = B[i]
                index++
            }
        }
        else {
            for (i in B.size-1 downTo 0) {
                result[index] = B[i]
                index++
            }
        }
        forward = !forward
    }
    return result.toList()
}

fun main() {
    val n = readLine()!!.toInt()
    sets = Array(n+1) { HashSet<Int>() }
    readLine()!!.split(" ").map { it.toInt() }.forEachIndexed { index, i ->
        sets!![i].add(index+2)
    }
    val answer = build(1)
    println(answer.size)
    println(answer.map { it-1 }.joinToString(" "))
}
