#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <string>
#include <sstream>
#include <iomanip>

using namespace std;

const int INF = 1000000000;

int gcd(int a, int b, int& x, int& y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	int x1, y1;
	int d = gcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

bool find_any_solution(int a, int b, int c, int& x0, int& y0, int& g) {
	g = gcd(abs(a), abs(b), x0, y0);
	if (c % g != 0)
		return false;
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}

void main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		int b, d;
		cin >> b >> d;
		int x, y, g;
		find_any_solution(d, b, b * b, x, y, g);
		cout << x << " " << y << " " << g << endl;
		double r = (double)x * (double)g / (double)b * (double)-1;
		double l = (double)y * (double)g / (double)d;
		int ans = abs((int)(r - l));
		if (abs((int)(r - l)) == abs(r - l)) --ans;
		cout << ans << endl;
	}
}
