def gcd(a, b):
	if a == 0:
		return 0, 1, b
	x1, y1, d = gcd(b % a, a)
	x = y1 - (b // a) * x1
	y = x1
	return x, y, d
	
def find_any(a, b, c):
	x0, y0, g = gcd(abs(a), abs(b))
	if c % g != 0:
		return False, 0, 0, 0
	
	x0 *= c // g
	y0 *= c // g
	
	if a < 0: x0 *= -1
	if b < 0: y0 *= -1
	return True, x0, y0, g
	
def solve(b, d):
	res, x0, y0, g = find_any(b, d, b * b)
	if not res:
		return 0
	stepX = d // g
	stepY = b // g
	
	if x0 <= 0:
		xK = (-x0) // stepX + 1
	else:
		xK = -((x0 - 1) // stepX)
	x = x0 + stepX * xK
	y = y0 - stepY * xK
	
	if y <= 0:
		return 0
	return (y - 1) // stepY + 1
	
t = int(input())
for it in range(t):
	b, d = map(int, input().split())
	print(solve(b, d))