/*
X⣿⣷⡁⢆⠈⠕⢕⢂⢕⢂⢕⢂⢔⢂⢕⢄⠂⣂⠂⠆⢂⢕⢂⢕⢂⢕⢂⢕⢂
X⣿⣿⡷⠊⡢⡹⣦⡑⢂⢕⢂⢕⢂⢕⢂⠕⠔⠌⠝⠛⠶⠶⢶⣦⣄⢂⢕⢂⢕
X⣿⠏⣠⣾⣦⡐⢌⢿⣷⣦⣅⡑⠕⠡⠐⢿⠿⣛⠟⠛⠛⠛⠛⠡⢷⡈⢂⢕⢂
X⣡⣾⣿⣿⣿⣿⣦⣑⠝⢿⣿⣿⣿⣿⣿⡵⢁⣤⣶⣶⣿⢿⢿⢿⡟⢻⣤⢑⢂
X⣿⣿⡿⢟⣛⣻⣿⣿⣿⣦⣬⣙⣻⣿⣿⣷⣿⣿⢟⢝⢕⢕⢕⢕⢽⣿⣿⣷⣔
X⣿⠵⠚⠉⢀⣀⣀⣈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣗⢕⢕⢕⢕⢕⢕⣽⣿⣿⣿⣿
X⣂⣠⣴⣾⡿⡿⡻⡻⣿⣿⣴⣿⣿⣿⣿⣿⣿⣷⣵⣵⣵⣷⣿⣿⣿⣿⣿⣿⡿
X⠻⣿⡿⡫⡪⡪⡪⡪⣺⣿⣿⣿⣿⣿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠃
X⡁⠹⡪⡪⡪⡪⣪⣾⣿⣿⣿⣿⠋⠐⢉⢍⢄⢌⠻⣿⣿⣿⣿⣿⣿⣿⣿⠏⠈
X⡘⢄⠙⣾⣾⣾⣿⣿⣿⣿⣿⣿⡀⢐⢕⢕⢕⢕⢕⡘⣿⣿⣿⣿⣿⣿⠏⠠⠈
X⢊⢂⢣⠹⣿⣿⣿⣿⣿⣿⣿⣿⣧⢐⢕⢕⢕⢕⢕⢅⣿⣿⣿⣿⡿⢋⢜⠠⠈
X⠁⠕⢝⡢⠈⠻⣿⣿⣿⣿⣿⣿⣿⣷⣕⣑⣑⣑⣵⣿⣿⣿⡿⢋⢔⢕⣿⠠⠈
X⡂⡀⢑⢕⡅⠂⠄⠉⠛⠻⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⡿⢋⢔⢕⢕⣿⣿⠠
*/
 
#define _CRT_SECURE_NO_WARNINGS
 
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")
 
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
 
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair
 
using namespace std;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;
 
const ll mod = 998244353;
const ld eps = 1e-8;
 
const ll inf = 1e9;
 
const ll P = 1e9 + 7;
const ll Q = 150001;
 
mt19937 rng(999);

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define ABS(A) ((A) > 0 ? (A) : -(A))

typedef long long ll;

const int maxc = 500010;

ll n, x[maxc];

ll Mul( ll a, ll b, ll m )
{
  ll k = ((long double)a * b) / m;
  ll r = a * b - k * m;
  while (r < 0) r += m;
  while (r >= m) r -= m;
  return r;
}

ll next( ll x )
{
  return (Mul(x, x, n) + 3) % n;
}

ll gcd(ll a, ll b)
{
    while (a)
    {
        b %= a;
        swap(a, b);
    }
    return b;
}

int Slow( int n )
{
  for (int i = 2; i * i <= n; i++)
    if (n % i == 0)
    {
      return i;
      exit(0);
    }
  return -1;
  puts("-1");
  exit(0);
}

ll plrd(ll n)
{

  if (n <= (int)1e6)
    Slow(n);

  ll C = 2 * pow(n, 1.0 / 4);
  forn(cnt, 4)
  {
    x[0] = rand() % (n - 1) + 1;
    forn(i, C)
      x[i + 1] = (Mul(x[i], x[i], n) + 3) % n;
    forn(i, C)
    {
      ll g = gcd(ABS(x[i] - x[C]), n);
      if (g != 1 && g != n)
      {
          return g;
        printf("%I64d %I64d\n", g, n / g);
        return 0;
      }
    }
  }
  return -1;
  puts("-1");
  return 0;
}
 

 
ll sqr(ll a) {
    return a * a;
}
 
ll powmod(ll a, ll n, ll mod) {
    if (n <= 0) return 1;
    if (n % 2 == 0) return sqr(powmod(a, n / 2, mod)) % mod;
    return (a * powmod(a, n - 1, mod)) % mod;
}
 
int32_t main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
 
    ll a, b, c, n;
    cin >> a >> b >> c >> n;
 
    int N = 20000000;
    vector<int> sieve(N, -1);
    for (ll i = 2; i < N; i++) {
        if (sieve[i] != -1) continue;
        for (ll j = i * i; j < N; j += i) sieve[j] = i;
    }
 
    vector<int> primes;
    for (int i = 2; i < N; i++) if (sieve[i] == -1) primes.pb(i);
 
    ll res = 1;
 
    map<ll, int> el;
 
    for (ll x = 0; x < n; x++) {
        ll poly = a * x * x + b * x + c;
 
        while (true) {
            ll x = plrd(poly);
            ll t = 0;
            while (poly % x == 0) {
                t++;
             poly /= x;
            }
            el[x] += t;
        }
            }
 
    for (auto e : el) {
        //cout << e.first << ' ' << e.second << endl;
        res *= powmod(e.first, (e.second / 2) * 2, P);
        res %= P;
    }
 
    cout << res << endl;
}
