// #define testing  
#include <bits/stdc++.h>
using namespace std;

#define llong long long 
#define len(x) ((int)x.size())
#define rep(i,n) for (int i = -1; ++ i < n; )
#define rep1(i,n) for (int i = 0; i ++ < n; )
#ifdef testing
mt19937 rng(177013);
#else
mt19937 rng(chrono::system_clock::now().time_since_epoch().count());
#endif
#define rand() (int)(rng() >> 1)
#define CONCAT_(x, y) x##y/*{{{*/
#define CONCAT(x, y) CONCAT_(x, y)
#define SPEC(name) CONCAT(name, __LINE__)
#ifdef LOCAL_DEBUG   
int __db_level = 0;
#define clog cerr << string(__db_level * 2, ' ')
struct debug_block {
    string msg;
    debug_block(const string& s): msg(s) { clog << "{ " << msg << endl; ++__db_level; }
    ~debug_block() { --__db_level; clog << "} " << msg << endl; }
};
#define DB(args...) stringstream SPEC(ss); SPEC(ss)<< args; debug_block SPEC(dbbl)(SPEC(ss).str())
#else
#define clog if (0) cerr
#define DB(...)
#endif
#define db(val) "[" #val " = " << val << "]; "
template<class U, class V> ostream& operator<<(ostream& out, const pair<U, V>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")";
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup);
}
template<class ...U>
ostream& operator<<(ostream& out, const tuple<U...>& tup) { return print_tuple_utils<0, tuple<U...>>(out, tup); }
template<class, typename = void> struct has_const_iterator : false_type {};
template<class T> struct has_const_iterator<T, void_t<typename T::const_iterator>> : true_type {};
template<class T>
typename enable_if<has_const_iterator<T>::value && !is_same<T, string>::value, ostream&>::type
operator<<(ostream& out, const T& container) { 
    auto beg = container.begin(), end = container.end();
    out << "(" << container.size() << ") {";
    if (beg != end) out << *(beg++);
    while (beg != end) out << ", " << *(beg++);
    return out << "}";
}
#define ptrtype(x) typename iterator_traits<x>::value_type
template<class u> vector<ptrtype(u)> $v(u a, u b) { return vector<ptrtype(u)>(a, b); }/*}}}*/
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////

llong gcd(llong a, llong b, llong& x, llong & y) {
    if (b == 0) {
        x = 1;
        y = 0;
        return a;
    }
    llong x1, y1;
    llong d = gcd(b, a % b, x1, y1);
    x = y1;
    y = x1 - y1 * (a / b);
    clog << db(a) << db(b) << db(x) << db(y) << db(d) << endl;
    return d;
}

llong solve(llong b, llong d) {
    llong x, y;
    llong g = gcd(d, b, x, y);
    clog << db(g) << endl;
    clog << db(x) << db(y) << endl; 
    clog << db(x * d + y * b)  << endl;
    x *= b / g * b;
    y *= b / g * b;
    clog << db(x) << db(y) << endl; 
    clog << db(x * d + y * b)  << endl;
    clog << db(x) << db(y) << endl; 
    
    llong u = b / g, v = d / g;
    
    llong t1 = (-x) / u;
    while (t1 * u + x > 0) --t1;
    while (t1 * u + x <= 0) ++t1;
    llong t2 = y / v;
    while (y - t2 * v > 0) ++t2;
    while (y - t2 * v <= 0) --t2;
    clog << db(t1) << db(t2) << endl;
    clog << db((t1 * u + x) * d + (y - t1 * v) * b) << db(b * b) << endl;
    clog << db(t1 * u + x) << db(y - t1 * v) << endl;
    clog << db(t2 * u + x) << db(y - t2 * v) << endl;
    
    if (y - t1 * v <= 0) {
        return 0;
    }
    if (x + t2 * u <= 0) {
        return 0;
    }
    
    return (t2 - t1 + 1);
}

llong slow(llong b, llong d) {
    llong ans = 0;
    for (llong a = 1; a <= 10000000; ++a) {
        llong c = (b * b - a * d) / b;
        if (c <= 0) continue;
        if (a * d + c * b == b * b) {
            clog << db(a) << db(c) << endl;
            ++ans;
        }
    }
    return ans;
}

int main(void) {
#ifdef LOCAL
#ifdef testing
    while (true) {
        llong b = rand() % 1000 + 1;
        llong d = rand() % 1000 + 1;
        auto ans = solve(b, d);
        auto exp = slow(b, d);
        if (ans == exp) {
            cout << "nice" << endl;
            continue;
        }
        ofstream("main.inp") << "1\n" << b << ' ' << d << endl << ans << ' ' << exp;
        cout << "FAILED " << endl;
        return 0;
    }
#endif
    freopen("main.inp", "r", stdin);
    freopen("main.out", "w", stdout);
    freopen(".log", "w", stderr);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n; cin >> n;
    while (n--) {
        DB("test");
        llong b, d; cin >> b >> d;
        auto ans = solve(b, d);  
        // auto ans = slow(b, d);  
        cout << ans << '\n';
    }
    
    return 0;
}

// vim: foldmethod=marker

