﻿#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <iomanip>
#include <array>
#include <numeric>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <queue>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <cassert>

#define all(a) (a).begin(), (a).end()

using namespace std;
using ll = long long;
using ld = long double;

#define int ll

int gcd(int a, int b, int& x, int& y) {
	if (b == 0) {
		x = 1;
		y = 0;
		return a;
	}
	int x1, y1;
	int d = gcd(b, a % b, x1, y1);
	x = y1;
	y = x1 - y1 * (a / b);
	return d;
}

bool find_any_solution(int a, int b, int c, int &x0, int &y0, int &g) {
	g = gcd(abs(a), abs(b), x0, y0);
	if (c % g) {
		return false;
	}

	x0 *= c / g;
	y0 *= c / g;
	if (a < 0) x0 = -x0;
	if (b < 0) y0 = -y0;
	return true;
}

ll b, d;

void read(istream& cin) {
	cin >> b >> d;
}
#define div kek
ll div(ll x, ll y) {
	if (x >= 0) {
		return (x + y - 1) / y;
	}
	return x / y;
}

ll div1(ll x, ll y) {
	if (x >= 0) {
		return x / y;
	}
	return (x - y + 1) / y;
}

void solve(ostream& cout) {
	ll x0, y0, g;
	if (!find_any_solution(d, b, b * b, x0, y0, g)) {
		cout << 0 << '\n';
		return;
	}
	x0 = 0, y0 = b;
	ll rb = div1(y0 - 1, (d / g));
	ll lb = div(-x0 + 1, b / g);
	cout << max(0LL, rb - lb + 1) << '\n';
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int tc = 1;
	 cin >> tc;
	while (tc--) {
		read(cin);
		solve(cout);
	}
}
