#include<iostream>
#include<vector>
#include<queue>
#include<set>
#include<map>
#include<string>
#include<bitset>
#include<stack>
#include<algorithm>
#include<iomanip>  // cout << setprecision(...) <<  fixed;
using namespace std;

#define ll long long
#define vll vector<ll>
#define qll queue<ll>
#define sll set<ll>
#define cll const ll

#ifdef LOCAL
#define pausesys cout << "\n"; system("pause");
#else
#define pausesys cout << "";
#endif

int n, t[800000];
int mint[800000];
int maxt[800000];
int countt[800000];

map<ll, pair<ll,ll>> g;

void buildmin (ll v) {
	int res = INT_MAX;
	if(g[v].first != 0){
		buildmin(g[v].first);
		res = min(mint[g[v].first], res);
	}
	if(g[v].second != 0){
		buildmin(g[v].second);
		res = min(mint[g[v].second], res); 
	}
	if(res != INT_MAX){
		mint[v] = min(res, t[v]);
	}
	else{
		mint[v] = t[v];
	}
}

void buildmax (ll v) {
	int res = INT_MIN;
	if(g[v].first != 0){
		buildmax(g[v].first);
		res = max(maxt[g[v].first], res);
	}
	if(g[v].second != 0){
		buildmax(g[v].second);
		res = max(maxt[g[v].second], res); 
	}
	if(res != INT_MIN){
		maxt[v] = max(res, t[v]);
	}
	else{
		maxt[v] = t[v];
	}
}

void buildcount (ll v) {
	int res = 0;
	if(g[v].first != 0){
		buildcount(g[v].first);
		res += countt[g[v].first] + 1;
	}
	if(g[v].second != 0){
		buildcount(g[v].second);
		res += countt[g[v].second] + 1;
	}
	if(res == 0){
		res = 1;
	}
	countt[v] = res;
}

int res;
int ans;
void lookup(ll v, ll L, ll R){
	ans++;
	if(v == 0)
		return;
	if (L <= mint[v] && maxt[v] <= R)
		return;
	if (maxt[v] < L || R < mint[v])
		return;
	if (L <= t[v] && t[v] <= R)
		;
	lookup(g[v].first, L, R);
	lookup(g[v].second, L, R);
	return;
}

int main() {
//	freopen(".in", "r", stdin);
//	freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;
	int a,b,c;
	for(int i = 0; i < n; i++){
		cin >> a >> b >> c;
		g[i + 1].first = a;
		g[i + 1].second = b;
		t[i + 1] = c;
	}
	
	buildmin(1);
	buildmax(1);
	buildcount(1);
	
	ll q;
	cin >> q;
	for(int i = 0; i < q; i++){
		cin >> a >> b;
		lookup(1, a, b);
		cout << ans << '\n';
		ans = 0;
	}

	pausesys;
}