#include <bits/stdc++.h>

#define FAST_READ ios_base::sync_with_stdio(false);
#define in freopen("input.txt", "r", stdin);
#define out freopen("input.txt", "w", stdout);
#define MAXN 500010
#define INF 100000000000ll
#define MOD 998244353ll
#define pi 3.14159265358973238462643383
#define EPS 0.000000000001
#define f first
#define s second
#define pb push_back
#define mp(i, j) make_pair(i, j)
#define pres(a, n) fixed << setprecision(a) << n

using namespace std;

typedef unsigned long long ull;
typedef int long long ll;
typedef long double ld;
typedef string str;
typedef pair < ll, ll > pr;

inline ll dist(string a, string b)
{
    ll ans = 0;
    for (int i = 0; i < 8; i++)
        if (a[i] == b[i])
        ans++;

    return ans;
}

int main() {
    FAST_READ

    ll n;

    cin >> n;

    vector < string > a(n);

    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }

    vector < ll > dp(n, 0);
    vector < vector < ll > > flag(n, vector < ll > (2, 0));

    flag[0][0] = 1;

    for (int i = 0; i < n; i++)
    {
        for (int j = max(0, i - 8); j < i; j++)
        {
            if (dist(a[i], a[j]) >= (i - j))
                flag[i][0] |= flag[j][1],
                flag[i][1] |= flag[j][0];
        }
    }

    dp[0] = 2;

    for (int i = 1; i < n; i++)
    {
        if (flag[i][0] == 0 && flag[i][1] == 0)
        {
            dp[i] = dp[i - 1];
            continue;
        }

        if (flag[i][0] == 1 && flag[i][1] == 0)
        {
            dp[i] = 2;
            continue;
        }

        if (flag[i][0] == 0 && flag[i][1] == 1)
        {
            dp[i] = 1;
            continue;
        }

        for (int j = max(0, i - 8); j < i; j++)
        {
            if (dist(a[i], a[j]) >= (i - j))
                {
                    dp[i] = dp[j] ^ 3;
                    break;
                }
            else {
                ll fl = 0;
                for (int k = j + 1; k < i; k++)
                    if (!(dist(a[j], a[k]) >= (k - j) && dist(a[k], a[i]) >= i - k))
                        break;
                else if (k == i - 1)
                {
                    dp[i] = dp[j];
                    fl = 1;
                }

                if (fl)
                    break;
            }
        }
    }

    for (int i = 0; i < n; i++)
    {
        cout << dp[i];
    }
}
