#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_set>

#define ll long long

using namespace std;

vector<int> ans;
vector<int> p;
vector<vector<int>> children;

void addReverse(int par) {
    if (!par) return;
    int i = (int)ans.size() - 1;
    vector<int> temp;
    while (ans[i] != par) {
        temp.push_back(ans[i]);
        i--;
    }
    ans.insert(ans.end(), temp.begin(), temp.end());
}


void rec(int i) {
    ans.push_back(i);
    addReverse(p[i]);
    for (auto child : children[i]) {
        rec(child);
    }
}

int main() {
    int n; cin >> n;
    p.resize(n + 1);
    for (int i = 2; i <= n; ++i) {
        cin >> p[i];
    }
    p[1] = 0;

    children.resize(n + 1);
    for (int i = 2; i <= n; ++i) {
        children[p[i]].push_back(i);
    }

    rec(1);
    cout << (ans.size() - 1) / 2<< endl;
    for (int i = 1; i < ans.size(); i += 2) {
        cout << ans[i] << ' ';
    }

    return 0;
}