#include <bits/stdc++.h>

using namespace std;

const long long MAX = 100001;

vector <int> primes;
bitset <MAX> is;

int main() {
    // std::ios_base::sync_with_stdio(false);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    for (int i=2; i<MAX; i++) {
        if (!is[i]) {
            primes.push_back(i);
            long long cur = 1ll * i * i;
            while (cur < MAX) {
                is[cur] = true;
                cur += i;
            }
        }
    }

    int t;
    cin >>t;
    while (t--) {
        long long n;
        cin >>n;
        int ans = 1;
        vector <pair <int, long long> > factors;
        for (int i=0; i<primes.size() && primes[i] <= sqrt(n); i++) {
            int cnt = 0;
            while (n % primes[i] == 0) {
                n /= primes[i];
                cnt++;
            }
            if (cnt != 0) {
                factors.push_back({cnt, primes[i]});
            }
            ans = max(ans, cnt);
        }
        if (n != 1) {
            factors.push_back({1, n});
        }
        long long arr[ans];
        for (int i=0; i<ans; i++)
            arr[i] = 1ll;
        for (pair <int, long long> it : factors) {
            for (int i=0; i<it.first; i++){
                arr[ans - i - 1] *= it.second;
            }
        }
        cout <<ans <<'\n';
        for (int i=0; i<ans; i++) {
            cout <<arr[i] <<' ';
        }
        cout <<'\n';
    }
    return 0;
}