#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>

#define ll long long

using namespace std;


void runn(ll time) {
    cout << "run " << time << endl;
    fflush(stdout);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector< pair <int, vector<int> > > mm = vector<pair<int, vector<int>>>();
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        vector<int> newV = vector<int>(0, 0);
        for (int j = 0; j < a; j++) {
            int k;
            cin >> k;
            newV.push_back(k);
        }
        mm.emplace_back(a, newV);
    }
    reverse(mm.begin(), mm.end());

    vector<int> prev = vector<int>(100000, -100);

    ll ans = 1;

    for (int i = 0; i < n; i++) {
        int f = mm[i].first;
        vector<int> d = mm[i].second;

        bool flag = false;
        for (int j = 0; j < f; j++) {
            if (prev[d[j]] == i - 1) {
                flag = true;
            }

            prev[d[j]] = i;
        }
        if (flag) ans++;
    }

    cout << ans;
    return 0;
}