#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <bitset>

#define ln '\n'
#define ll long long
#define ioio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define X first
#define Y second

const double pi = acos(-1.0);
const double eps = 1e-9;
const int INF = 1e9;

using namespace std;


void solve()
{
	int n;
	cin >> n;
	vector<set<int>>v(n);
	for (int i = 0; i < n; ++i)
	{
		int m;
		cin >> m;
		for (int j = 0; j < m; ++j)
		{
			int t;
			cin >> t;
			v[i].insert(t);
		}
	}
	int ans = n;
	for (int i = 1; i < n; ++i)
	{
		vector<int>inter;
		set_intersection(v[i].begin(), v[i].end(), v[i - 1].begin(), v[i - 1].end(), back_inserter(inter));
		if (inter.size() == 0)
			ans--;
	}
	cout << ans;
}



int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ioio;
	cout << fixed << setprecision(15);
	int n = 1;
	//cin >> n;
	for (int i = 0; i < n; ++i) {
		//cout << ln << "TEST NUMBER" << i + 1 << ln << ln;
		solve();
	}
}