import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class A {
    static StringTokenizer st;
    static BufferedReader br;
    static PrintWriter pw;

    static String nextToken() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return st.nextToken();
    }

    static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    static double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    static long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        run();
        pw.close();
    }

    static int[] AB;
    static int[][] graph;
    static int all;

    private static void run() {
        AB = new int[2];
        AB[0] = nextInt();
        AB[1] = nextInt();
        graph = new int[AB[0] + AB[1]][3];
        all = AB[0] + AB[1] * 2;
//        rec(all);
//        for (int i = 0; i < graph.length; i++) {
//            for (int j = 0; j < 3; j++) {
//                pw.print(graph[i][j] + " ");
//            }
//            pw.println();
//        }
        ArrayList<V> queue = new ArrayList<>();
        int id = 0;
        int c = 2;
        if (AB[1] == 0) {
            c = 1;
        }
        AB[c - 1]--;
        queue.add(new V(all - c, c));
        while (id < queue.size()) {
            V v = queue.get(id);
            if (v.all > 0) {
                int l = v.all / 2;
                int r = v.all - v.all / 2;
                if (l > 0) {
                    V vl = initV(l);
                    queue.add(vl);
                    v.l = queue.size();
                }
                if (r > 0) {
                    V vr = initV(r);
                    queue.add(vr);
                    v.r = queue.size();
                }
                if (AB[0] < 0) {
                    pw.println(-1);
                    return;
                }
            }
            id++;
        }
        for (V v : queue) {
            pw.println(v.c + " " + v.l + " " + v.r);
        }
    }

    static boolean ans = true;

    private static V initV(int all) {
        int c = 2;
        if (AB[1] == 0 || all == 1) {
            c = 1;
        }
        AB[c - 1]--;
        all -= c;
        return new V(all, c);
    }

    static int v = 0;

//    private static int rec(int all) {
//        if (all <= 0) return 0;
//        if (all % 2 == 0) {
//            if (AB[1] > 0) {
//                all -= 2;
//                AB[1]--;
//                graph[v][0] = 2;
//            } else {
//                all -= 1;
//                AB[0]--;
//                graph[v][0] = 1;
//            }
//        } else {
//            if (AB[0] > 0) {
//                all -= 1;
//                AB[0]--;
//                graph[v][0] = 1;
//            } else {
//                all -= 2;
//                AB[1]--;
//                graph[v][0] = 2;
//            }
//        }
//        int vv = v;
//        v++;
//        int l = all / 2;
//        graph[vv][1] = rec(l);
//        graph[vv][2] = rec(all - l);
//        return vv + 1;
//    }


    static class V {
        int all;
        int c;
        int l;
        int r;

        public V(int all, int c) {
            this.all = all;
            this.c = c;
        }
    }
}
