import sun.awt.CGraphicsConfig;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class CC {
    static StringTokenizer st;
    static BufferedReader br;
    static PrintWriter pw;

    static String nextToken() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return st.nextToken();
    }

    static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    static double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    static long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        run();
        pw.close();
    }

    static ArrayList<Integer>[] graph;

    private static void run() {
        int n = nextInt();
        graph = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            graph[i] = new ArrayList<>();
        }

        for (int i = 1; i < n; i++) {
            int p = nextInt() - 1;
            graph[i].add(p);
            graph[p].add(i);
        }
        ArrayList<Integer> ans = rec(-1, 0);
        pw.println(ans.size());
        for (int x :
                ans) {
            pw.print((x + 1) + " ");
        }
    }

    private static ArrayList<Integer> rec(int p, int v) {
        ArrayList<Integer> ans = new ArrayList<>();
        if(p != -1) {
            ans.add(v);
        }
        ArrayList<ArrayList<Integer>> lists = new ArrayList<>();
        for (int i = 0; i < graph[v].size(); i++) {
            int vv = graph[v].get(i);
            if (vv == p) continue;
            lists.add(rec(v, vv));
        }
        pp = new ArrayList<>();
        buildLists(0, lists);
        ans.addAll(pp);
        return ans;
    }

    static ArrayList<Integer> pp;

    private static void buildLists(int i, ArrayList<ArrayList<Integer>> lists) {
        if (i >= lists.size()) return;
        ArrayList<Integer> list = lists.get(i);
        ArrayList<Integer> ppp = new ArrayList<>();
        buildLists(i + 1, lists);
        ppp.addAll(pp);
        Collections.reverse(pp);
        for (int j = 0; j < list.size(); j++) {
            ppp.add(list.get(j));
            ppp.addAll(pp);
            Collections.reverse(pp);
        }
        pp = ppp;
    }

    static int ans = 0;
    static ArrayList<Integer> path = new ArrayList<>();

}
