#include <bits/stdc++.h>
/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;*/
#define itn int
#define all(c) c.begin(),c.end()
#define make_unique(x) sort(all((x))); (x).resize(unique(all((x))) - (x).begin())
#define ll long long
#define ull unsigned long long
#define pll pair<ll, ll>
#define pii pair<int, int>
#define mp(x, y) make_pair(x, y)
using namespace std;
 
const ll MAX_N = 2e5 + 5, inf = 1e18, mod = 1000000007;
const double PI = 3.1415926536;
int days[13] = {0, 31, 28, 31, 30, 31,30, 31, 31, 30, 31, 30, 31};
 
template<typename T>
ostream& operator <<(ostream& out, const vector<T>& mas) {
    for (const auto& x : mas) {
        out << x << ' ';
    }
    return out;
}
 
void ok() {
    cout << "YES" << '\n';
}
 
void no() {
    cout << "NO" << '\n';
}
 
inline ll nxt() {
    ll x;
    cin >> x;
    return x;
}

vector<int> inv_p;
void top_sort(vector<vector<int>>& g) {
    vector<int> ans;
    vector<bool> used(g.size() + 1);
    function<void(int)> dfs = [&](int v) {
        used[v] = true;
        for (size_t i=0; i<g[v].size(); ++i) {
            int to = g[v][i];
            if (!used[to])
                dfs (to);
        }
        ans.push_back (v);
    };
    int n = g.size();
    for (int i=0; i<n; ++i)
        used[i] = false;
    for (int i=1; i<n; ++i)
        if (!used[i])
            dfs (i);
    reverse(ans.begin(), ans.end()); 
    inv_p.resize(n + 2);
    for (int i = 0; i < ans.size(); i++) { 
        inv_p[ans[i]] = n - i;
    }
}

bool cmp(int a, int b) {
    return inv_p[a] < inv_p[b];
}

void solve() {
    int n = nxt();
    vector<vector<int>> tree(n);
    for (int i = 1; i < n; i++) {
        int v = nxt() - 1;
        tree[v].push_back(i);
    }
    
    auto check = [&](int mask) {
        queue<int> q;
        q.push(0);
        while (q.size()) {
            int v = q.front();
            q.pop();
            mask -= (1 << v);
            for (auto& to : tree[v]) {
                if ((mask >> to) % 2) {
                    q.push(to);
                } 
            }
        }
        return (mask == 0); 
    };

    int m = (1 << n);
    vector<int> ok(m);
    for (int i = 1; i < m; i++) {
        if (check(i)) {
            ok[i] = true;
        }
    }
 
    vector<vector<int>> g(m);
    for (int i = 1; i < m; i += 2) {
        if (!ok[i]) continue;
        for (int j = 0; j < n; j++) {
            int to = (i ^ (1 << j));
            if (ok[to]) {
                g[i].push_back(to);
            }
        }
    }
    top_sort(g);
    
    vector<int> dp(m, 0);
    vector<int> used(m);
    vector<int> nt(m, -1);
    function<void(int)> dfs = [&](int v) {
        used[v] = true;
        sort(all(g[v]), cmp);
        for (auto& to : g[v]) {
            if (!used[to]) {
                dfs(to);
                if (dp[v] < dp[to] + 1) {
                    dp[v] = dp[to] + 1;
                    nt[v] = to;
                }
            } 
        }
    };
    dfs(1);
    int cur = nt[1];
    int prev = 1;
    vector<int> ans;
    while (cur != -1) {
        for (int i = 0; i < n; i++) {
            if ((prev >> i) % 2 + (cur >> i) % 2 == 1) {
                ans.push_back(i + 1);
            }
        }
        prev = cur;
        cur = nt[cur];
    }
    cout << ans.size() << endl << ans << endl;
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}