#include <bits/stdc++.h>
#include <random>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef double ld;
//#define ll __int128
//#define int ll
//#define char ll
//#define double ld
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;
typedef pair<int, int> pii;
typedef pair<pii, pii> piii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<short> vs;
typedef vector<vs> vvs;
typedef vector<vvs> vvvs;
typedef vector<ll> vl;
typedef vector<vl> vvl;
typedef vector<vvl> vvvl;
typedef vector<ld> vld;
typedef vector<vld> vvld;
typedef vector<vvld> vvvld;
typedef vector<string> vst;
typedef vector<vst> vvst;
typedef pair<ld, ld> pld;

#define inmin(a, b) a = min(a, (b))
#define inmax(a, b) a = max(a, (b))
#define ALL(a) a.begin(),a.end()
#define RALL(a) a.rbegin(),a.rend()
#define sqr(x) ((x) * (x))
#define fori(i, n) for(int i = 0; i < int(n); ++i)
#define SZ(a) ((int)((a).size()))
#define triple(T) tuple<T, T, T>
#define quad(T) tuple<T, T, T, T>
#define watch(x) cerr << (#x) << " = " << (x) << endl;

#ifdef MAX_HOME
#define cerr cout
#else
#define cerr if (false) cerr
#endif

const double PI = 2 * acos(0.0);
//#define rand shittttty_shit
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng_64(chrono::steady_clock::now().time_since_epoch().count());

const string DIGITS = "0123456789";
const string ALPH = "abcdefghijklmnopqrstuvwxyz";


template<class T0, class T1>
inline ostream &operator<<(ostream &out, pair<T0, T1> &a) {
    return out << "{" << a.first << ", " << a.second << "}";
}

template<class T0, class T1>
inline istream &operator>>(istream &in, pair<T0, T1> &a) {
    return in >> a.first >> a.second;
}

template<class T0, class T1, class T2>
inline ostream &operator<<(ostream &out, tuple<T0, T1, T2> &a) {
    return out << "{" << get<0>(a) << ", " << get<1>(a) << ", " << get<2>(a) << "}";
}

template<class T0, class T1, class T2, class T3>
inline ostream &operator<<(ostream &out, tuple<T0, T1, T2, T3> &a) {
    return out << "{" << get<0>(a) << ", " << get<1>(a) << ", " << get<2>(a) << ", " << get<3>(a) << "}";
}

template<class T>
inline ostream &operator<<(ostream &out, vector<T> &a) {
    out << "[";
    fori (i, a.size())out << a[i] << vector<string>{", ", "]  "}[i + 1 == a.size()];
    return out;
}


void smain();


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef MAX_HOME
    freopen("input.txt", "r", stdin);
    clock_t start = clock();
#else
    //        freopen("grass.in", "r", stdin);
//        freopen("grass.out", "w", stdout);
#endif
#ifdef HK_CUP
    freopen("finput.txt", "r", stdin);
    freopen("output.txt", "g", stdout);
#endif

    cout << setprecision(12) << fixed;
    smain();
#ifdef MAX_HOME
#ifndef HK_CUP
    cout << "\n\nTOTAL EXECUTION TIME: " << float(clock() - start) / CLOCKS_PER_SEC << endl;
#endif
#endif
    return 0;
}

const int N = 3e5 + 10;
const int L = 8;

int stair[N];
int dp[1 << L];
int ndp[1 << L];

int g[N];

int antimask(int mask) {
    int kek =  mask ^ ((1 << L) - 1);
    return kek;
}

int up(int mask, int shift) {
    mask <<= shift;
    return mask & ((1 << L) - 1);
}

int get_dist(int m1, int m2) {
    return L - __builtin_popcount(m1 ^ m2);
}

void smain() {
    int n;
    cin >> n;
    fori (i, n) {
        string s;
        cin >> s;
        fori (j, s.size()) {
            if (s[j] == 'W') {
                stair[i] |= 1 << j;
            }
        }
    }

    vi ans(n);

    // init if first 1

    fori (mask, 1 << L) {
        dp[mask] = (mask & 1);
    }

    for (int i = 1; i < n; ++i) {
        // add edges

        for (int j = i - 1; j >= max(0, i - L); --j) {
            int dist = i - j;
            if (dist <= get_dist(stair[i], stair[j])) {
                g[j] |= 1 << (i - j - 1);
            }
        }

        // calc ndp
        fori (mask, 1 << L) {
            int j = max(i - L, 0);
            bool val = g[j] & antimask(mask);
//            if (i == 2 && mask == 0) {/
//                watch(antimask(mask));
//            }
            ndp[mask] = dp[up(mask, 1) ^ val];
        }

        // calc answer
        int mask = 0;
        for (int j = i - 1; j > max(i - L, 0); --j) {
            mask = up(mask, 1) ^ bool(g[j] & antimask(mask));
        }
        ans[i] = ndp[mask];
        if (i - L >= 0){
            fori (mask, 1 << L) {
                dp[mask] = ndp[mask];
            }
        }
    }
    fori (i, n) {
        if (ans[i] == 0)
            ans[i] += 2;
        cout << ans[i];
    }
}