/*

Code for problem I by cookiedoth
Generated 13 Dec 2020 at 01.34 PM


СТРОИМ СТЕНУ РАБОТЯГИ!
█▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀█
█═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═█
█═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═█
█═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═█
█═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═█
█═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═█
█═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═█
█═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═█
█═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═╩═╦═█
█▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄█

=_=
¯\_(ツ)_/¯
^_^

*/

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <ctime>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <complex>
#include <cassert>
#include <random>
#include <cstring>
#include <numeric>
#include <random>
#include <utility>
#include <tuple>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << #a << " = " << a << endl
#define forn(i, n) for (int i = 0; i < n; ++i)
#define length(a) (int)a.size()

using namespace std;

template<class T> int chkmax(T &a, T b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, T b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream& out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

mt19937 rng(58);

vector<pair<int, int>> dir = {
	{1, 0},
	{-1, 0},
	{0, -1},
	{0, 1},
	{-1, 1},
	{1, -1},
};

const int mx = 50;
int field[mx][mx], n;
int head[2][2];

int ok(int r, int c) {
	return r >= 0 && r < n && c >= 0 && c < n;
}

int canMove(int player, int d) {
	int r = head[player][0] + dir[d].first;
	int c = head[player][1] + dir[d].second;
	// cerr << "canMove " << r << " " << c << '\n';
	return ok(r, c) && field[r][c] == 0;
}

void applyTurn(int player, int d) {
	head[player][0] += dir[d].first;
	head[player][1] += dir[d].second;
	field[head[player][0]][head[player][1]] = player + 1;
}

void revertTurn(int player, int d) {
	field[head[player][0]][head[player][1]] = 0;
	head[player][0] -= dir[d].first;
	head[player][1] -= dir[d].second;
}

#ifndef TESTING
void makeTurn(int d) {
	applyTurn(0, d);
	cout << dir[d].first << ' ' << dir[d].second << endl;
}

int expectTurn(int d) {
	string token;
	cin >> token;
	if (token == "win") {
		return 1;
	}
	if (token == "lose") {
		return -1;
	}
	int dx, dy;
	cin >> dx >> dy;
	head[1][0] += dx;
	head[1][1] += dy;
	field[head[1][0]][head[1][1]] = 2;
	return 0;
}
#else
void makeTurn(int d) {
	applyTurn(0, d);
}

int expectTurn(int d) {
	vector<int> poss;
	for (int i = 0; i < dir.size(); ++i) {
		if (canMove(1, i)) {
			poss.push_back(i);
		}
	}
	if (poss.size() == 0) {
		return 1;
	} else {
		applyTurn(1, poss[rng() % poss.size()]);
		return 0;
	}
}
#endif

const int INF = 1e9;

vector<vector<int>> d1, d2;

void bfs(int sx, int sy, vector<vector<int>>& d) {
	for (int i = 0; i < n; ++i) {
		fill(all(d[i]), INF);
	}
	queue<pair<int, int>> q;
	q.push({sx, sy});
	d[sx][sy] = 0;
	while (!q.empty()) {
		pair<int, int> pp = q.front();
		q.pop();
		for (auto [dx, dy] : dir) {
			int x1 = pp.first + dx;
			int y1 = pp.second + dy;
			if (ok(x1, y1) && field[x1][y1] == 0 && d[x1][y1] == INF) {
				d[x1][y1] = d[pp.first][pp.second] + 1;
				q.push({x1, y1});
			}
		}
	}
}

int get_score() {
	bfs(head[0][0], head[0][1], d1);
	bfs(head[1][0], head[1][1], d2);
	int res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (field[i][j] == 0 && d1[i][j] < d2[i][j]) {
				res++;
			}
		}
	}
	return res;
}

int strategy() {
	int score = -INF;
	vector<int> optTurns;
	for (int d = 0; d < dir.size(); ++d) {
		if (canMove(0, d)) {
			applyTurn(0, d);
			int curScore = get_score();
			if (chkmax(score, curScore)) {
				optTurns = {d};
			} else {
				if (score == curScore) {
					optTurns.push_back(d);
				}
			}
			revertTurn(0, d);
		}
	}
	if (optTurns.empty()) {
		return -1;
	}
	return optTurns[rng() % optTurns.size()];
}

void resetField() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			field[i][j] = (i + j < n / 2 || i + j >= 2 * n - 1 - n / 2) ? 3 : 0;
		}
	}
}

void printField() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cerr << field[i][j];
		}
		cerr << '\n';
	}
}

void play() {
	resetField();
	head[0][1] = head[1][1] = n / 2;
	head[0][0] = n / 2 - n / 4;
	head[1][0] = n / 2 + n / 4;
	field[head[0][0]][head[0][1]] = 1;
	field[head[1][0]][head[1][1]] = 2;
	// printField();
	while (true) {
		int d = strategy();
		if (d == -1) {
			cerr << ":(\n";
			exit(0);
		}
		makeTurn(d);
		int result = expectTurn(d);
		// printField();
		if (result == -1) {
			exit(0);
		}
		if (result == 1) {
			return;
		}
	}
}

signed main() {
	fast_io();
	int T;
	cin >> T >> n;
	n = 2 * n + 1;
	d1.resize(n, vector<int> (n));
	d2.resize(n, vector<int> (n));
	while (T--) {
		play();
		// cerr << "passed " << T << '\n';
	}
}
