#include <vector>
#include <iostream>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <iomanip>
#include <time.h>
#include <unordered_map>
#include <unordered_set>

#define fi first
#define se second
#define ll long long
#define ld long double
#define int long long
using namespace std;
const int N = 6e5 + 12;
const int MOD = 1e9 + 7;
const int LogN = 9;


bool use[N];
vector<int> primes;


int solve(int a, int b, int c, int n) {
    int k, A, B, x;
    map<int, int> m;
    for (int i = 0; i < n; ++i) {
        x = a * i * i + b * i + c;
        for (int j = 0; j < primes.size() && primes[j] * primes[j] <= x; ++j) {
            while (x % primes[j] == 0) {
                x /= primes[j];
                ++m[primes[j]];
            }
        }
        int c = sqrt(x + 0.5);
        if (x > 1) {
            if (c * c == x)
                m[c] += 2;
            else {
                if (x < 1e12)
                    ++m[x];
            }
        }
    }
    int ans = 1;
    for (auto pp : m) {
        for (int j = 0; j < pp.se / 2; ++j) {
            ans = (ans * ((pp.fi * pp.fi) % MOD)) % MOD;
        }
    }
    return ans;
}

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(false); cin.tie(0);
    for (int i = 2; i < N; ++i)
        if (!use[i]) {
            primes.push_back(i);
            for (int j = 2; i * j < N; ++j)
                use[i * j] = 1;
        }
    int a, b, c, n;
    cin >> a >> b >> c >> n;
    cout << solve(a, b, c, n);
}