#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <math.h>
#include <iomanip>
#include <fstream>
#include <set>
#include <map>
#define ll long long
#define ld long double

using namespace std;

void merge(vector<int>& a, vector<int>& b, vector<int>& c) {
    c = a;
    reverse(a.begin(), a.end());
    for (int i = 0; i < b.size(); ++i) {
        c.push_back(b[i]);
        for (auto elem : a) {
            c.push_back(elem);
        }
        reverse(a.begin(), a.end());
    }
}

void solve(int u, vector<vector<int>>& graph, vector<int> &ans) {
    int m = graph[u].size();
    vector<vector<int> > all(m);
    vector<vector<int> > all2(m);
    for (int i = 0; i < m; ++i) {
        solve(graph[u][i], graph, all[i]);
        all2[i] = all[i];
        reverse(all2.begin(), all2.end());
    }
    ans.push_back(u + 1);
    if (m == 0) {
        return;
    }
    vector<int> now = all[0];
    vector<int> now2;
    for (int i = 1; i < m; ++i) {
        merge(now, all[i], now2);
        now = now2;
        now2.clear();
    }
    for (auto elem : now) {
        ans.push_back(elem);
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int> > graph(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        graph[p].push_back(i);
    }
    vector<int> ans;
    solve(0, graph, ans);
    int N = ans.size();
    cout << N - 1 << "\n";
    for (int i = 1; i < N; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}
//*/