#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 2e9;
const ll MOD = 998244353;
const ld EPS = 1e-9;
const int M = 31;
const int N = 1e6 + 10;

vector<int> g[N];

vector<int> dfs(int v) {
  if (g[v].size() == 0) {
    return {v};
  } 
  vector<vector<int>> a(g[v].size());
  for (int i = 0; i < g[v].size(); ++i) {
    a[i] = dfs(g[v][i]); 
  }

  vector<int> answer = a[0];
  vector<int> new_answer;
  for (int i = 1; i < a.size(); ++i) {
    auto cur = a[i];
    new_answer = cur;
    reverse(cur.begin(), cur.end());
    for (int i = 0; i < answer.size(); ++i) {
      new_answer.push_back(answer[i]);
      new_answer.insert(new_answer.end(), cur.begin(), cur.end());
      reverse(cur.begin(), cur.end()); 
    }
    answer = move(new_answer);
  }
  if (v) {
    answer.insert(answer.begin(), v);
  }
  return answer;
}

void solve() {
  int n;
  cin >> n;
  for (int i = 0; i < n; ++i) g[i].clear();
  for (int i = 1; i <= n - 1; ++i) {
    int x;
    cin >> x;
    --x;
    g[x].push_back(i);
  }

  auto ans = dfs(0);
  cout << ans.size() << endl;
  for (auto v: ans) {
    cout << v + 1 << " ";
  }
  cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t = 5;
	while (t--) {
		solve();
	}
}
