#include <bits/stdc++.h>
using namespace std;

// 1  : a, b
// 2  : c, d
// 1+2: b, d 
// a, c - ?

// > 0
// a / b + c / d = b / d  (*bd)
// a * d + c * b = b * b

// 3 * 6 + 7 * 9 = 9 * 9

typedef long long ll;

ll gcd(ll a, ll b, ll &x, ll &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

// 2x + 3y = 4
// a / 40 + c / 60 = 40 / 60  (*bd)
// 60a + 40c = 40*40
// 6a + 4c = 160
// 3a + 2c = 80

int main() {
    int n;
    cin >> n;

    while (n--) {
        ll b, d, a0, c0;
        cin >> b >> d;
        ll g = __gcd(b, d);
        if (b * b % g != 0) {
            cout << 0 << endl;
            continue;
        }
        ll mul = b * b / g;
        b /= g;
        d /= g;
        gcd(d, b, a0, c0);
        // (a0 + kb) * d + (c0 - kd) * b = 1  (we need b*b so mul)
        // we can increase a by b and decrease c by d
        a0 *= mul;
        c0 *= mul;
        //cerr << b << " " << d << " " << a0 << " " << c0 << endl;
        ll a1 = a0 % b; // first positive a
        while (a1 <= 0) a1 += b;
        ll c1 = c0 % d;// first positive c
        while (c1 <= 0) c1 += d;
        ll a2 = (a0 - b * (c1 - c0) / d); // corresponding a
        //cerr << "> " << a1 << " " << c1 << " " << a2 << endl;
        cout << max(0ll, (a2 - a1) / b + 1) << endl;
    }

    return 0;
}