#include <iostream>
#include <cstdio>
#include <set>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <cstring>
#include <sstream>
#include <unordered_set>
#include <queue>
#include <stack>

using namespace std;
//#define int long long

vector<vector<int>> g;
int val[400002];
int cnt[400002];
pair<int, int> v2otrs[400002];
map<int, vector<pair<int, int>>> otrs;
const int INF = 1234567890;

void dfs(int v) {
    if (v == 0) {
        return;
    }
    for (auto to : g[v]) {
        dfs(to);
    }
    int left_v = g[v][0];
    int right_v = g[v][1];
    cnt[v] = 1 + cnt[left_v] + cnt[right_v];

    v2otrs[v].first = left_v ? v2otrs[left_v].first : val[v];
    v2otrs[v].second = right_v ? v2otrs[right_v].second : val[v];
    otrs[v2otrs[v].first].push_back({v2otrs[v].second, v});
}

int find_bad(int l, int r) {
    int ans = 0;
    while (true) {
        auto it_m = otrs.lower_bound(l);
        if (it_m == otrs.end()) {
            break;
        }
        auto& vec = it_m->second;
        auto it_p = upper_bound(vec.begin(), vec.end(), pair<int, int>{r, INF});
        if (it_p == vec.begin()) {
            break;
        }
        auto [cur_r, v] = *prev(it_p);
        ans += cnt[v] - 1;
        l = cur_r + 1;
    }
    return ans;
}

signed main() {
//#ifndef ONLINE_JUDGE
//    freopen("input.txt", "r", stdin);
//#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);

    int n;
    scanf("%d", &n);
    g.resize(2 * n + 1);
    int next_n = n + 1;
    for (int i = 1; i <= n; ++i) {
        g[i].resize(2);
        for (int j = 0; j < 2; ++j) {
            scanf("%d", &g[i][j]);
            //cin >> g[i][j];
        }
        //cin >> val[i];
        scanf("%d", &val[i]);
        if ((g[i][0] == 0 && g[i][1] != 0) || (g[i][1] == 0 && g[i][0] != 0)) {
            if (g[i][0] == 0) {
                g[i][0] = next_n;
            } else {
                g[i][1] = next_n;
            }
            g[next_n] = {0, 0};
            val[next_n] = val[i];
            ++next_n;
        }
    }
    n = next_n - 1;
    dfs(1);
    for (auto& it : otrs) {
        sort(it.second.begin(), it.second.end());
    }

    int Q;
    //cin >> Q;
    scanf("%d", &Q);
    for (int q = 1; q <= Q; ++q) {
        int L, R;
        cin >> L >> R;
        int gg1 = find_bad(L, R);
        int gg2 = find_bad(-INF, L - 1);
        int gg3 = find_bad(R + 1, INF);

        int ans = n - gg1 - gg2 - gg3;
        //cout << ans << endl;
        printf("%d\n", ans);
    }

}