#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <string>
#include <unordered_map>
using namespace std;
#pragma warning (disable:4996)

pair<int, int> f(int u, vector<vector<int>>& v, vector<int>& st, vector<int>& w, vector<vector<int>>& q, vector<pair<int, int>>& mx) {
    st[u] = 1;
    pair<int, int> ans = make_pair(w[u], w[u]);
    for (auto i = 0; i < v[u].size(); ++i) {
        if (v[u][i] != -1 && st[v[u][i]] == 0) {
            auto curr = f(v[u][i], v, st, w, q, mx);
            ans.first = min(ans.first, min(w[v[u][i]], curr.first));
            ans.second = max(ans.second, max(w[v[u][i]], curr.second));
        }
    }
    if (ans.first != 2e9) {
        vector<int> ok(3);
        ok[0] = ans.first;
        ok[1] = u;
        ok[2] = -1;
        q.push_back(ok);
        ok[0] = ans.second;
        ok[2] = 1;
        q.push_back(ok);
    }
    mx[u] = ans;
    return ans;
}

int look (int u, vector<vector<int>>& v, vector<pair<int, int>>& mx, int l, int r) {
    if (u == -1)
        return 0;
    int ans = 0;
    if (l <= mx[u].first && mx[u].second <= r) {
        return 0;
    }
    if (l > mx[u].second || mx[u].first > r) {
        return 0;
    }
    ans += 2;
    if (v[u][0] != -1)
        ans += look(v[u][0], v, mx, l ,r);
    if (v[u][1] != -1)
        ans += look(v[u][1], v, mx, l, r);
    return ans;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    vector<int> w(n);
    for (auto i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y >> w[i];
        v[i].push_back(x - 1);
        v[i].push_back(y - 1);
    }
    vector<int> ok(3);
    vector<vector<int>> q;
    vector<int> st(n, 0);
    vector<pair<int, int>> mx(n);
    auto r = f(0, v, st, w, q, mx);
    int k;
    cin >> k;
    for (auto i = 0; i < k; ++i) {
        int l, r;
        cin >> l >> r;
        cout << look(0, v, mx, l, r) + 1 << '\n';
    }
    /*vector<int> ll(k, 0), rr(k, 0);
    vector<int> cc_l(k, 0);
    sort(q.begin(), q.end());
    int cnt_o = 0;
    int cnt_c = 0;
    for (auto i = 0; i < q.size(); ++i) {
        switch (q[i][2]) {
        case -1:
            ++cnt_o;
            break;
        case 1:
            ++cnt_c;
            break;
        case -2:
            ll[q[i][1]] += cnt_o - cnt_c;
            break;
        case 2:
            break;
        }
    }
    sort(q.rbegin(), q.rend());
    cnt_o = 0;
    cnt_c = 0;
    for (auto i = 0; i < q.size(); ++i) {
        switch (q[i][2]) {
        case -1:
            ++cnt_c;
            break;
        case 1:
            ++cnt_o;
            break;
        case -2:
            cc_l[q[i][1]] += cnt_o;
            break;
        case 2:
            rr[q[i][1]] += cnt_o - cnt_c;
            cc_l[q[i][1]] -= cnt_o;
            break;
        }
    }
    for (auto i = 0; i < k; ++i) {
        cout << (ll[i] + rr[i]) * 2 << '\n';
    }*/
    return 0;
}