#include <bits/stdc++.h>

#define fi(n) for (int i = 0; i < int(n); i++)
#define fj(n) for (int j = 0; j < int(n); j++)
#define fk(n) for (int k = 0; k < int(n); k++)
#define f1(x) for (auto &i1 : x)
#define f2(x) for (auto &i2 : x)
#define f3(x) for (auto &i3 : x)
#define all(x) std::begin(x), std::end(x)

using namespace std;

using ll = int64_t;
using ull = uint64_t;
using ld = long double;

constexpr ll MOD = 1'000'000'007;

struct node {
	int value = -1;
	int l = -1;
	int r = -1;
};

vector<node> tree;

#if 0
map<pair<int, int>, int> cache;

pair<node *, bool> dfs(int a, int b)
{
	if (a + b == 0) {
		return { nullptr, true };
	}

	tree.emplace_back();
	node *me = &tree.back();

	auto iter = cache.find(make_pair(a, b));
	if (iter != cache.end()) {
		if (iter->second == -1) {
			tree.pop_back();
			return { nullptr, false };
		}
		me->value = iter->second;
		if (me->value == 2) {

		}
	}
}
#endif

int dfs(int v)
{
	if (v == -1) {
		return 0;
	}
	node &n = tree[v];
	int sum = n.value;
	int suml = dfs(n.l);
	int sumr = dfs(n.r);
	if (abs(suml - sumr) > 1) {
		cout << -1 << endl;
		exit(0);
	}
	return sum;
}

int main(int argc, char *argv[])
{
#ifdef OFFLINE_JUDGE
	(void) argc; (void) argv;
	freopen("/home/sven/progs/acm/input.txt", "r", stdin);
#endif
	cin.sync_with_stdio(false);
	cout.sync_with_stdio(false);
	cin.tie(nullptr);

	int a, b;
	cin >> a >> b;

	tree.emplace_back();
	if (b > 0) {
		tree[0].value = 2;
		b--;
	} else {
		tree[0].value = 1;
		a--;
	}

	vector<pair<int, char> > curlayer;
	vector<pair<int, char> > nextlayer;
	curlayer.emplace_back(0, 'L');
	curlayer.emplace_back(0, 'R');

	while (a + b > 0) {
		bool startones = false;
		bool kostyl = false;

		auto layercopy = curlayer;

		fi(curlayer.size()) {
			if (a + b == 0) {
				break;
			}

			auto &i1 = curlayer[i];

			int childid = int(tree.size());
			tree.emplace_back();

			node &parent = tree[i1.first];
			node &child = tree.back();

			if (i1.second == 'L') {
				assert(parent.l == -1);
				parent.l = childid;
			} else {
				assert(parent.r == -1);
				parent.r = childid;
			}

			if (b > 0) {
				child.value = 2;
				b--;
				if (b == 0) {
					startones = true;
				}
			} else {
				child.value = 1;
				a--;
				if (startones && !kostyl && i % 2 != 0) {
					kostyl = true;
					if (i < int(curlayer.size()) / 2) {
						for (int j = i + 1; j < int(curlayer.size()) / 2; j += 2) {
							swap(curlayer[j], curlayer[j + 1]);
						}
						reverse(curlayer.begin() + (curlayer.size() / 2), curlayer.end());
					} else {
						for (int j = i + 1; j < int(curlayer.size()); j += 2) {
							swap(curlayer[j], curlayer[j + 1]);
						}
					}
				}
			}
		}

		//    1     // 1L 1R
		//  2   3   // 2L 3L 2R 3R
		// 4 6 5 7  // 4L 5L 6L 7L 4R 5R 6R 7R

		f1(layercopy) {
			node &parent = tree[i1.first];
			if (i1.second == 'L' && parent.l != -1) {
				nextlayer.emplace_back(parent.l, 'L');
			}
			if (i1.second == 'R' && parent.r != -1) {
				nextlayer.emplace_back(parent.r, 'L');
			}
		}

		f1(layercopy) {
			node &parent = tree[i1.first];
			if (i1.second == 'L' && parent.l != -1) {
				nextlayer.emplace_back(parent.l, 'R');
			}
			if (i1.second == 'R' && parent.r != -1) {
				nextlayer.emplace_back(parent.r, 'R');
			}
		}

		if (startones) {
			reverse(all(nextlayer));
		}

		swap(curlayer, nextlayer);
		nextlayer.clear();
	}

	dfs(0);

	f1(tree) {
		cout << i1.value << ' ';
		int il = i1.l == -1 ? 0 : i1.l + 1;
		int ir = i1.r == -1 ? 0 : i1.r + 1;
		cout << il << ' ' << ir << endl;
	}

	return 0;
}
