#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;

const ll mod = 1000000007;

#define x first
#define y second

template<typename T>
istream& operator >> (istream& in, vector<T> &v) {
	for (int i = 0; i < v.size(); i++) {
		in >> v[i];
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v) {
	for (int i = 0; i < v.size(); i++) {
		out << v[i] << ' ';
	}
	return out;
}

bool ok(string &a) {
	map<char, int> m;
	for (auto i : a) {
		m[i]++;
	}

	return (m['2'] >= 2) && (m['0'] >= 1) && (m['1'] >= 1);
}

ll toNum(string &a) {
	ll ans = 0;
	reverse(a.begin(), a.end());
	ll d = 1;
	for (auto i : a) {
		ans += (i - '0') * d;
		d *= 10;
	}

	return ans;
}

void solve() {
	int n;
	cin >> n;
	vector<pair<ll, string>> v(n);
	int mn = 1e8;
	int ans = -1;
	for (int i = 0; i < n; i++) {
		cin >> v[i].x >> v[i].y;
//		cerr << v[i].x << ' ';
		//ll b = toNum(v[i].y);
		if (ok(v[i].y) && v[i].x < mn) {
			mn = v[i].x;
			ans = i;
			//cerr << ok(v[i].y) << endl;
		}
	}
	if (ans >= 0)cout << ans + 1;
	else cout << -1 << endl;
}
 
int main() {
	#ifdef LOCAL
		freopen("input.in", "r", stdin);
		freopen("output.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
//	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}