// chrono::system_clock::now().time_since_epoch().count()
#include <bits/stdc++.h>

#define pb push_back
#define eb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define debug(x) cerr << #x << " = " << x << endl

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int MAXN = (int)3e5 + 5;

vi g[MAXN];
priority_queue<int> q;
int ans[MAXN];
int dp[MAXN], flip[MAXN], last[MAXN];
int arr[MAXN];
int n;
vi changed;

int f(int a, int b) {
    return 8 - __builtin_popcount(a ^ b);
}

void go(int st) {
    q.push(st);
    
    while (!q.empty()) {
        int v = q.top();
        q.pop();
        
        if (last[v] != st) {
            last[v] = st;
            flip[v] = 0;
        }
        
        if (flip[v] % 2 == 0) {
            continue;
        }
        
        if (dp[v] > 0) {
            for (int to : g[v]) {
                if (--dp[to] == 0) {
                    if (last[to] != st) {
                        last[to] = st;
                        flip[to] = 0;
                    }
                
                    ++flip[to];
                    q.push(to);
                }
            }
        }
        else {
            for (int to : g[v]) {
                if (dp[to]++ == 0) {
                    if (last[to] != st) {
                        last[to] = st;
                        flip[to] = 0;
                    }
                
                    ++flip[to];
                    q.push(to);
                }
            }
        }
    }
}

void solve() {
    cin >> n;
    
    rep (i, 0, n) {
        string s;
        cin >> s;
        
        rep (j, 0, 8) {
            arr[i] = arr[i] * 2 + (s[j] == 'W');
        }
    }
    
    for (int i = n - 1; ~i; --i) {
        for (int j = i + 1; j < min(n, i + 8); ++j) {
            if (j - i <= f(arr[i], arr[j])) {
                g[j].pb(i);
            
                if (dp[j] == 0) {
                    ++dp[i];
                }
            }
        }
    }
    
    ans[n] = 2 - !!dp[0];
    fill(last, last + n, -1);
    
    for (int lim = n - 1; lim; --lim) {        
        if (dp[lim] == 0) { 
            last[lim] = lim;
            flip[lim] = 1;
            dp[lim] = 1;
            go(lim);
        }
    
        ans[lim] = 2 - !!dp[0];
    }
    
    rep (i, 1, n + 1) {
        cout << ans[i];
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    
    while (tt--) {
        solve();
    }

    return 0;
}
