#include <bits/stdc++.h>
    
#define mp make_pair
#define pb push_back
#define f first
#define s second
#define ll long long
#define forn(i, a, b) for(int i = (a); i <= (b); ++i)
#define forev(i, b, a) for(int i = (b); i >= (a); --i)
#define VAR(v, i) __typeof( i) v=(i)
#define forit(i, c) for(VAR(i, (c).begin()); i != (c).end(); ++i)
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
#define file(s) freopen(s".in","r",stdin); freopen(s".out","w",stdout);
    
using namespace std;
    
const int maxn = (int)6e5 + 100;
const int mod = (int)1e9 + 7;
const int P = (int) 1e6 + 7; 
const double pi = acos(-1.0);
    
#define inf mod
    
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;   
typedef vector<ll> Vll;               
typedef vector<pair<int, int> > vpii;
typedef vector<pair<ll, ll> > vpll;
 
          
int n, q, vmin[maxn], vmax[maxn], key[maxn], l[maxn], r[maxn], h[maxn];
vi vals, g1[maxn], g2[maxn];
vector<pair<int, pii> > qt[maxn];
int a[maxn], b[maxn];
int up[maxn][20];
 
void dfs(int v, int par = 0){
  up[v][0] = par;
  forn(i, 1, 19)
    up[v][i] = up[up[v][i - 1]][i - 1];
  vmin[v] = vmax[v] = key[v];
  if(l[v]){
    h[l[v]] = h[v] + 1;
    dfs(l[v], v);
    vmin[v] = min(vmin[v], vmin[l[v]]);
    vmax[v] = max(vmax[v], vmax[l[v]]);
  }
  if(r[v]){
    h[r[v]] = h[v] + 1;
    dfs(r[v], v);
    vmin[v] = min(vmin[v], vmin[r[v]]);
    vmax[v] = max(vmax[v], vmax[r[v]]);
  }
  qt[vmax[v]].pb({vmin[v], {vmin[v], v}});
 
}
int lca(int u, int v){
  if(h[u] > h[v])
    swap(u, v);
  forev(i, 19, 0){
    if(h[up[v][i]] >= h[u])
      v = up[v][i];
  }
  if(v == u)
    return v;
  forev(i, 19, 0){
    if(up[v][i] != up[u][i]){
      u = up[u][i];
      v = up[v][i];
    }
  }
  return up[u][0];
}  
 
pii t[maxn];
void upd(int pos, pii val){
  for(; pos < maxn; pos |= (pos + 1))
    t[pos] = max(t[pos], val);
}
pii get(int r){
  pii res = {-inf, -inf};
  for(; r >= 0; r = (r & (r + 1)) - 1)
    res = max(res, t[r]);
  return res;
}
void solve(){
  scanf("%d", &n);
  forn(i, 1, n){
    scanf("%d%d%d", &l[i], &r[i], &key[i]);
    vals.pb(key[i]);
    vals.pb(key[i] - 1);
    vals.pb(key[i] + 1);
  }
  sort(all(vals));
  vals.resize(unique(all(vals)) - vals.begin());
  forn(i, 1, n)
    key[i] = lower_bound(all(vals), key[i]) - vals.begin();
  h[1] = 1;
  dfs(1);
  scanf("%d", &q);
  forn(i, 1, q){
    scanf("%d%d", &l[i], &r[i]);
    l[i] = lower_bound(all(vals), l[i]) - vals.begin();
    r[i] = lower_bound(all(vals), r[i]) - vals.begin();
    g1[l[i]].pb(i);
    g2[r[i]].pb(i);
  }
  forev(i, maxn - 1, 0){
    for(auto x : qt[i]){
      //cout << x.f << " -> " << x.s.f << " " << x.s.s << endl;
      upd(x.f, {x.s.f, x.s.s});
    }
    for(auto x : g1[i])
      a[x] = get(i).s;
    for(auto x : g2[i])
      b[x] = get(i).s;
  }
  forn(i, 1, q){
    /*int cur = -1;
    forn(v, 1, n){
      if(vmin[v] <= r[i] && r[i] <= vmax[v]){
        if(cur == -1 || h[cur] < h[v])
          cur = v;
      } 
    }
    cout << cur << ": ";
    */
    if(!a[i] || !b[i]) puts("1");
    else{
      int cur = 1, l = lca(a[i], b[i]);
      if(a[i] != b[i]){
        cur += (h[a[i]] - h[l]) * 2;
        cur += (h[b[i]] - h[l]) * 2;
        cur += 2;
      }
      else {
        cur += 2 * h[a[i]];
      }
      cout << cur << endl;
    }
  }
}
   
int main () {
  int t = 1;
  //scanf("%d", &t);
  while(t--)
    solve();
   
}