#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include "stdio.h"
#include "stdlib.h"
#include "time.h"
#include <cmath>
#include <math.h>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <bitset>
#include <functional>
#include <intrin.h>
#include <stack>
using namespace std;
//typedef long long ll;
#define ll long long
#define ld long double


#define MIN(x,y) ((x)<(y)?(x):(y))
#define MAX(x,y) ((x)>(y)?(x):(y))
#define PI 3.14159265358979323846
#define ABS(a) ((a)<0?-(a):(a))
const long long MOD = 1000000007;
const long long LLONG = 9223372036854775807;
const int N = 1000000;
const double EPS = 0.0001;

template <typename T> inline int sgn(const T& val) { return (T(0) < val) - (val < T(0)); }
inline unsigned long long hsh(int x, int y) { return (((unsigned long long)x) << 32) + y; }
template <typename T> inline T gcd(T a, T b) {
    while (b) { a %= b; swap(a, b); }
    return a;
}
inline void fastio() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
const uint64_t m1 = 0x5555555555555555;
const uint64_t m2 = 0x3333333333333333;
const uint64_t m4 = 0x0f0f0f0f0f0f0f0f;
int popcount64(uint64_t x)
{
    x -= (x >> 1) & m1;
    x = (x & m2) + ((x >> 2) & m2);
    x = (x + (x >> 4)) & m4;
    x += x >> 8;
    x += x >> 16;
    x += x >> 32;
    return x & 0x7f;
}

const int mlen[2][12] = { {31,28,31,30,31,30,31,31,30,31,30,31},{31,29,31,30,31,30,31,31,30,31,30,31} };
const int mcode[12] = { 1,4,4,0,2,5,0,3,6,1,4,6 };
inline int is_leap(int year) { return (!(year % 400)) || ((year % 100) && (!(year % 4))); }

void YaCupDsolve()
{
    //freopen("output.txt", "w+", stdout);
    //freopen("input.txt", "r", stdin);
    multiset <long long> nums;
    int n, k, r, cn = 0;
    long long sum = 0, t, a;
    scanf("%i %i %i", &n, &k, &r);
    for (int i = 0; i < n; i++)
    {
        scanf("%lli", &a);
        nums.insert(a);
    }
    auto st = nums.begin();
    auto en = st;
    while (cn < k && en != nums.end())
    {
        cn++;
        sum += *en;
        en++;
    }
    en--;
    if (k > 1)
    {
        for (int i = 0; i < r; i++)
        {
            t = sum;
            sum -= *st;
            nums.insert(t);
            auto tp = st;
            st++;
            nums.erase(tp);
            if (st != nums.begin())
            {
                st--;
                sum += *st;
            }
            else
            {
                if (t < *en)
                {
                    sum += t;
                }
                else
                {
                    en++;
                    sum += *en;
                }
            }
        }
    }
    for (auto it : nums)
    {
        printf("%lli ", it);
    }
}

int Convexity4()
{
    int x[4], y[4], dx[3], dy[3];
    bool fl;
    for (int i = 0; i < 4; i++)
        scanf("%i %i", x + i, y + i);
    for (int i = 0; i < 4; i++)
    {
        fl = false;
        for (int j = 0; j < 3; j++)
        {
            dx[j] = x[(i + j + 1) % 4] - x[i];
            dy[j] = y[(i + j + 1) % 4] - y[i];
        }
        for (int j = 0; j < 3; j++)
        {
            long double m = (dx[j] * dy[(j + 1) % 3] - dx[(j + 1) % 3] * dy[j]) / ((long double)(dx[(j + 2) % 3] * dy[(j + 1) % 3] - dx[(j + 1) % 3] * dy[(j + 2) % 3]));
            if (m > 0 + EPS && m < 1 - EPS)
            {
                long double l = (dx[j] - m * dx[(j + 2) % 3]) / ((long double)dx[(j + 1) % 3]);
                if (l > 0 + EPS && m + l < 1 - EPS)
                    fl = true;
            }
        }
        if (fl)
        {
            printf("3\n");
            return 0;
        }
    }
    printf("4\n");
}

void mult22(long long matrres[2][2], long long matrmult[2][2], long long mod)
{
    long long tmatr[2][2];
    tmatr[0][0] = (matrres[0][0] * matrmult[0][0]) % mod + (matrres[0][1] * matrmult[1][0]) % mod;
    tmatr[0][1] = (matrres[0][0] * matrmult[0][1]) % mod + (matrres[0][1] * matrmult[1][1]) % mod;
    tmatr[1][1] = (matrres[1][0] * matrmult[0][1]) % mod + (matrres[1][1] * matrmult[1][1]) % mod;
    tmatr[1][0] = (matrres[1][0] * matrmult[0][0]) % mod + (matrres[1][1] * matrmult[1][0]) % mod;
    matrres[0][0] = (tmatr[0][0]) % mod;
    matrres[1][0] = (tmatr[1][0]) % mod;
    matrres[1][1] = (tmatr[1][1]) % mod;
    matrres[0][1] = (tmatr[0][1]) % mod;
}

long long fibo(long long n, long long mod)
{
    if (n == 0)return 0;
    long long matr[2][2];
    matr[0][0] = 0;
    matr[1][0] = 1;
    matr[1][1] = 1;
    matr[0][1] = 1;
    long long multmatr[2][2];
    multmatr[0][0] = 0;
    multmatr[1][0] = 1;
    multmatr[1][1] = 1;
    multmatr[0][1] = 1;
    n = n - 1;
    while (n > 0)
    {
        if (n & 1)
            mult22(matr, multmatr, mod);
        mult22(multmatr, multmatr, mod);
        n >>= 1;
    }
    return(matr[0][1]);
}

bool issqr(int k)
{
    int t = (int)sqrt(k);
    return (t * t) == k;
}

void multNN(long long* matrres, long long* matrmult, long long mod, int n)
{
    long long* tmatr = (long long*)malloc(n * n * 8);
    int i, j, k;
    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++)
        {
            tmatr[i * n + j] = 0;
            for (k = 0; k < n; k++)
            {
                tmatr[i * n + j] += matrres[i * n + k] * matrmult[k * n + j];
                tmatr[i * n + j] %= mod;
            }
        }

    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++)
            matrres[i * n + j] = tmatr[i * n + j];
    free(tmatr);
}

void matrPOW(long long* matrres, int n, long long pow, long long mod)
{
    long long* multmatr = (long long*)malloc(n * n * 8);
    int i, j;
    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++)
            multmatr[i * n + j] = matrres[i * n + j];
    pow = pow - 1;
    while (pow > 0)
    {
        if (pow & 1)
            multNN(matrres, multmatr, mod, n);
        multNN(multmatr, multmatr, mod, n);
        pow >>= 1;
    }
}

double calcdet33(double* matr)
{
    double res = 0;
    res += matr[0] * matr[4] * matr[8];
    res += matr[1] * matr[5] * matr[6];
    res += matr[2] * matr[3] * matr[7];
    res -= matr[2] * matr[4] * matr[6];
    res -= matr[1] * matr[3] * matr[8];
    res -= matr[0] * matr[5] * matr[7];
    return res;
}

template <typename T> class UniFenv
{
private:
    T(*_reverse)(T, T);
    T(*_forward)(T, T);
    vector<T> _v;
    T _default;
    int _n;
public:
    UniFenv(int n, T default_value, T(*reverseFunc)(T, T), T(*forwardFunc)(T, T))
    {
        _reverse = reverseFunc;
        _forward = forwardFunc;
        _n = n;
        _default = default_value;
        _v.resize(_n, _default);
    }
    T get(int r)
    {
        T result = _default;
        for (; r >= 0; r = (r & (r + 1)) - 1)
            result = _forward(result, _v[r]);
        return result;
    }
    T get(int l, int r)
    {
        return _reverse(get(r), get(l - 1));
    }
    void inc(int i, T d)
    {
        for (; i < _n; i = (i | (i + 1)))
            _v[i] = _forward(_v[i], d);
    }
};

class SectiFenv
{
private:
    vector<double> left;
    vector<double> right;
    int k;

    inline int G(int x)
    {
        return x - (x & (x - 1));
    }
public:
    SectiFenv(vector<double> v, double def)
    {
        for (k = 0; (1 << k) < v.size(); k++);
        left.resize(1 << k, def);
        right.resize(v.size(), def);
        for (int i = 0; i < v.size(); i++) Update(i + 1, v[i]);
    }
    void Update(int r, double cost)
    {
        //a[r - 1] = cost;
        int i = r;
        while (i <= pow(2.0, double(k)))
        {
            left[i] = max(left[i], cost);
            i = i + G(i);
        }
        i = r;
        while (i > 0)
        {
            right[i] = max(right[i], cost);
            i = i - G(i);
        }
    }
    double Max(int l, int r) {
        double res = 0;
        int i = l;
        while (i + G(i) <= r)
        {
            res = max(res, right[i]);
            i = i + G(i);
        }
        //res = max(res, a[i - 1]);
        i = r;
        while (i - G(i) >= l)
        {
            res = max(res, left[i]);
            i = i - G(i);
        }
        return res;
    }
};



class Longnum
{
public:

    vector < long long > c;

    Longnum()
    {
        c.push_back(0);
    }
    Longnum(int n)
    {
        c.resize(n, 0);
    }

    ~Longnum()
    {
        c.clear();
        c.shrink_to_fit();
    }

    int slongsub(Longnum& temp, Longnum& b)
    {
        long long carry = 0;
        vector<long long> a(temp.c);
        for (size_t i = 0; i < b.c.size() || carry; ++i) {
            a[i] -= carry + (i < b.c.size() ? b.c[i] : 0);
            carry = a[i] < 0;
            if (carry)  a[i] += slongbase;
        }
        if (carry)
            return -1;
        else
        {
            while (a.size() > 1 && a.back() == 0)
                a.pop_back();
            temp.c = a;
            return 0;
        }
    }

    void add(int b)
    {
        long long carry = 0;
        for (size_t i = 0; i < c.size() || carry; ++i) {
            if (i == c.size())
                c.push_back(0);
            c[i] += carry + (i > 0 ? 0 : b);
            carry = c[i] >= slongbase;
            if (carry)  c[i] -= slongbase;
        }
    }

    void mult(long long b)
    {
        long long carry = 0;
        for (size_t i = 0; i < c.size() || carry; ++i) {
            if (i == c.size())
                c.push_back(0);
            long long cur = carry + c[i] * 1ll * (b % slongbase);
            carry = cur / slongbase + c[i] * (b / slongbase);
            c[i] = int(cur % slongbase);
        }
        while (c.size() > 1 && c.back() == 0)
            c.pop_back();
    }

    void longmult(Longnum b)
    {
        Longnum n(c.size() + b.c.size());

        for (size_t i = 0; i < c.size(); ++i)
            for (int j = 0, carry = 0; j < (int)b.c.size() || carry; ++j) {
                long long cur = n.c[i + j] + c[i] * 1ll * (j < (int)b.c.size() ? b.c[j] : 0) + carry;
                n.c[i + j] = int(cur % slongbase);
                carry = int(cur / slongbase);
            }
        while (n.c.size() > 1 && n.c.back() == 0)
            n.c.pop_back();
        c = n.c;
    }

    int slongcomp(Longnum a, Longnum b)
    {
        if (a.c.size() != b.c.size())
            return (a.c.size() > b.c.size() ? 1 : -1);
        else
        {
            for (int i = a.c.size() - 1; i >= 0; i--)
                if (a.c[i] != b.c[i])
                    return (a.c[i] > b.c[i] ? 1 : -1);
            return 0;
        }
    }

    void slongdel(Longnum& b)
    {
        Longnum temp, temp2;
        Longnum res;
        for (int i = 0; i < c.size() - b.c.size(); i++)
        {
            temp.c.push_back(0);
            res.c.push_back(0);
        }
        res.c.push_back(0);
        for (int i = 0; i < b.c.size(); i++)
            temp.c.push_back(b.c[i]);

        for (int i = c.size() - b.c.size(); i >= 0; i--)
        {
            temp2.c = temp.c;
            res.c[i] = (c[c.size() - 1] / temp.c[temp.c.size() - 1]);
            temp.mult(c[c.size() - 1] / temp.c[temp.c.size() - 1]);
            if (slongcomp(temp, *this) > 0)
            {
                slongsub(temp, temp2);
                res.c[i]--;
            }
            slongsub(*this, temp);
            temp.c.clear();
            for (int j = 1; j < temp2.c.size(); j++)
                temp.c.push_back(temp2.c[i + 1]);
        }
        if (c.size() > 1 || c[0] > 0)
        {
            res.c[0] += 1;
            int carry = res.c[0] / slongbase;
            int i = 0;
            while (carry)
            {
                res.c[i] %= slongbase;
                i++;
                if (i == res.c.size())
                    res.c.push_back(0);
                res.c[i] += carry;
                carry = res.c[i] / slongbase;
            }
        }
        c = res.c;
        return;
    }

    void slongprint()
    {
        printf("%lldd", c.empty() ? 0 : c.back());
        for (int i = (int)c.size() - 2; i >= 0; --i)
            printf("%09lld", c[i]);
        printf(" ");
    }

    void slongread()
    {
        string s;
        cin >> s;
        for (int i = (int)s.length(); i > 0; i -= 9)
            if (i < 9)
                c.push_back(atoi(s.substr(0, i).c_str()));
            else
                c.push_back(atoi(s.substr(i - 9, 9).c_str()));
    }

    void longadd(Longnum& b)
    {
        long long carry = 0;
        for (size_t i = 0; i < max(c.size(), b.c.size()) || carry; ++i) {
            if (i == c.size())
                c.push_back(0);
            c[i] += carry + (i < b.c.size() ? b.c[i] : 0);
            carry = c[i] >= slongbase;
            if (carry)  c[i] -= slongbase;
        }
    }

private:

    const long long slongbase = 1000 * 1000 * 1000;
};

class SeTree
{
public:
    SeTree() {}
    ~SeTree() {}
    void build(int a, int l, int r, int* inp)
    {
        int m = (l + r + 1) / 2;
        if (a == 1)
        {
            _l = l;
            _r = r;
        }
        vup[a] = 0;
        if (l != r)
        {
            build(a * 2, l, m - 1, inp);
            build(a * 2 + 1, m, r, inp);
            v[a] = v[a * 2 + 1] ^ v[a * 2];
        }
        else
            v[a] = inp[l];
    }
    void flip(int a, int l, int r, int li, int ri)
    {
        if (vup[a])
        {
            if (l != r)
            {
                v[a * 2 + 1] = !v[a * 2 + 1];
                vup[a * 2 + 1] = 1;
                v[a * 2] = !v[a * 2];
                vup[a * 2] = 1;
            }
            vup[a] = 0;
        }
        if ((li == l) && (ri == r))
        {
            v[a] = !v[a];
            vup[a] = 1;
        }
        else
        {
            int m = (l + r + 1) / 2;
            if (ri < m)
            {
                flip(a * 2, l, m - 1, li, ri);
            }
            else
            {
                if (li >= m)
                {
                    flip(a * 2 + 1, m, r, li, ri);
                }
                else
                {
                    flip(a * 2, l, m - 1, li, m - 1);
                    flip(a * 2 + 1, m, r, m, ri);
                }
            }
            v[a] = v[a * 2 + 1] ^ v[a * 2];
        }
    }
    void flip(int li, int ri)
    {
        flip(1, _l, _r, li, ri);
    }
    void flip(int a, int l, int r, int i)
    {
        if (vup[a])
        {
            if (l != r)
            {
                v[a * 2 + 1] = !v[a * 2 + 1];
                vup[a * 2 + 1] = 1;
                v[a * 2] = !v[a * 2];
                vup[a * 2] = 1;
            }
            vup[a] = 0;
        }
        if (l == r)
            v[a] = !v[a];
        else
        {
            int m = (l + r + 1) / 2;
            if (i < m)
            {
                flip(a * 2, l, m - 1, i);
            }
            else
            {
                flip(a * 2 + 1, m, r, i);
            }
        }
    }
    void flip(int i)
    {
        flip(1, _l, _r, i);
    }
    /*void  update(int a, int l, int r, double k, int lr, int rr)
    {
        if ((lr == l) && (rr == r))
        {
            v[a] = k;
            vup[a] = 1;
        }
        else
        {
            int m = (l + r + 1) / 2;
            if (vup[a])
            {
                v[a * 2 + 1] = v[a];
                vup[a * 2 + 1] = 1;
                v[a * 2] = v[a];
                vup[a * 2] = 1;
                vup[a] = 0;
            }
            if (rr < m)
            {
                update(a * 2, l, m - 1, k, lr, rr);
            }
            else
            {
                if (lr >= m)
                {
                    update(a * 2 + 1, m, r, k, lr, rr);
                }
                else
                {
                    update(a * 2, l, m - 1, k, lr, m - 1);
                    update(a * 2 + 1, m, r, k, m, rr);
                }
            }
            v[a] = (v[a * 2 + 1] * (r - m + 1) + v[a * 2] * (m - l)) / (double)(r - l + 1);
        }
    }*/
    /*double getavg(int a, int l, int r, int lr, int rr)
    {
        if (vup[a] || (l == lr && r == rr))
            return v[a];
        else
        {
            int m = (l + r + 1) / 2;
            if (rr < m)
            {
                return getavg(a * 2, l, m - 1, lr, rr);
            }
            else
            {
                if (lr >= m)
                    return getavg(a * 2 + 1, m, r, lr, rr);
                else
                {
                    return (getavg(a * 2 + 1, m, r, m, rr) * (rr - m + 1) + getavg(a * 2, l, m - 1, lr, m - 1) * (m - lr)) / (double)(rr - lr + 1);
                }
            }
        }
    }*/
    bool getxor(int a, int l, int r, int li, int ri)
    {
        if (vup[a])
        {
            if (l <= r)
            {
                v[a * 2 + 1] = !v[a * 2 + 1];
                vup[a * 2 + 1] = 1;
                v[a * 2] = !v[a * 2];
                vup[a * 2] = 1;
            }
            vup[a] = 0;
        }
        if (r < l)
            return 0;
        if (l == li && r == ri)
            return v[a];
        else
        {
            int m = (l + r + 1) / 2;
            if (ri < m)
            {
                return getxor(a * 2, l, m - 1, li, ri);
            }
            else
            {
                if (li >= m)
                    return getxor(a * 2 + 1, m, r, li, ri);
                else
                {
                    return (getxor(a * 2 + 1, m, r, m, ri) ^ getxor(a * 2, l, m - 1, li, m - 1));
                }
            }
        }
    }
    bool getxor(int li, int ri)
    {
        return getxor(1, _l, _r, li, ri);
    }
    bool get(int a, int l, int r, int i)
    {
        if (vup[a])
        {
            if (l < r)
            {
                v[a * 2 + 1] = !v[a * 2 + 1];
                vup[a * 2 + 1] = 1;
                v[a * 2] = !v[a * 2];
                vup[a * 2] = 1;
            }
            vup[a] = 0;
        }
        if (l == r)
            return v[a];
        else
        {
            int m = (l + r + 1) / 2;
            if (i < m)
            {
                return get(a * 2, l, m - 1, i);
            }
            else
            {
                return get(a * 2 + 1, m, r, i);
            }
        }
    }
    bool get(int i)
    {
        return get(1, _l, _r, i);
    }

private:
    int _l, _r;
    bool vup[N * 4];
    int v[N * 4];
};

void eratosfen(char* erat, int n)
{
    int sr = (int)ceil(sqrt(n + 1)), i, j;
    erat[0] = erat[1] = 0;
    erat[2] = 0;
    for (i = 3; i <= n; i++)
        erat[i] = i % 2;
    for (i = 3; i * i <= n; i++)
        for (j = i * i; j <= n; j += i)
            erat[j] = 0;
}



void taskK() {
    int n;
    cin >> n;

    int bestI = -1;
    int bestPrice = 10000000;

    int price;
    string s;


    for (int i = 0; i < n; ++i) {
        cin >> price >> s;

        if (s.find('0') == -1) {
            continue;
        }
        if (s.find('1') == -1) {
            continue;
        }

        if (s.find('2') == -1) {
            continue;
        }

        if ( s.rfind('2')==s.find('2')) {
            continue;
        }

        if (price < bestPrice) {
            bestI = i;
            bestPrice = price;
        }
    }

    cout << (bestI + 1) << endl;
}


int main() {
    taskK();
    return 0;
}