n = int(input())

v = [int(x) for x in input().split()]
nodes = dict()
for i in range(n-1):
    if v[i] in nodes:
        nodes[v[i]].append(i+2)
    else:
        nodes[v[i]] = [i+2]

def color(root):
    if root not in nodes:
        return [root]
    ans = []
    
    for x in nodes[root]:
        c = color(x)
        tmp = []
        if len(c) > len(ans):
            c, ans = ans, c

        for i in range(len(ans)):
            tmp.append(ans[i])
            if i % 2 != 0:
                tmp += c
            else:
                tmp += c[::-1]    
        ans = c + tmp
    return [root] + ans
    

ans = color(1)
if n == 1:
    print("0\n")
else:
    print(len(ans)-1)
    print(" ".join(map(str, ans[1:])))
