#include <bits/stdc++.h>
using namespace std;
typedef int64_t i64;

int main() {
#ifdef LOCAL_TESTING
    freopen("input.txt", "rt", stdin);
#endif
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        int pi;
        cin >> pi;
        pi--;
        g[pi].push_back(i);
    }
    function<vector<int> (int, int)> solve = [&](int x, int sz) {
        vector<int> ans{x};
        if (g[x].size() == 0)  {
            return ans;
        }
        if (sz == 0) {
            auto temp = solve(g[x][sz], g[g[x][sz]].size() - 1);
            ans.insert(ans.end(), temp.begin(), temp.end());
            return ans;
        }
        vector<int> temp1 = solve(x, sz - 1);
        vector<int> temp2 = solve(g[x][sz], g[g[x][sz]].size() - 1);
        temp1.erase(temp1.begin());
        vector<int> tempr(temp1);
        reverse(tempr.begin(), tempr.end());
        for (int i = 0; i < temp2.size(); i++) {
            if (i % 2 == 0) {
                ans.insert(ans.end(), temp1.begin(), temp1.end());
            } else {
                ans.insert(ans.end(), tempr.begin(), tempr.end());
            }
            ans.push_back(temp2[i]);
        }
        if (temp2.size() % 2 == 0) {
            ans.insert(ans.end(), temp1.begin(), temp1.end());
        } else {
            ans.insert(ans.end(), tempr.begin(), tempr.end());
        }
        return ans;
    };
    vector<int> ans = solve(0, g[0].size() - 1);
    ans.erase(ans.begin());
    cout << ans.size() << endl;
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
    return 0;
}