#include <bits/stdc++.h>
using namespace std;

#define int long long

int n;

struct Seg {
    int l;
    int r;
    int w;
};

bool cmpl(const Seg& a, const Seg& b) {
    if (a.l == b.l)
        return a.r < b.r;
    return a.l < b.l;
}

bool cmpr(const Seg& a, const Seg& b) {
    return a.r < b.r;
}

bool cmprr(const pair<pair<int, int>, int>& a, const pair<pair<int, int>, int>& b) {
    return a.first.second < b.first.second;
}
std::vector<std::vector<int>> g(200005);
std::vector<Seg> all;
std::vector<Seg> allr;
int k[200005];
std::map<int, int> mp;
std::vector<int> ls;
int ans[200005];
pair<int, int> dfs(int x) {
    int mn = k[x];
    int mx = k[x];
    for (const int ind : g[x]) {
        auto res = dfs(ind);
        mn = min(mn, res.first);
        mx = max(mx, res.second);
    }
    ls.push_back(mn);
    all.push_back({mn, mx, 2});
    return {mn, mx};
}

struct Fenwik {
    vector<int> t;

    Fenwik(int n) {
        t.resize(n + 228);
    }

    int get(int r) {
        int ans = 0;
        for (int i = r; i > 0; i -= (i & -i))
            ans += t[i];
        return ans;
    }

    void inc(int pos, int a) {
        ++pos;
        for (int i = pos; i < t.size(); i += (i & -i))
            t[i] += a;
    }

    int get(int l, int r) {
        ++l;
        ++r;
        return get(r) - get(l - 1);
    }

    void change(int pos, int newValue) {
        inc(pos, -get(pos, pos));
        inc(pos, newValue);
    }
};

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin >> n;

    for (int i = 0; i < n; i++) {
        int l, r, kc;
        cin >> l >> r >> kc;
        k[i + 1] = kc;
        if (l != 0) {
            g[i + 1].push_back(l);
        }
        if (r != 0) {
            g[i + 1].push_back(r);
        }
    }
    dfs(1);
    allr = all;
    sort(all.begin(), all.end(), cmpr);
    sort(allr.begin(), allr.end(), cmpl);
    for (const auto& item : all) {
        ls.push_back(item.l);
    }
    int q;
    cin >> q;
    std::vector<pair<pair<int, int>, int>> qs;
    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        ls.push_back(l);
        qs.push_back({{r, l}, i});
    }
    sort(ls.begin(), ls.end());
    int cnt = 0;
    for (int i = 0; i < ls.size(); i++) {
        if (i && ls[i] != ls[i - 1])
            cnt++;
        mp[ls[i]] = cnt;
    }
    sort(qs.begin(), qs.end());
    int nex = 0;
    Fenwik fen(500000);
    for (int i = 0; i < qs.size(); i++) {
        while (nex < all.size() && all[nex].r <= qs[i].first.first) {
            fen.inc(mp[all[nex].l], all[nex].w);
            nex++;
        }
        ans[qs[i].second] = fen.get(mp[qs[i].first.second], 450000);
    }
    nex = 0;
    for (int i = 0; i < qs.size(); i++) {
        while (nex < allr.size() && allr[nex].l <= qs[i].first.first) {
            nex++;
        }
        ans[qs[i].second] += 2 * (n - nex);
    }
    nex = 0;
    sort(qs.begin(), qs.end(), cmprr);
    for (int i = 0; i < qs.size(); i++) {
        while (nex < all.size() && all[nex].r < qs[i].first.second) {
            nex++;
        }
        ans[qs[i].second] += 2 * nex;
    }
    for (int i = 0; i < q; i++) {
        int rs = 2 * n + 1;
        rs -= ans[i];
        cout << rs << "\n";
    }
    return 0;
}