﻿#include <algorithm>
#include <assert.h>
#include <chrono>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ll MOD = 1000000007;
const ld EPS = 1e-11;
const ll INFL = 1e18;
const ll INF = 1e9 + 7;
const ld PI = acos(-1);

mt19937 rnd((unsigned)chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    int besta = 0;
    int minc = INF;
    for (int ti = 0; ti < n; ++ti) {
        int p;
        cin >> p;
        string s;
        cin >> s;
        vector<int> cou(10, 0);
        for (int i = 0; i < s.size(); ++i) {
            ++cou[s[i] - '0'];
        }
        if (cou[0] >= 1 && cou[1] >= 1 && cou[2] >= 2 && minc > p) {
            minc = p;
            besta = ti + 1;
        }
    }

    cout << besta << "\n";

    return 0;
}