#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
//#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 1e5 + 1;

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#else
    //    freopen("lupa.in","r",stdin);
    //    freopen("pupa.out","w",stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(10);
    cout << fixed;
    int n;
    cin >> n;

    vector<int> last(maxn, -1);
    vector<vector<int>> graph(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int ind;
            cin >> ind;
            if (last[ind] > -1) {
                graph[last[ind]].push_back(i);
            }
            last[ind] = i;
        }
    }
    vector<int> collor(n);
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        int mx = 0;
        for (int next: graph[i]) {
            mx = max(mx, collor[next]);

        }
        collor[i] = mx + 1;
        ans = max(ans, mx + 1);
    }
    cout << ans;
    return 0;
}