#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 100500;
const int inf = 1e9;

pair<int, pair<int, int>> ans[2 * maxn];
int new_v;

int Solve(int v, int depth, int max_bit, int left, int mask) {
    // if (depth > 6) {
    //     exit(0);
    // }
    // cout << v << ' ' << depth << ' ' << left << endl;
    if (depth > max_bit) {
        if (left == 0) {
            return 0;
        }
        v = new_v++;
        ans[v].first = 1;
        --left;
        int left_l = left >> 1;
        int left_r = left - left_l;
        int l = Solve(2 * v, depth + 1, max_bit, left_l, mask);
        int r = Solve(2 * v + 1, depth + 1, max_bit, left_r, mask);
        ans[v].second = {l, r};
        return v;
    }
    int color = 1 + !!(mask & (1 << depth));
    ans[v].first = color;

    int left_l = left >> 1;
    int left_r = left - left_l;
    int l = Solve(2 * v, depth + 1, max_bit, left_l, mask);
    int r = Solve(2 * v + 1, depth + 1, max_bit, left_r, mask);
    ans[v].second = {l, r};
    return v;
}

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    // freopen("dome.in", "r", stdin);
    // freopen("dome.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    
    int n, m;
    cin >> n >> m;

    int mask = 0;
    int max_bit = -1;
    for (int i = 0; i < 20; ++i) {
        if (m & (1 << i)) {
            mask |= 1 << i;
            max_bit = i;
        }
    }
    int left = n;
    if (max_bit != -1) {
        left -= (1 << (max_bit + 1)) - 1;
        left += mask;
        if (left < 0) {
            return cout << -1 << endl, 0;
        }
    }
    new_v = 1 << (max_bit + 1);
    Solve(1, 0, max_bit, left, mask);

    for (int i = 1; i <= n + m; ++i) {
        cout << ans[i].first << ' ' << ans[i].second.first << ' ' << ans[i].second.second << '\n';
    }
    // for (int i = 1; i < 20; ++i) {
    //     int cnt = (1 << i) - 1;
    //     if (cnt >= n + m) {
    //         if (cnt == n + m) {
    //             break;
    //         }
    //     }
    // }
}