#include <bits/stdc++.h>

using namespace std;

const int maxn = 200500;

using ll = long long;

int l[maxn];
int r[maxn];
int k[maxn];
int mx[maxn];
int mn[maxn];
vector<pair<int, int>> t;

void dfs(int v) {
    if (v == 0) return;
    dfs(l[v]);
    dfs(r[v]);
    mx[v] = k[v];
    mn[v] = k[v];
    if (l[v] != 0) {
        mx[v] = max(mx[v], mx[l[v]]);
        mn[v] = min(mn[v], mn[l[v]]);
    }
    if (r[v] != 0) {
        mx[v] = max(mx[v], mx[r[v]]);
        mn[v] = min(mn[v], mn[r[v]]);
    }
    t.emplace_back(mn[v], mx[v]);
}

struct query {
    int l;
    int b;
    int add;
    int index;
    bool operator < (const query& q) const {
        return l < q.l;
    }
};

int get(int x, const vector<int>& v) {
    return lower_bound(v.begin(), v.end(), x) - v.begin();
}

void add_fw(vector<int>& fw, int x) {
    for (; x < fw.size(); x |= x + 1) {
        fw[x]++;
    }
}

int get_fw(vector<int>& fw, int x) {
    int ret = 0;
    for (; x>= 0; x = (x & (x + 1)) - 1) {
        ret += fw[x];
    }
    return ret;
}

int main() {
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);


    int n;
    cin >> n;
    vector<int> vv;
    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i] >> k[i];
        vv.push_back(l[i]);
        vv.push_back(r[i]);
    }

    int q;
    cin >> q;
    vector<query> qu;
    vector<int> answer(q);
    for (int qq = 0; qq < q; ++qq) {
        int L, R;
        cin >> L >> R;
        qu.push_back({L - 1, L, +1, qq});
        qu.push_back({R, R + 1, +1, qq});
        qu.push_back({L - 1, R + 1, -1, qq});

        vv.push_back(L - 1);
        vv.push_back(L);
        vv.push_back(R + 1);
        vv.push_back(R);
//        int res = 0;
//        for (int i = 1; i <= n; ++i) {
//            int l = mn[i];
//            int r = mx[i];
//            if (l < L && r > R) {
//                res++;
//            }
//            if (l < L && L <= r && r <= R) {
//                res++;
//            }
//            if (L <= l && l <= R && r > R) {
//                res++;
//            }
//        }
//        cout << 2 * res + 1 << '\n';
    }

    dfs(1);

    sort(vv.begin(), vv.end());
    vv.erase(unique(vv.begin(), vv.end()), vv.end());

    vector<int> fw(vv.size());

    sort(qu.begin(), qu.end());
    sort(t.begin(), t.end());
    int ptr = 0;
    for (const auto& z : qu) {
        int L = z.l;
        int x = z.b;
        int add = z.add;
        int index = z.index;
        while (ptr < t.size() && t[ptr].first <= L) {
//            int l = t[ptr].first;
            int r = t[ptr].second;
            add_fw(fw, get(r, vv));
            ptr++;
        }
        answer[index] += add * (ptr - get_fw(fw, get(x, vv) - 1));
    }

    for (int x : answer) {
        cout << 2 * x + 1 << '\n';
    }


    return 0;
}
