#include<bits/stdc++.h>

using namespace std;

struct arc_s
{
    int b;
    int v;

    arc_s(int b_, int v_)
    {
        b = b_;
        v = v_;
    }
    arc_s()
    {
        b = 0;
        v = 0;
    }
};

vector<arc_s> arc[1100000];
int depth[1100000];

int rootpath[21];
int subtree[21];

int n;
int k;
bool vis[1100000];
bool oarc[21][21];
int par[21];

int odfs(int v)
{
    int bm = 1 << (v-1);
    for (int i=1; i<=n; i++)
    {
        if (oarc[v][i])
            bm |= odfs(i);
    }
    return bm;
}

int c_dfs(int v)
{
    if (vis[v])
        return 0;
    vis[v] = true;
    //cout << "c dfs: " << v << " " << bitset<32>(v) << endl;

    for (int i = 2; i<=n; i++)
    {
        //cout << i << ": " << ((v & rootpath[i]) == rootpath[i]) << " " << ((v & (1 << (i-1))) == 0) << " " << (v & (1 << (i-1))) << endl;
        if (((v & rootpath[i]) == rootpath[i]) && ((v & (1 << (i-1))) == 0))
        {
            //cout << "lala" << endl;
            arc[v].push_back(arc_s(v | (1<<(i-1)), i));
            arc[v | (1<<(i-1))].push_back(arc_s(v, i));
            c_dfs(v | (1<<(i-1)));
        }
    }
    return 0;
}

vector<int> res;
bool onstack[1100000];
/*
int d_dfs(int v)
{
    if (vis[v])
        return depth[v];
    vis[v] = true;
    onstack[v] = true;

    depth[v] = 0;
    for (auto u : arc[v])
    {
        if (!onstack[u.b])
            depth[v] = max(depth[v], d_dfs(u.b)+1);
    }
    onstack[v] = false;
    return depth[v];
}*/

int d_dfs(int v)
{
    if (onstack[v])
        return 0;
    onstack[v] = true;

    depth[v] = 0;
    for (auto u : arc[v])
    {
        depth[v] = max(depth[v], d_dfs(u.b)+1);
    }
    onstack[v] = false;
    return depth[v];
}

int w_dfs(int v)
{
    if (vis[v])
        return 0;
    vis[v] = true;

    arc_s w;
    int md = 0;
    for (auto u : arc[v])
    {
        if (!vis[u.b])
        {
            if (depth[u.b] > md)
            {
                w=u;
                md = depth[u.b];
            }
        }
    }

    if (w.b!=0)
    {
        res.push_back(w.v);
        w_dfs(w.b);
    }
    return 0;
}

int main()
{
    cin >> n;
    int i;
    int p;
    par[1] = 0;
    memset(oarc, false, sizeof(oarc));
    for (i=2; i<=n; i++)
    {
        cin >> p;
        par[i] = p;
        oarc[p][i]=true;
    }

    int bm = 0;
    int v;
    for (int i = 2; i<=n; i++)
    {
        bm = 0;
        int v = par[i];
        while (v != 0)
        {
            bm |= 1 << (v-1);
            v = par[v];
        }
        rootpath[i] = bm;
    }

    //cout << "rootpaths: " << endl;
    //for (i=2; i<=n; i++)
    //{
    //    cout << i << ' ' << bitset<32>(rootpath[i]) << endl;
    //}

    for (int i=2; i<=n; i++)
    {
        subtree[i] = odfs(i) & (~1u << (i-1));
    }
    memset(vis, false, sizeof(vis));
    c_dfs(1);
    memset(vis, false, sizeof(vis));
    memset(depth, false, sizeof(depth));
    memset(onstack, false, sizeof(onstack));
    d_dfs(1);
    memset(vis, false, sizeof(vis));
    w_dfs(1);


    cout << res.size() << endl;
    for (i=0; i<res.size();i++)
    {
        cout << res[i] << " ";
    }
    cout << endl;
}
