#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp> // Общий файл.
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

ll BinPow(ll a, ll b, ll mod) {
    ll result = 1;

    while (b) {
        if (b & 1) {
            result *= a;
            result %= mod;
        }

        a *= a;
        a %= mod;
        b >>= 1;
    }

    return result;
}

ll MulMod(ll a, ll b, ll mod) {
    ll result = 0;

    while (b) {
        if (b & 1) {
            result += a;
            result %= mod;
        }

        a *= 2;
        a %= mod;
        b >>= 1;
    }

    return result;
}

ll RevElement(ll a, ll mod) {
    return BinPow(a, mod - 2, mod);
}

ll calc(ll x, ll y) {
    return -x * y;
}

ll nextInt() {
    char c = getchar();
    ll res = 0;

    do {
        res *= 10;
        res += c - '0';
        c = getchar();
    } while (c >= '0' && c <= '9');

    return res;
}

const int INF = 1e9;

void Solve() {
    int n;
    cin >> n;

    int min_cost = 999999999, ind = 0;
    string s;
    vector<int> cnt;

    for (int i = 1; i <= n; ++i) {
        int cost;
        cnt.assign(10, 0);

        cin >> cost >> s;

        for (auto &c : s) {
            cnt[c - '0']++;
        }

        if (cnt[0] > 0 && cnt[1] > 0 && cnt[2] > 1 && cost < min_cost) {
            min_cost = cost;
            ind = i;
        }
    }

    cout << ind;
}

int main() {
    //    freopen("flow.in", "r", stdin);
    //    freopen("flow.out", "w", stdout);
    //freopen("../in", "r", stdin);
    //freopen("../out.txt", "w", stdout);
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    Solve();
    return 0;
}