#include <iostream>

struct Pack {
	int cost;
	int zero;
	int one;
	int two;

	bool works;
};

int n;
Pack pack[1000];

char digits[201];

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;

	for (int i = 0; i < n; i++) {
		std::cin >> pack[i].cost;
		std::cin >> std::ws;
		std::cin.getline(digits, 201);

		pack[i].zero = 0;
		pack[i].one = 0;
		pack[i].two = 0;
		pack[i].works = false;

		for (int j = 0; digits[j]; j++) {
			if (digits[j] == '0') {
				pack[i].zero++;
			} else if (digits[j] == '1') {
				pack[i].one++;
			} else if (digits[j] == '2') {
				pack[i].two++;
			}
		}
		if (pack[i].two >= 2 && pack[i].one >= 1 && pack[i].zero >= 1) {
			pack[i].works = true;
		}
	}

	int best = -1;
	int bestCost = 1000000000;

	for (int i = 0; i < n; i++) {
		Pack &p = pack[i];

		if (p.works) {
			if (p.cost < bestCost) {
				best = i;
				bestCost = p.cost;
			}
		}
	}

	std::cout << best + 1 << std::endl;

	return 0;
}
