#include "bits/stdc++.h"
//#include<ext/pb_ds/assoc_container.hpp>
//#include <random>

using namespace std;
//using namespace __gnu_pbds;

template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
    os << '{';
    string sep;
    for (const auto& x : v) os << sep << x, sep = ", ";
    return os << '}';
}

template <typename T, size_t size>
ostream& operator<<(ostream& os, const array<T, size>& arr) {
    os << '{';
    string sep;
    for (const auto& x : arr) os << sep << x, sep = ", ";
    return os << '}';
}

template <typename A, typename B>
ostream& operator<<(ostream& os, const pair<A, B>& p) { return os << '(' << p.first << ", " << p.second << ')'; }


#define all(x) x.begin(), x.end()
#define bits(x) __builtin_popcount(x)
#define int ll
#define sz(x) int((x).size())

typedef long long ll;
typedef long double ld;
typedef __float128 lld;
//typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> dd;

/*void random() {
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
}*/

template <class FR>
inline FR max(FR& a, const FR& b) {
    return (a > b) ? a : b;
}

template <class FR>
inline FR min(FR& a, const FR& b) {
    return (a > b) ? b : a;
}

const int MAXN = (int) 1e6 + 10;
const int MOD = (int) 1e9 + 7;
const int INF = 1e13 + 1;



int32_t main() {
//    freopen("unionday.in", "r", stdin), freopen("unionday.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int,pair<int,string>>> a;
    for (int i = 0; i < n; ++i) {
        int p;
        cin >> p;
        string s;
        cin >> s;
        a.push_back({p, {i + 1, s}});
    }
    sort(all(a));
    for (int i = 0; i < n; ++i) {
        vector<int> cnt(10);
        for (int j = 0; j < sz(a[i].second.second); ++j) {
            cnt[a[i].second.second[j] - '0'] += 1;
        }
        if (cnt[0] >= 1 && cnt[1] >= 1 && cnt[2] >= 2) {
            return cout << a[i].second.first << '\n', 0;
        }
    }
    cout << 0 << '\n';
    return 0;
}

