#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE
#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<string>
#include<cstring>
#include<algorithm>
#include<cmath>
#include <set>
#include <queue>
#include <map>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>

using namespace std;
struct node {
    int value;
    int lc;
    int rc;
    int childs;
    int vmax;
    int vmin;
    node(int v, int l, int r, int c = 0)
    {
        value = v, lc = l, rc = r, childs = 0;
        vmax = -1e+9 - 7;
        vmin = 1e+9 + 7;
    }
};

vector <node> tree;
int a;


int count_clilds(int v)
{
    if (tree[v].lc == 0 && tree[v].rc == 0)
    {
        tree[v].childs = 0;
        tree[v].vmax = tree[v].value;
        tree[v].vmin = tree[v].value;
        return 1;
    }
    int an = 0;
    if (tree[v].lc)
        an = count_clilds(tree[v].lc);
    if (tree[v].rc)
        an += count_clilds(tree[v].rc);
    tree[v].vmax = max(tree[tree[v].rc].vmax, tree[v].value);
    tree[v].vmin = min(tree[tree[v].lc].vmin, tree[v].value);
    tree[v].childs = an;
    return an + 1;
}

int count_lookups2(int v, int lb, int rb)
{
    int ans = 0;
    if (lb <= tree[v].vmin && tree[v].vmax <= rb)
        return 0;
    if (tree[v].vmax < lb || rb < tree[v].vmin)
        return 0;

    ans += count_lookups2(tree[v].lc, lb, rb);
    ans += count_lookups2(tree[v].rc, lb, rb);
    return ans += 2;
}
int main()
{
    //freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    node asd(0, 0, 0);
    tree.reserve(205000);
    tree.push_back(asd);

    scanf("%d", &a);
    for (int i = 0; i < a; ++i)
    {
        int tml, tmr, tmv;
        scanf("%d%d%d", &tml, &tmr, &tmv);
        node tmp(tmv, tml, tmr);
        tree.push_back(tmp);
    }
    count_clilds(1);
    int n_tests;
    scanf("%d", &n_tests);
    for (int i = 0; i < n_tests; ++i)
    {
        int tlb, trb;
        scanf("%d%d", &tlb, &trb);
        int result = count_lookups2(1, tlb, trb) + 1;
        printf("%d\n", result);
    }
    return 0;
}