﻿#include <iostream>
#include <vector>
#include <map>
using namespace std;

bool check(int a, int dis) {
	int k = 8;
	while(a>0) {
		k -= a & 1;
		a >>= 1;
	}
	return  dis <= k;
}

int main() {
	int N; cin >> N;
	int* M = new int[N];
	string buf;

	for (int i = 0; i < N; i++) {
		cin >> buf;
		M[i] = 0;
		for (int j = 0; j < 8; j++) M[i] += ((buf[7 - j] == 'R') << j);
	}

	int cur;
	bool win;
	bool exit;
	for (int i = 0; i < N; i++) {
		cur = 0;
		win = true;
		exit = true;
		while (exit) {
			exit = false;
			for (int j = i; j != cur; j--) {
				if (check(M[cur] ^ M[j], j - cur)) {
					cur = j;
					exit = true;
					win = !win;
					break;
				}
			}
		}
		cout << win+1;
	}
}