#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

const int MOD = (int) 1e9 + 7;
const int P = 239;

int last[30], value[30], revvalue[15];
bool used[30];
int answer[300005];
string dict[300005];
map <int, vector <int> > opa;

int build_hash(const string &s)
{
 	for (int i = 0; i < 26; i++) last[i] = 0;
 	int n = (int) s.length();
 	int hs = 0;
 	for (int i = 1; i <= n; i++)
 	{
 	 	int d = i - last[s[i - 1] - 'A'];
 	 	hs = ((ll) hs * (ll) P + (ll) d) % (ll) MOD;
 	 	last[s[i - 1] - 'A'] = i;
 	}
 	return hs;
}

int main()
{
 	//freopen("input.txt", "r", stdin);
 	//freopen("output.txt", "w", stdout);
 	ios_base::sync_with_stdio(0); cin.tie(0);
 	
 	string s, t;
 	cin >> s >> t;
 	for (char c : s) used[c - 'A'] = true;
 	for (char c : t) used[c - 'A'] = true;
 	int kol = 0;
 	for (int i = 0; i < 26; i++) kol += used[i];
 	if (kol > 10) cout << "0\n", exit(0);

 	int n;
 	cin >> n;
 	for (int i = 1; i <= n; i++)
 	{
 		cin >> dict[i];
 		int haha = build_hash(dict[i]);
 		opa[haha].pb(i);
 	}

   	vector <int> perm(10), last(10);
   	for (int i = 0; i < 10; i++) perm[i] = i;
   	last = perm;

   	do
   	{
   		if (perm != last)
   		{
   		 	bool fl = false;
   		 	for (int i = 0; i < kol; i++) if (perm[i] != last[i]) fl = true;
   		 	if (!fl) continue;
		}
		for (int i = 0; i < 26; i++) value[i] = -1;
		for (int i = 0; i < 10; i++) revvalue[i] = -1;

		int sch = 0;
		for (int i = 0; i < 26; i++)
			if (used[i])
			{
			 	value[i] = perm[sch];
			 	revvalue[perm[sch]] = i;
			 	sch++;
			}
		if (value[s[0] - 'A'] != 0 && value[t[0] - 'A'] != 0)
		{
    		ll num1 = 0, num2 = 0;
    		for (char c : s) num1 = num1 * 10 + value[c - 'A'];
    		for (char c : t) num2 = num2 * 10 + value[c - 'A'];
    		ll res = num1 + num2;
    		string R = to_string(res);

    		string st = "";
    		for (int i = 0; i < (int) R.length(); i++) st += (char) (R[i] - '0' + 'A');
    		int hrhr = build_hash(st);

    		if (opa.find(hrhr) != opa.end())
    		{
    			vector <int> potent = opa[hrhr];
    			for (int i = 0; i < (int) potent.size(); i++)
    			{
    			 	int num = potent[i];
    			 	bool fl = true;
    			 	for (int j = 0; answer[num] < 2 && fl && j < dict[num].length(); j++)
    			 	{
    			 	 	int dig = R[j] - '0';
    			 	 	if (revvalue[dig] != -1) fl = fl && (dict[num][j] - 'A' == revvalue[dig]);
    			 	 	else fl = fl && (value[dict[num][j] - 'A'] == -1);
    			 	}
    			 	if (fl) answer[num]++;
    			}
    		}
   		}	
		
		last = perm;
   	} while (next_permutation(perm.begin(), perm.end()));

   	int ans = 0;
   	for (int i = 1; i <= n; i++) ans += (answer[i] == 1);
   	cout << ans << '\n';
   	for (int i = 1; i <= n; i++)
   		if (answer[i] == 1) cout << dict[i] << '\n';

 	return 0;
}
