#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	vector<pair<int, string>> arr(n);

	for (auto &it : arr)
		cin >> it.first >> it.second;

	int ans = -1;

	for (int i = 0; i < arr.size(); i++)
		if ((ans == -1 || arr[i].first < arr[ans].first) &&
		    arr[i].second.find('0') != string::npos &&
		    arr[i].second.find('1') != string::npos &&
		    count(arr[i].second.begin(), arr[i].second.end(), '2') >= 2)
			ans = i;

	cout << ans + 1 << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
