#include <bits/stdc++.h>

using namespace std;

typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;

const int inf = 1e9;
const ll inf64 = 1e18;

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> p(n + 1);
    vector<vector<int>> cnt(n + 1, vector<int>(10));

    int res = inf, best = 0;

    for (int i = 0; i < n; i++) {
        cin >> p[i];
        string s;
        cin >> s;
        for (char c : s) {
            cnt[i][c - '0']++;
        }
        if (cnt[i][2] >= 2 && cnt[i][1] >= 1 && cnt[i][0] >= 1) {
            if (res > p[i]) {
                res = p[i];
                best = i + 1;
            }
        }
    }

    cout << best << "\n";

    return 0;
}
