#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <random>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

struct state {
	int v;
};

vector<vector<int>> g;
vector<vector<state>> st;
vector<bool> flag;

void rec(int v, vector<vector<state>>& now, int pos) {
	if (pos == 0) {
		if (!flag[pos]) {
			for (int j = 1; j < len(now[0]); j++) {
				st[v].pb(now[pos][j]);
			}
		}
		else {
			for (int j = len(now[0]) - 2; j >= 0; j--) {
				st[v].pb(now[pos][j + 1]);
			}
		}
		flag[pos] = !flag[pos];
		return;
	}
	rec(v, now, pos - 1);
	if (!flag[pos]) {
		for (int j = 1; j < len(now[pos]); j++) {
			st[v].pb(now[pos][j]);
			rec(v, now, pos - 1);
		}
	}
	else {
		for (int j = len(now[pos]) - 2; j >= 0; j--) {
			st[v].pb(now[pos][j + 1]);
			rec(v, now, pos - 1);
		}
	}
	flag[pos] = !flag[pos];
}

void calc(int v, int p = -1) {
	vector<vector<state>> now;
	for (auto x : g[v]) {
		if (x == p) 
			continue;
		calc(x, v);
		now.pb(st[x]);
	}
	st[v].pb({-1});
	st[v].pb({v});
	flag = vector<bool> (len(now) + 1, 0);
	if (len(now) != 0) {
		rec(v, now, len(now) - 1);
	}
	// cout << v << " " << len(st[v]) << endl;
}

signed main() {
	#ifdef PC
		freopen("in.txt", "r", stdin);
		freopen("out.txt", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);	

	int n;
	cin >> n;
	g = vector<vector<int>> (n);
	st = vector<vector<state>> (n);
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		g[i].pb(p);
		g[p].pb(i);
	}
	calc(0);
	vector<int> ans;
	for (int j = 2; j < len(st[0]); j++) {
		if (st[0][j].v == -1) 
			continue;
		ans.pb(st[0][j].v);
	}
	cout << len(ans) << '\n';
	for (auto x : ans) {
		cout << x + 1 << " ";
	}
}