#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <random>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()
// #define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

const int m = 8;

int common(vector<int>& a, vector<int>& b) {
	int ans = 0;
	for (int i = 0; i < m; i++) 
		ans += (a[i] == b[i]);
	return ans;
}

signed main() {
	#ifdef PC
		freopen("in.txt", "r", stdin);
		freopen("out.txt", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);	

	int n;
	cin >> n;
	vector<vector<int>> mat(n, vector<int> (m, 0));

	
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c;
			cin >> c;
			if (c == 'W') 
				mat[i][j] = 1;
			else 
				mat[i][j] = 0;
		}
	}

	vector<bool> dp((1 << m), 0);
	for (int msk = 0; msk < (1 << m); msk++) {
		dp[msk] = (msk & 1);
	}
	cout << 2;
	for (int i = 1; i < n; i++) {
		vector<bool> poss(9, 0);
		vector<bool> dpn((1 << m), 0);
		for (int j = i - 1; j >= max(0, i - 8); j--) {
			if ((i - j) <= common(mat[i], mat[j])) 
				poss[i - j] = 1;
		}
		for (int msk = 0; msk < (1 << m); msk++) {
			int mskn = msk >> 1;
			int cur = msk & 1;
			// cout << i << " " << msk << " " << mskn << endl;
			for (int j = 1; j <= 8; j++) {
				if (!poss[j]) 
					continue;
				if (cur == 0) 
					mskn |= (1 << (j - 1));
			}
			// cout << i << " " << msk << " " << mskn << endl;
			dpn[msk] = dp[mskn];
		}
		dp = dpn;
		if (dp[0] == 0) 
			cout << 2;
		else
			cout << 1;
	}

	// for (int st = 0; st < n; st++) {
	// 	// vector<int> dp(st + 1, 0);
	// 	// for (int i = st; i >= 0; i--) {
	// 	// 	for (int j = i + 1; j <= min(st, i + 8); j++) {
	// 	// 		if (dp[j] == 0 && (j - i) <= common(mat[i], mat[j]))
	// 	// 			dp[i] = 1;
	// 	// 	}
	// 	// }
	// 	if (dp[st][0] == 0) 
	// 		cout << 2;
	// 	else
	// 		cout << 1;
	// }
	// for (int i = 0; i < n; i++) {
	// 	if (dp[i] == 0) 
	// 		cout << 2;
	// 	else
	// 		cout << 1;
	// }
}