#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<ll> vll;

#define printvi(arr) for (int x : arr) cout << x << ' '; cout << '\n';
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)

const int maxn = 1e5 + 1;

int main() {
    int n;
    cin >> n;
    vi last(maxn);
    vi dp(n + 1);
    for (int i = 1; i <= n; ++i) {
        int m;
        cin >> m;
        forn(j, m) {
            int k;
            cin >> k;
            dp[i] = max(dp[i], dp[last[k]] + 1);
            last[k] = i;
        }
    }
    cout << *max_element(dp.begin(), dp.end()) << '\n';
}
