
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int mod = 1e9 + 7;

ll binpow(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            (res *= a) %= mod;
        }
        p >>= 1;
        (a *= a) %= mod;
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    int best = 1e9;
    int ind = 0;
    for (int i = 1; i <= n; i++) {
        int p;
        string s;
        cin >> p >> s;
        int mask = 0;
        vector<int> cnt(26);
        for (char c : s) {
            cnt[c - '0']++;
        }
        if (cnt[2] >= 2 && cnt[0] && cnt[1] && p < best) {
            best = p;
            ind = i;
        }
    }
    cout << ind << '\n';
    
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case " << tc << ": ";
        solve();
    }
    return 0;
}