#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <complex>
#include <bitset>
#include <vector>
#include <cstdio>
#include <random>
#include <chrono>
#include <queue>
#include <cmath>
#include <list>
#include <set>
#include <map>
using namespace std;
typedef pair<int, int> pii;
typedef pair<int, pii> pip;
typedef pair<long long, int> pli;
typedef pair<long long, long long> pll;
typedef pair<long double, long double> pdd;
typedef complex<double> base;
const int N = 100010;
const int mod = 1000000007;
const long double eps = 1e-9;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());


long long gcd (long long a, long long b, long long & x, long long & y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    }
    long long x1, y1;
    long long d = gcd (b%a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

void solve() {
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        int b, d;
        scanf("%d%d", &b, &d);
        long long x0, y0;
        long long g = gcd(d, b, x0, y0);
        if (b * 1ll * b % g != 0) {
            puts("0");
            continue;
        }
        x0 *= b * 1ll * b / g;
        y0 *= b * 1ll * b / g;
        printf("%lld\n", x0 / (b / g) + y0 / (d / g) - 1);
    }
}


int main() {
#ifdef HAMLET
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
