#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e5 + 7;

bool used[N];
int dp[N];
vector <int> f[N];
vector <int> g[N], rg[N];
vector <int> ord;

int ans = 0;

void dfs(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) dfs(to);
    }
    ord.push_back(v);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            f[x].push_back(i);
        }
    }
    for (int i = 0; i < N; i++) {
        for (int j = 0; j + 1 < f[i].size(); j++) {
            g[f[i][j]].push_back(f[i][j + 1]);
            rg[f[i][j + 1]].push_back(f[i][j]);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    for (int i = 0; i < n; i++) {
        int v = ord[i];
        dp[v] = 1;
        for (auto to : g[v]) {
            dp[v] = max(dp[v], dp[to] + 1);
        }
    }
    for (int i = 0; i < n; i++) {
        ans = max(ans, dp[i]);
    }
    cout << ans << endl;
    return 0;
}
