import com.sun.deploy.util.StringUtils;

import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

public class K {
    public static void main(String[] args) {

        Scanner scan = new Scanner(System.in);

        PriorityQueue<Pack> packs = new PriorityQueue<>(new Comparator<Pack>() {
            @Override
            public int compare(Pack o1, Pack o2) {
                return o1.price-o2.price;
            }
        });
        int t=0;
        String str="";
        int n=scan.nextInt();
        for(int i=0; i<n; i++){
            t=scan.nextInt();
            str=scan.next();
            if(IsFine(str)){
                packs.add(new Pack(i+1, t, str));
            }
        }

        if(packs.isEmpty()){
            System.out.println(0);
        }
        else{
            System.out.println(packs.poll().num);
        }

    }

    static class Pack{
        int num;
        int price;
        String s;

        Pack(int num, int price, String s){
            this.num=num;
            this.price=price;
            this.s=s;
        }

    }

    public static boolean IsFine(String s){
        int count1=s.length() - s.replaceAll("1","").length();
        int count2=s.length() - s.replaceAll("2","").length();
        int count0=s.length() - s.replaceAll("0","").length();

        if(count1>=1 && count0>=1 && count2>=2){
            return true;
        }
        return false;
    }
}
