import java.math.BigInteger;
import java.util.List;
import java.util.Scanner;

public class SquareDivisor {

    public static Scanner in= new Scanner(System.in);

    static BigInteger func(long a, long b, long c, long i) {
        return BigInteger.valueOf(a*i*i+b*i+c);
    }
    public static BigInteger bigIntSqRootFloor(BigInteger x)
            throws IllegalArgumentException {
        if (x.compareTo(BigInteger.ZERO) < 0) {
            throw new IllegalArgumentException("Negative argument.");
        }
        // square roots of 0 and 1 are trivial and
        // y == 0 will cause a divide-by-zero exception
        if (x .equals(BigInteger.ZERO) || x.equals(BigInteger.ONE)) {
            return x;
        } // end if
        BigInteger two = BigInteger.valueOf(2L);
        BigInteger y;
        // starting with y = x / 2 avoids magnitude issues with x squared
        for (y = x.divide(two);
             y.compareTo(x.divide(y)) > 0;
             y = ((x.divide(y)).add(y)).divide(two));
        return y;
    } // end bigIntSqRootFloor

    public static void main(String[] args) {

        long a =in.nextLong();
        long b =in.nextLong();
        long c =in.nextLong();
        long n =in.nextLong();

        BigInteger result = BigInteger.ONE;

        for (int i=0;i<n;i++){
            result = result.multiply(func(a,b,c,i));
        }
        BigInteger sqrt = bigIntSqRootFloor(result);

        sqrt = sqrt.add(sqrt);

        BigInteger remainderRes = BigInteger.ONE;

        for(long i=1;i<sqrt.longValue();i++){
            BigInteger temp1 = BigInteger.valueOf(i).multiply(BigInteger.valueOf(i));
            BigInteger[] remainder = result.divideAndRemainder(temp1);
            if(remainder[1].compareTo(BigInteger.ZERO)==0) {
                remainderRes=temp1;
            }
        }
        //BigInteger temp = remainderRes.multiply(remainderRes);
        //System.out.println(temp);
        BigInteger[] res=remainderRes.divideAndRemainder(BigInteger.valueOf((long)1000000007));
        System.out.println(res[1]);

    }

}