#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>
//#include <assert.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-12;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}

void solve() {
	ll b, d;
	cin >> b >> d;
	ll g = lcm(b, d);
	
	ll x = g / b;
	ll y = g / d;
	ll z = b * y;
	
	ll max_c = z / y - x;
	ll min_c = (z / y) % x;
	if (min_c == 0)
		min_c += x;
	
	cout << (max_c - min_c) / x + 1 << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}