#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>
//#include <assert.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-12;

void solve() {
	int n;
	cin >> n;
	int min_p = inf, min_id = 0;
	for (int i = 0; i < n; ++i) {
		int p;
		string s;
		cin >> p >> s;
		
		int cnt0 = 1;
		int cnt1 = 1;
		int cnt2 = 2;
		for (char c : s) {
			cnt0 -= (c == '0');
			cnt1 -= (c == '1');
			cnt2 -= (c == '2');
		}
		
		if (cnt0 <= 0 && cnt1 <= 0 && cnt2 <= 0 && p < min_p) {
			min_p = p;
			min_id = i + 1;
		}
	}
	
	cout << min_id << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}