#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>
//#include <assert.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-12;

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> a(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; ++j)
			cin >> a[i][j];
	}
	
	vector<int> last_num(100010, 0);
	for (int i = n - 1; i >= 0; --i) {
		int max_num = 0;
		for (int j = 0; j < a[i].size(); ++j)
			max_num = max(max_num, last_num[a[i][j]]);
		for (int j = 0; j < a[i].size(); ++j)
			last_num[a[i][j]] = max_num + 1;
	}
	
	cout << *max_element(last_num.begin(), last_num.end()) << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}