#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <random>

#define ll long long
#define ld long double
#define INF 10e+9

using namespace std;

int main() {
    cin.tie(nullptr);
    std::istream::sync_with_stdio(false);

    ll a, b;
    cin >> a >> b;

    ll p = a + b;

    ll step = 1;
    for (step = 1; step <= p; step *= 2);

    ll stepB = 1;
    for (stepB = 1; stepB <= b; stepB *= 2);

    if (stepB-1 > p) {
        cout << "-1";
        return 0;
    }

    vector<pair<ll, ll>> v = vector<pair<ll, ll>>(step);
    vector<ll> massV = vector<ll>(step*2, 0);
    for (ll i = 1; i < step; i++) {
        if (i == 1) v[i] = pair<ll, ll>(2, 3);
        else {
            ll ii = i - i % 2;
            ll ii1 = i + ii;
            ll ii2 = i + ii*2;
            v[i] = pair<ll, ll>(i + ii, i + 2 * ii);
        }
    }

    if (b % 2 == 1){
        for (ll i = 1; i <= b; i++) {
            massV[i] = 2;
        }
    } else {
        massV[1] = 1;
        a--;
        for (ll i = 2; i <= b+1; i++) {
            massV[i] = 2;
        }
    }


    for (ll i = b + 1 + (massV[1] == 1 ? 1 : 0); i < stepB; i++) {
        if(a == 0){
            cout << "-1";
            return 0;
        }
        massV[i] = 1;
        a--;
    }

    for(ll i = p; i >= stepB; i--){
        massV[i] = 1;
    }

    for(int i = 1; i <= p; i++){
        cout << massV[i] << " " << (massV[v[i].first] != 0 ? v[i].first : 0) << " " << (massV[v[i].second] != 0 ? v[i].second : 0) << endl;
    }


        return 0;
}