﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <queue>
#include <cmath>
#include <stack>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<vector<int> > table(n);
    set<int, greater<int> > students;
    for (int i = 0; i < n; i++)
    {
        int k;
        cin >> k;
        int j;
        for (int p = 0; p < k; p++)
        {
            cin >> j;
            table[i].push_back(j);
            students.insert(j);
        }
    }
    vector<int> s(*(students.begin()), 1);
    int ans = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        int mx = 0;
        for (int j = 0; j < table[i].size(); j++)
        {
            mx = max(mx, s[table[i][j] - 1]);
        }
        ans = max(mx, ans);
        for (int j = 0; j < table[i].size(); j++)
        {
            s[table[i][j] - 1] = mx + 1;
        }
    }
    cout << ans;
    return 0;
}