#include <bits/stdc++.h>

using namespace std;

//#define MULTITEST

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sqr(a) ((a) * (a))
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++) 
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &v) {
	out << "[";
	forn(i, sz(v)) {
		if(i) out << ", ";
		out << v[i];
	}
	return out << "]";
}

mt19937 rnd(time(NULL));

const int INF = int(1e9);
const li INF64 = li(1e18);
const int MOD = int(1e9) + 7;
const ld EPS = 1e-9;
const ld PI = acos(-1.0);

const int N = 100 * 1000 + 13;

int a, b;

bool read () {
	if (scanf("%d%d", &a, &b) != 2)
		return false;
	return true;
}

int x[N], l[N], r[N];
int cnt;

bool build(int v, int a, int b){
	if (b > 0) x[v] = 2, --b;
	else x[v] = 1, --a;
	if (b % 2 == 1 && a == 0) return false;
	if (a == 0 && b == 0) return true;
	int la, ra, lb, rb;
	if (a % 2 == 1 && b % 2 == 1){
		ra = a / 2, la = a - a / 2;
		lb = b / 2, rb = b - b / 2;
	}
	else if (a % 2 == 0 && b % 2 == 1){
		ra = a / 2 + 1, la = a / 2 - 1;
		lb = b / 2, rb = b - b / 2;
	}
	else{
		la = a / 2, ra = a - a / 2;
		lb = b / 2, rb = b / 2;
	}
	assert(abs((la + lb * 2) - (ra + rb * 2)) <= 1);
	bool res = true;
	if (la > 0 || lb > 0) l[v] = cnt++, res &= build(cnt - 1, la, lb);
	if (ra > 0 || rb > 0) r[v] = cnt++, res &= build(cnt - 1, ra, rb);
	return res;
}

void solve() {
	memset(l, -1, sizeof(l));
	memset(r, -1, sizeof(r));
	cnt = 1;
	bool res = build(0, a, b);
	if (!res){
		puts("-1");
		return;
	}
	forn(i, cnt){
		printf("%d %d %d\n", x[i], l[i] + 1, r[i] + 1);
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	
	int tt = clock();
	
#endif
	
	cerr.precision(15);
	cout.precision(15);
	cerr << fixed;
	cout << fixed;

#ifdef MULTITEST
	int tc;
	scanf("%d", &tc);
	while(tc--){
		read();
#else
	while(read()) {	
#endif
		solve();
		
#ifdef _DEBUG
	cerr << "TIME = " << clock() - tt << endl;
	tt = clock();
#endif

	}
}