#pragma comment(linker, "/STACK:66777216")

#include <iostream>
#include <map>
#include <vector>
#include <sstream>
#include <set>
#include <unordered_map>
#include <functional>
#include <algorithm>
#include <unordered_set>
#include <numeric>
#include <deque>

using namespace std;

template<typename T> std::string toString(T val){std::ostringstream oss; oss << val; return oss.str();}
template<typename T, typename U> inline ostream &operator<< (ostream &_out, const pair<T, U> &_p) { _out << _p.first << ' ' << _p.second << '\n'; return _out; }
template<typename T, typename U> inline istream &operator>> (istream &_in, pair<T, U> &_p) { _in >> _p.first >> _p.second; return _in; }
template<typename T> inline ostream &operator<< (ostream &_out, const vector<T> &_v) { if (_v.empty()) { return _out; } _out << _v.front() << ' '; for (auto _it = ++_v.begin(); _it != _v.end(); ++_it) { _out << *_it <<' '; } return _out; }
template<typename T> inline istream &operator>> (istream &_in, vector<T> &_v) { for (auto &_i : _v) { _in >> _i; } return _in; }
template<typename T> inline ostream &operator<< (ostream &_out, const set<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const multiset<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const unordered_set<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const unordered_multiset<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T, typename U> inline ostream &operator<< (ostream &_out, const map<T, U> &_m) { if (_m.empty()) { return _out; }for (auto _it:_m) { _out << _it.first << ": " << _it.second << '\n'; } return _out; }

#define pb push_back
//#define int long long
#define X first
#define Y second
#define pog long double
#define all(x) x.begin(),(x).end()


//vector<int> dx = {2, 2, 1, 1, -1, -1, -2, -2};
//vector<int> dy = {1, -1, 2, -2, 2, -2, 1, -1};

struct cord{
    int x, y, z;
};

vector<int> zfun(string s){
    int n = s.size();
    vector<int> z(n,0);
    for(int i = 1, l = 0, r = 0;i < n;i++){
        if(i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while(i + z[i] < n && s[z[i]] == s[i + z[i]])
            z[i]++;
        if(i + z[i] - 1 > r)
            l = i, r = i + z[i] - 1;
    }
    return z;
}

int mod = 1e9 + 7;
long long bin_pow(long long base, long long p) {
    int res = 1;
    while(p){
        if(p & 1)
            res = (res * base) % mod;
        base = (base * base) % mod;
        p /= 2;
    }
    return res;
}

long long inverse_element(long long x) {
    return bin_pow(x, mod - 2);
}

long long divide(long long a, long long b) {
    return a * inverse_element(b) % mod;
}
bool in = false;
int& tests(){
    static int tests;
    if (!in) {
        cin >> tests;
        in = true;
    }
    return tests;
}

void en(int num){
    cout <<  (num == 1 ? "Yes" : "No");
    exit(0);
}
int n = 17;
vector<int > mul(vector<int > &a, vector<int>& b) {
    vector<int> c(n, 0);
    for(int i = 0;i < n; i++) {
        c[i] = b[a[i]];
    }
    return c;
}

vector<int>  bin_pow(vector<int> base, long long p) {
    vector<int> res(n);
    iota(all(res), 0);
    while(p){
        if(p & 1)
            res = mul(res, base);
        base = mul(base, base);
        p /= 2;
    }
    return res;
}
void imp() {
    cout << "Impossible";
    exit(0);
}

void ask(int a) {
    cout << "? " << a << endl;
}

void yes_no(int can) {
    cout << (can ? "YES\n" : "NO\n");
}
#define sqr(x) (x) * (x)
#define int long long

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

//    freopen("../input.txt", "r", stdin);

    string a;
    string b;
    cin >> a >> b;

    int n;
    cin >> n;

    set<char> s;

    for (auto i : a)
        s.insert(i);
    for (auto j : b)
        s.insert(j);

    map<string, pair<vector<int>, int>> v;
    vector<string> ans;
    for (int i = 0; i < n; i++){
        string st;
        cin >> st;
        reverse(all(st));
        string nst = "";
        char z = 'a';
        char arr3[1000] = {0};
        for (auto i : st){
            if (s.find(i) == s.end()) {
                if (arr3[i] == 0) {
                    arr3[i] = z;
                    z++;
                }
                nst += arr3[i];
            }else
                nst += i;
        }
        reverse(all(nst));
        reverse(all(st));
        if (v.find(nst) == v.end())
            v[nst] = {{i}, 0};
        else
            v[nst].first.push_back(i);
        ans.push_back(st);
    }

    if (s.size() > 10) {
        cout << 0;
    } else {
        reverse(all(a));
        reverse(all(b));
        vector<int> id;
        for (int i = 0; i < 10; i++)
            id.push_back(i);
        vector<char> S;
        for (auto i : s) {
            S.push_back(i);
        }

//        string stat_prev = "";

        map<string, bool> was;
        do {
            int arr[1000] = {0};
            char arr2[10] = {0};
            string stat = "";
            for (int i = 0; i < S.size(); i++) {
                arr[S[i]] = id[i];
                stat += (char)(id[i] + '0');
                arr2[id[i]] = S[i];
            }
            if (was[stat])
                continue;
//            if (stat_prev == stat)
//                continue;
//            stat_prev = stat;
            was[stat] = true;

            if (arr[a.back()] == 0 || arr[b.back()] == 0)
                continue;

            int c = 1;
            int A = 0;
            for (auto i : a) {
                A += arr[i] * c;
                c *= 10;
            }
            int B = 0;
            c = 1;
            for (auto i : b) {
                B += arr[i] * c;
                c *= 10;
            }

            int C = A + B;

            string ans = "";
            char z = 'a';
            while (C != 0){
                c = C % 10;
                if (arr2[c] == 0) {
                    arr2[c] = z;
                    z += 1;
                }
                ans += arr2[c];
                C /= 10;
            }

            reverse(all(ans));

            if (v.find(ans) != v.end())
                v[ans].second += 1;
        }while(next_permutation(all(id)));

        set<int> A;
        for (auto & i : v) {
            if (i.second.second == 1)
                for (auto j : i.second.first) {
                    A.insert(j);
                }
        }

        cout << A.size() << "\n";
        for (auto & i : A)
            cout << ans[i] << "\n";
    }

//    SEND MORE 3 FUN HONEY MONEY

    return 0;
}