#include<bits/stdc++.h>

using namespace std;

template<typename T> std::string toString(T val){std::ostringstream oss; oss << val; return oss.str();}
template<typename T, typename U> inline ostream &operator<< (ostream &_out, const pair<T, U> &_p) { _out << _p.first << ' ' << _p.second << '\n'; return _out; }
template<typename T, typename U> inline istream &operator>> (istream &_in, pair<T, U> &_p) { _in >> _p.first >> _p.second; return _in; }
template<typename T> inline ostream &operator<< (ostream &_out, const vector<T> &_v) { if (_v.empty()) { return _out; } _out << _v.front() << ' '; for (auto _it = ++_v.begin(); _it != _v.end(); ++_it) { _out << *_it <<' '; } return _out; }
template<typename T> inline istream &operator>> (istream &_in, vector<T> &_v) { for (auto &_i : _v) { _in >> _i; } return _in; }
template<typename T> inline ostream &operator<< (ostream &_out, const set<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const multiset<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const unordered_set<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const unordered_multiset<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T, typename U> inline ostream &operator<< (ostream &_out, const map<T, U> &_m) { if (_m.empty()) { return _out; }for (auto _it:_m) { _out << _it.first << ": " << _it.second << '\n'; } return _out; }

#define pb push_back
//#define int long long
#define X first
#define Y second
#define pog long double
#define all(x) x.begin(),(x).end()


//vector<int> dx = {2, 2, 1, 1, -1, -1, -2, -2};
//vector<int> dy = {1, -1, 2, -2, 2, -2, 1, -1};

struct cord{
    int x, y, z;
};

vector<int> zfun(string s){
    int n = s.size();
    vector<int> z(n,0);
    for(int i = 1, l = 0, r = 0;i < n;i++){
        if(i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while(i + z[i] < n && s[z[i]] == s[i + z[i]])
            z[i]++;
        if(i + z[i] - 1 > r)
            l = i, r = i + z[i] - 1;
    }
    return z;
}

int mod = 1e9 + 7;
long long bin_pow(long long base, long long p) {
    int res = 1;
    while(p){
        if(p & 1)
            res = (res * base) % mod;
        base = (base * base) % mod;
        p /= 2;
    }
    return res;
}

long long inverse_element(long long x) {
    return bin_pow(x, mod - 2);
}

long long divide(long long a, long long b) {
    return a * inverse_element(b) % mod;
}
bool in = false;
int& tests(){
    static int tests;
    if (!in) {
        cin >> tests;
        in = true;
    }
    return tests;
}

void en(int num){
    cout <<  (num == 1 ? "Yes" : "No");
    exit(0);
}
int n = 17;
vector<int > mul(vector<int > &a, vector<int>& b) {
    vector<int> c(n, 0);
    for(int i = 0;i < n; i++) {
        c[i] = b[a[i]];
    }
    return c;
}

vector<int>  bin_pow(vector<int> base, long long p) {
    vector<int> res(n);
    iota(all(res), 0);
    while(p){
        if(p & 1)
            res = mul(res, base);
        base = mul(base, base);
        p /= 2;
    }
    return res;
}
void imp() {
    cout << "Impossible";
    exit(0);
}

void ask(int a) {
    cout << "? " << a << endl;
}

void yes_no(int can) {
    cout << (can ? "YES\n" : "NO\n");
}
#define sqr(x) (x) * (x)

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int len = (1 << 21) + 10;
    vector<int> states(len , 0);
    vector<int> px(len, -1);
    vector<vector<int> > gr(n);
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x--;
        gr[x].push_back(i);
    }
    int current_state = 1;
    states[current_state] = 1;
    function<void(int, function<void(int, int, int&)>)> huge_dfs = [&](int c, function<void(int, int, int&)> dfs) {
        int cnt = 0;
        dfs(0, c, cnt);
    };

    function<void(int, int, int&)> dfs = [&](int v, int st, int& nn) {
        nn += 1;
        for (auto to : gr[v]) {
            if ((st >> to) & 1) {
                int cnt = 0;
                dfs(to, st, cnt);
                nn += cnt;
            } else {
                int n_st = st ^ (1 << to);
                if (!states[n_st]) {
                    states[n_st] = states[st] + 1;
                    huge_dfs(n_st, dfs);
                    px[n_st] = st;
                }
            }

        }
        if (nn == 1 && v != 0) {
            int n_st = st ^ (1 << v);
            if (!states[n_st]) {
                states[n_st] = states[st] + 1;
                huge_dfs(n_st, dfs);
                px[n_st] = st;
            }

        }
    };
    huge_dfs(1, dfs);
    int best = 0;
    for (int i = 0; i < len; i++) {
        if (states[best] < states[i]) {
            best = i;
        }
    }
    int p = best;
    vector<int> ans;
    while (p != -1) {

        if (px[p] != -1) {
            int bit = px[p] ^ p;
            for (int i = 0; i < 22; i++) {
                if ((bit >> i) & 1) {
                    ans.push_back(i + 1);
                    break;
                }
            }
        }

        p = px[p];
    }
    reverse(all(ans));
    std::cout << ans.size() << '\n' << ans;

    return 0;
}