#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <iomanip>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

const int INF = 1e9;

int main() {

//	fstream cin("input.txt");
	//ofstream cout("output.txt");

	int n, ans = 0; cin >> n;
	vector <vector <int> > tab(n);
	map <int, vector <int> > m;
	vector <bool> Event(n);
	Event[0] = true;

	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		tab[i].resize(k);
		for (int j = 0; j < k; j++)
			cin >> tab[i][j];
	}

	for (int i = 0; i < n; i++)
		sort(tab[i].begin(), tab[i].end());

	for (int i = 0; i < n; i++)
		for (int j = 0; j < tab[i].size(); j++)
			m[tab[i][j]].push_back(i);

	for (int i = 0; i < n; i++) {
		if (Event[i]) ans++;
		int next = INF;
		for (int j = 0; j < tab[i].size(); j++) {
			auto id = upper_bound(m[tab[i][j]].begin(), m[tab[i][j]].end(), i);
			if (id != m[tab[i][j]].end()) next = min(next, *id);
		}
		if(next != INF) Event[next] = true;
	}

	cout << ans;

}