﻿#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <iomanip>
#include <cmath>
#include <map>
#include <vector>
#include <sstream>
#include <numeric>

#ifdef _DEBUG
constexpr bool debug_mode = true;
#else
constexpr bool debug_mode = false;
#endif

using namespace std;
const double EPS = 1e-9;

std::vector<std::string> split(const std::string& s, char delim) {
	std::stringstream ss(s);
	std::string part;
	std::vector<std::string> result;
	
	while (std::getline(ss, part, delim)) {
		result.push_back(part);
	}

	return result;
}

int digitToInt(char c) {
	return c - '0';
}

int main() {
	using ll = long long;

#if defined _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cout << fixed << setprecision(1);

	long long n;
	cin >> n;

	for (int i = 0; i < n; i++) {
		long long b, d;
		cin >> b >> d;

		long long gc = gcd(b, d);
		long long b2 = d / gc;

		long long ans = b / b2;

		if (b % b2 == 0) {
			ans--;
		}

		cout << ans << endl;
	}

	return 0;
}
