#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("tune=native")
using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX_N = 300015;

int a, b;
map<int, tuple<int, int, int>> can[MAX_N];
int currV = 1;
int w[MAX_N], l[MAX_N], r[MAX_N];

tuple<int, int, int> findCan(int x, int y)
{
	if (x == 0 && y == 0)
		return { -1, 0, 0 };
	if (can[x].count(y) != 0)
		return can[x][y];

	if (x - 2 * y > 0)
	{
		int x1 = (x - 1) >> 1, x2 = (x - 1) - x1;
		int y1 = y >> 1, y2 = y - y1;
		for (int it = 0; it < 2 && y1 >= 0; it++, y1--, y2++)
		{
			auto pr1 = findCan(x1, y1);
			if (get<0>(pr1) != 0)
			{
				auto pr2 = findCan(x2, y2);
				if (get<0>(pr2) != 0)
				{
					can[x][y] = { 1, x1, y1 };
					return can[x][y];
				}
			}
		}
	}
	if (y > 0 && x >= 2)
	{
		int x1 = (x - 2) >> 1, x2 = (x - 2) - x1;
		int y1 = (y - 1) >> 1, y2 = (y - 1) - y1;
		for (int it = 0; it < 2 && y1 >= 0; it++, y1--, y2++)
		{
			auto pr1 = findCan(x1, y1);
			if (get<0>(pr1) != 0)
			{
				auto pr2 = findCan(x2, y2);
				if (get<0>(pr2) != 0)
				{
					can[x][y] = { 2, x1, y1 };
					return can[x][y];
				}
			}
		}
	}
	can[x][y] = { 0, 0, 0 };
	return can[x][y];
}

int dfs(int x, int y)
{
	if (x == 0 && y == 0)
		return 0;

	auto currCan = can[x][y];
	int curr = currV;
	currV++;

	w[curr] = get<0>(currCan);
	int x1 = get<1>(currCan), y1 = get<2>(currCan);
	int x2 = x - x1, y2 = y - y1;
	if (w[curr] == 1)
		x2--;
	else
	{
		x2 -= 2;
		y2--;
	}

	int currL = dfs(x1, y1);
	int currR = dfs(x2, y2);
	l[curr] = currL;
	r[curr] = currR;
	return curr;
}

int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> a >> b;
	auto startPr = findCan(a + 2 * b, b);
	if (get<0>(startPr) == 0)
	{
		cout << "-1\n";
		return 0;
	}
	dfs(a + 2 * b, b);
	for (int i = 1; i < currV; i++)
		cout << w[i] << ' ' << l[i] << ' ' << r[i] << '\n';

	return 0;
}