﻿#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("tune=native")

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <assert.h>
#include <string>
#include <stack>
#include <queue>
#include <tuple>
#include <numeric>
#include <fstream>
#include <ctime>
#include <array>
#include <random>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

bool check(string s)
{
	int cnt0 = 0, cnt1 = 0, cnt2 = 0;

	for(auto c : s)
		switch (c)
		{
		case '0':
			cnt0++;
			break;
		case '1':
			cnt1++;
			break;
		case '2':
			cnt2++;
			break;
		}

	return cnt0 > 0 && cnt1 > 0 && cnt2 > 1;
}

int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	const int INF = 123456789;

	int bestpr = INF;
	int bestnum = 0;

	for (int i = 0; i < n; i++)
	{
		int p;
		string s;
		cin >> p >> s;

		if (p < bestpr && check(s))
		{
			bestpr = p;
			bestnum = i + 1;
		}
	}

	cout << bestnum << endl;

	return 0;
}