#include <bits/stdc++.h>
using namespace std;
const int sz=6e5+10;
int L[sz], R[sz], key[sz];

vector <int> sp[sz], dot[sz*4];

void build(int nu, int l, int r)
{
    if(l==r)
    {
        dot[nu]=sp[l];
        sort(dot[nu].begin(), dot[nu].end());
    }
    else
    {
        int mid=(l+r)>>1;
        build(nu*2, l, mid);
        build(nu*2+1, mid+1, r);
        dot[nu].resize(dot[nu*2].size()+dot[nu*2+1].size());
        merge(dot[nu*2].begin(), dot[nu*2].end(), dot[nu*2+1].begin(), dot[nu*2+1].end(), dot[nu].begin());
    }
}

int lg, rg;
int que2(int nu, int l, int r)
{
    if(l>=lg and r<=rg)
    {
        return upper_bound(dot[nu].begin(), dot[nu].end(), rg)-dot[nu].begin();
    }
    else if(l>rg or r<lg) return 0;
    else
    {
        int mid=(l+r)>>1;
        return que2(nu*2, l, mid)+que2(nu*2+1, mid+1, r);
    }
}

int fenl[sz], fenr[sz];

void cha(int *fen, int p, int va)
{
    while(p<sz)
    {
        fen[p]+=va, p=p|(p+1);
    }
}
int que(int *fen, int p)
{
    int re=0;
    while(p>=0)
    {
        re+=fen[p], p=(p&(p+1))-1;
    }
    return re;
}

pair <int, int> dfs(int v)
{
    pair <int, int> res={key[v], key[v]};

    if(L[v]) res.first = dfs(L[v]).first;
    if(R[v]) res.second = dfs(R[v]).second;

    int l=res.first, r=res.second;
    //cout<<l<<" "<<r<<"\n";
    cha(fenl, l, 1);
    cha(fenr, r, 1);
    sp[l].push_back(r);

    return res;
}

main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin>>n;
    map <int, int> ma;
    for(int a=1; a<=n; a++)
    {
        scanf("%d%d%d", &L[a], &R[a], &key[a]);
        ma[key[a]]=0;
    }
    int q;
    cin>>q;
    int ll[q], rr[q];
    for(int a=0; a<q; a++)
    {
        scanf("%d%d", &ll[a], &rr[a]);
        ma[ll[a]]=0;
        ma[rr[a]]=0;
    }
    int m=0;
    for(auto it=ma.begin(); it!=ma.end(); it++) (*it).second=m++;

    for(int a=1; a<=n; a++) key[a]=ma[key[a]];

    for(int a=0; a<q; a++)
    {
        ll[a]=ma[ll[a]];
        rr[a]=ma[rr[a]];
    }

    dfs(1);

    build(1, 0, m-1);

    for(int a=0; a<q; a++)
    {
        lg=ll[a], rg=rr[a];
        int an=n-que(fenr, lg-1)-(que(fenl, m-1)-que(fenl, rg))-que2(1, 0, m-1);

        //cout<<lg<<" "<<rg<<"\n";

        //cout<<que(fenr, lg-1)<<" "<<(que(fenl, m-1)-que(fenl, rg))<<" "<<que2(1, 0, m-1)<<"\n";

        printf("%d\n", an*2+1);
    }
}
