
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define sz(a) ((int)(a).size())
#define X first
#define Y second

using ll = long long;
using ull = unsigned long long;
using dbl = long double;
using pii = pair<int, int>;

struct Split{
    int root;
    int a1, b1, a2, b2;
};

map<pii, bool> ok;
map<pii, Split> p;

void rec(int A, int B){
    if(ok.count(make_pair(A, B)))
        return;
    if((A == 0 && B == 1) || (A == 1 && B == 0)){
        ok[make_pair(A, B)] = true;
        return;
    }
    //cerr << A << ' ' << B << endl;
    ok[make_pair(A, B)] = false;
    //root is 1
    if(A > 0){
        int a = A - 1, b = B;
        int a1 = (A - 1)/2, b1 = B/2;
        if(a%2 == 0 && b%2 == 0){
            rec(a1, b1);
            if(ok[make_pair(a1, b1)]){
                ok[make_pair(A, B)] = true;
                p[make_pair(A, B)] = Split{1, a1, b1, a1, b1};
            }
        }
        if(a%2 == 1 && b%2 == 0){
            rec(a1 + 1, b1);
            rec(a1, b1);
            if(ok[make_pair(a1, b1)] && ok[make_pair(a1 + 1, b1)]){
                ok[make_pair(A, B)] = true;
                p[make_pair(A, B)] = Split{1, a1 + 1, b1, a1, b1};
            }
        }
        if(a%2 == 0 && b%2 == 1){
            if(a1){
                rec(a1 + 1, b1);
                rec(a1 - 1, b1 + 1);
                if(ok[make_pair(a1 + 1, b1)] && ok[make_pair(a1 - 1, b1 + 1)]){
                    ok[make_pair(A, B)] = true;
                    p[make_pair(A, B)] = Split{1, a1 + 1, b1, a1 - 1, b1 + 1};
                }
            }
        }
        if(a%2 == 1 && b%2 == 1){
            rec(a1 + 1, b1);
            rec(a1, b1 + 1);
            if(ok[make_pair(a1 + 1, b1)] && ok[make_pair(a1, b1 + 1)]){
                ok[make_pair(A, B)] = true;
                p[make_pair(A, B)] = Split{1, a1 + 1, b1, a1, b1 + 1};
            }
        }
    }
    if(ok[make_pair(A, B)])
        return;
    //root is 2
    if(B > 0){
        int a = A, b = B - 1;
        int a1 = a/2, b1 = b/2;
        if(a%2 == 0 && b%2 == 0){
            rec(a1, b1);
            if(ok[make_pair(a1, b1)]){
                ok[make_pair(A, B)] = true;
                p[make_pair(A, B)] = Split{2, a1, b1, a1, b1};
            }
        }
        if(a%2 == 1 && b%2 == 0){
            rec(a1 + 1, b1);
            rec(a1, b1);
            if(ok[make_pair(a1, b1)] && ok[make_pair(a1 + 1, b1)]){
                ok[make_pair(A, B)] = true;
                p[make_pair(A, B)] = Split{2, a1 + 1, b1, a1, b1};
            }
        }
        if(a%2 == 0 && b%2 == 1){
            if(a1){
                rec(a1 + 1, b1);
                rec(a1 - 1, b1 + 1);
                if(ok[make_pair(a1 + 1, b1)] && ok[make_pair(a1 - 1, b1 + 1)]){
                    ok[make_pair(A, B)] = true;
                    p[make_pair(A, B)] = Split{2, a1 + 1, b1, a1 - 1, b1 + 1};
                }
            }
        }
        if(a%2 == 1 && b%2 == 1){
            rec(a1 + 1, b1);
            rec(a1, b1 + 1);
            if(ok[make_pair(a1 + 1, b1)] && ok[make_pair(a1, b1 + 1)]){
                ok[make_pair(A, B)] = true;
                p[make_pair(A, B)] = Split{2, a1 + 1, b1, a1, b1 + 1};
            }
        }
    }
}

int cid = 0;
vector<tuple<int, int, int> > ans;

void restore(int v, int A, int B){
    if(A == 0 && B == 0)
        return;
    if(A == 0 && B == 1){
        ans[v] = make_tuple(2, 0, 0);
        return;
    }
    if(A == 1 && B == 0){
        ans[v] = make_tuple(1, 0, 0);
        return;
    }
    Split s = p[make_pair(A, B)];
    int l = !(s.a1 || s.b1) ? -1 : cid++;
    int r = !(s.a2 || s.b2) ? -1 : cid++;
    ans[v] = make_tuple(s.root, l + 1, r + 1);
    restore(l, s.a1, s.b1);
    restore(r, s.a2, s.b2);
}

void solve() {
    int A, B;
    cin >> A >> B;
    ok[make_pair(0, 0)] = true;
    rec(A, B);
    //for(auto [s, val]: ok)
    //    cerr << s.X << ' ' << s.Y << ' ' << val << endl;
    if(!ok[make_pair(A, B)])
        cout << "-1\n";
    else{
        ans.resize(A + B);
        restore(cid++, A, B);
        for(auto v: ans)
            cout << get<0>(v) << ' ' << get<1>(v) << ' ' << get<2>(v) << '\n';
    }
}

signed main() {
#ifdef LOCAL
     assert(freopen("input.txt", "r", stdin));
     //assert(freopen("output.txt", "w", stdout));
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);
    int T;
    T = 1;
    while(T--)
        solve();

#ifdef LOCAL
    cout << endl << endl << "time = " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
}


