/*

Code for problem B by cookiedoth
Generated 13 Dec 2020 at 12.22 PM


   ,##.                   ,==.
 ,#    #.                 \ o ',
#        #     _     _     \    \
#        #    (_)   (_)    /    ; 
 `#    #'                 /   .'  
   `##'                   "=="

^_^
-_-
z_z

*/

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <ctime>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <complex>
#include <cassert>
#include <random>
#include <cstring>
#include <numeric>
#include <random>
#include <utility>
#include <tuple>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << #a << " = " << a << endl
#define forn(i, n) for (int i = 0; i < n; ++i)
#define length(a) (int)a.size()

using namespace std;

template<class T> int chkmax(T &a, T b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, T b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream& out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int K = 26;
int used[K], useCount, dictSize;
ll coeff[K];
vector<char> use, other;
string term1, term2;
unordered_map<string, int> cnt;
vector<string> normalized, str;

void makeUsed(const string& term) {
	ll val = 1;
	for (int i = 0; i < (int)term.size() - 1; ++i) {
		val *= 10;
	}
	for (int i = 0; i < term.size(); ++i) {
		char c = term[i];
		if (used[c - 'A'] == -1) {
			used[c - 'A'] = useCount++;
			use.push_back(c);
		}
		coeff[c - 'A'] += val;
		val /= 10;
	}
}

void normalize(string &s) {
	vector<int> curUsed(K, -1);
	int ptr = 0;
	for (auto &c : s) {
		if (used[c - 'A'] == -1) {
			if (curUsed[c - 'A'] == -1) {
				curUsed[c - 'A'] = ptr++;
			}
			c = other[curUsed[c - 'A']];
		}
	}
}

void read() {
	fill(used, used + K, -1);
	cin >> term1 >> term2;
	makeUsed(term1);
	makeUsed(term2);
	// output(used, used + K);
	for (int i = 0; i < K; ++i) {
		if (used[i] == -1) {
			other.push_back('A' + i);
		}
	}
	// cerr << "other:" << endl;
	// for (auto c : other) {
	// 	cerr << c;
	// }
	// cerr << '\n';
	// cerr << "use:" << endl;
	// for (auto c : use) {
	// 	cerr << c;
	// }
	// cerr << '\n';
	cnt.rehash(1e7);
	cin >> dictSize;
	for (int i = 0; i < dictSize; ++i) {
		string word;
		cin >> word;
		str.push_back(word);
		// cerr << "normalize " << word << '\n';
		normalize(word);
		// cerr << word << '\n';
		if (cnt.find(word) == cnt.end()) {
			cnt[word] = 0;
		}
		normalized.push_back(word);
	}
	// cerr << coeff['S' - 'A'] << '\n';
	// cerr << coeff['E' - 'A'] << '\n';
}

const int D = 10;
vector<int> perm, number;
int assign[K];
char assignD[D];

void go() {
	for (int i = useCount; i < D - 1; ++i) {
		if (!(perm[i] < perm[i + 1])) {
			return;
		}
	}
	// cerr << "opa" << endl;
	fill(assign, assign + K, -1);
	fill(assignD, assignD + D, -1);
	ll tot = 0;
	for (int i = 0; i < useCount; ++i) {
		tot += coeff[use[i] - 'A'] * perm[i];
		assign[use[i] - 'A'] = perm[i];
		assignD[perm[i]] = use[i];
		// cerr << "assignD " << perm[i] << " " << use[i] << '\n';
	}
	// cerr << "tot = " << tot << '\n';
	if (assign[term1[0] - 'A'] == 0 || assign[term2[0] - 'A'] == 0) {
		return;
	}
	number.clear();
	while (tot) {
		number.push_back(tot % 10);
		tot /= 10;
	}
	reverse(all(number));
	string result(number.size(), 'A');
	int ptr = 0;
	for (int i = 0; i < number.size(); ++i) {
		if (assignD[number[i]] == -1) {
			// cerr << "bad " << i << '\n';
			assignD[number[i]] = other[ptr++];
		}
		result[i] = assignD[number[i]];
	}
	// cerr << "result: " << result << '\n';
	auto it = cnt.find(result);
	if (it != cnt.end()) {
		it->second++;
	}
}

void bruteforce() {
	perm.resize(D);
	iota(all(perm), 0);
	do {
		go();
	} while (next_permutation(all(perm)));
}

void print_ans() {
	vector<string> ans;
	for (int i = 0; i < normalized.size(); ++i) {
		if (cnt[normalized[i]] == 1) {
			ans.push_back(str[i]);
		}
	}
	cout << ans.size() << '\n';
	for (auto str : ans) {
		cout << str << '\n';
	}
}

signed main() {
	fast_io();
	read();
	bruteforce();
	print_ans();
}
