#include <algorithm>
#include <iostream>
#include <vector>
#include <map>

using namespace std;

vector<int> dfs(int u, const vector<vector<int>>& g) {
    vector<int> ans;
    for (int v : g[u]) {
        auto cur = dfs(v, g);
        vector<int> ans1 = cur;
        for (int i = 0; i < (int)ans.size(); i++) {
            ans1.push_back(ans[i]);
            reverse(cur.begin(), cur.end());
            for (int x : cur) ans1.push_back(x);
        }
        ans = ans1;
    }
    ans.insert(ans.begin(), u);
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int p;
        cin >> p;
        g[p - 1].push_back(i + 1);
    }
    if (n == 1) {
        cout << 1 << '\n' << 1 << endl;
        return 0;
    }
    auto ans = dfs(0, g);
    ans.erase(ans.begin());
    cout << ans.size() << endl;
    for (int x : ans) cout << x + 1 << ' ';
    cout << endl;
}