#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define all(x) begin(x), end(x)
#define debug(x) cerr << #x << " = " << x << endl;
#define len(a) (int)(a.size())

using ll = long long;
using ld = long double;
using namespace std;

string s, t;

vector<int> lets;
vector<int> fr;

vector<int> sumrepr;
vector<vector<int>> results;
set<vector<int>> rs, bad;

struct Node {
    vector<int> go;
    int term;
    Node(): go(26, -1), term(0) {}
};

vector<Node> nodes;

void add_str(string s) {
    int v = 0;
    for (auto c : s) {
        if (nodes[v].go[c - 'A'] != -1) {
            v = nodes[v].go[c - 'A'];
        } else {
            int u = nodes.size();
            nodes.emplace_back();
            nodes[v].go[c - 'A'] = u;
            v = u;
        }
    }
    nodes[v].term = 1;
}

vector<int> count_sum() {
    int a = 0, b = 0;
    for (auto c : s) {
        a *= 10;
        a += fr[c];
    }
    for (auto c : t) {
        b *= 10;
        b += fr[c];
    }
    int c = a + b;
    vector<int> res;
    while (c > 0) {
        res.push_back(c % 10);
        c /= 10;
    }
    reverse(all(res));
    return res;
}

vector<int> cur;

void dfs(int v, int pos) {
    if (v == -1) {
        return;
    }
    if (pos == len(sumrepr)) {
        if (nodes[v].term)
            results.push_back(cur);
        return;
    }
    if (sumrepr[pos] != -1) {
        dfs(nodes[v].go[sumrepr[pos]], pos + 1);
        return;
    }

    for (int i = 0; i < 26; i++) {
        if (fr[i] != -1) continue;
        if (nodes[v].go[i] != -1) {
            cur.push_back(i);
            dfs(nodes[v].go[i], pos + 1);
            cur.pop_back();
        }   
    }
}

void checkadd() {
    if (fr[s[0]] == 0) return;
    if (fr[t[0]] == 0) return;
    if (fr[sumrepr[0]] == 0) return;
    ll a0 = 0;
    for (auto c : s) {
        a0 *= 10;
        a0 += fr[c];
    }
    
    ll a1 = 0;
    for (auto c : t) {
        a1 *= 10;
        a1 += fr[c];
    }

    ll a2 = 0;
    for (auto c : sumrepr) {
        a2 *= 10;
        a2 += fr[c];
    }

    vector<int> was(10);
    for (int i = 0; i < 26; i++) {
        if (fr[i] != -1) {
            if (was[fr[i]])
                return;
            was[fr[i]] = 1;
        }
    }

    if (a1 + a0 == a2) {
        if (rs.count(sumrepr)) {
            bad.insert(sumrepr);
        } else {
            rs.insert(sumrepr);
        }
    }
}

void solve() {
    cin >> s >> t;
    int n; cin >> n;

    nodes.emplace_back();

    for (int i = 0; i < n; i++) {
        string ss;
        cin >> ss;
        add_str(ss);
    }


    set<int> used_letters;
    for (auto& c : s) {
        c -= 'A';
        used_letters.insert(c);
    }
    for (auto& c : t) {
        c -= 'A';
        used_letters.insert(c);
    }
    for (auto& c : used_letters) {
        lets.push_back(c);
    }
    if (lets.size() > 10) {
        cout << 0;
        return;
    }
    while (lets.size() < 10) {
        lets.push_back(-1);
    }
    fr.resize(26);
    sort(all(lets));
    while (1) {
        fill(all(fr), -1);
        for (int i = 0; i < len(lets); i++) {
            if (lets[i] != -1) {
                fr[lets[i]] = i;
            }
        }

        auto sum = count_sum();
        sumrepr.assign(len(sum), -1);
        for (int i = 0; i < len(sum); i++) {
            sumrepr[i] = lets[sum[i]];
        }
        vector<int> gaps;
        for (int i = 0; i < len(sum); i++) {
            if (sumrepr[i] == -1) gaps.push_back(i);
        }

        results.clear();
        dfs(0, 0);

        for (auto& result : results) {
            for (int i = 0; i < len(gaps); i++) {
                sumrepr[gaps[i]] = result[i];
                fr[result[i]] = sum[gaps[i]];
            }
            checkadd();
            for (int i = 0; i < len(gaps); i++) {
                sumrepr[gaps[i]] = -1;
                fr[result[i]] = -1;
            }
        }

        ll f = next_permutation(all(lets));
        if (!f) {
            break;
        }
    }
    for (auto x : bad) {
        rs.erase(x);
    }
    cout << rs.size() << '\n';
    for (auto& s : rs) {
        for (auto c : s) cout << (char)(c + 'A');
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(30);
    solve();
}