#include <vector>
#include <iostream>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <iomanip>
#include <time.h>
#include <unordered_map>
#include <unordered_set>

#define fi first
#define se second
#define ll long long
#define ld long double
#define int long long
using namespace std;
const int N = 3e5 + 12;
const int MOD = 1e9 + 7;
const int LogN = 9;
string s[N];
bool dp[N][256];
bool revdp[N][256];
int t[LogN];
bool can[N][LogN];
bool good[N];


void solve() {
    int k, n, A, B, x;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < LogN; ++j)
            if (i + j >= n)
                can[i][j] = 0;
            else {
                int cnt = 0;
                for (int l = 0; l < 8; ++l)
                    cnt += s[i][l] == s[i + j][l];
                can[i][j] = cnt >= j;
            }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i; j >= 0; --j) {
            good[j] = 0;
            for (int l = 1; l < LogN && j + l <= i; ++l)
                if (can[j][l] && !good[j + l])
                    good[j] = 1;
        }
        if (good[0])
            cout << 1;
        else
            cout << 2;
    }
}

void solve1() {
    int k, n, A, B, x;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < LogN; ++j)
            if (i + j >= n)
                can[i][j] = 0;
            else {
                int cnt = 0;
                for (int l = 0; l < 8; ++l)
                    cnt += s[i][l] == s[i + j][l];
                can[i][j] = cnt >= j;
            }
    }
    for (int i = 0; i < n; ++i) {
        for (int mask = 0; mask < 256; ++mask) {
            dp[i][mask] = 0;
            for (int l = 1; l < 9; ++l)
                if (can[i][l] && ((mask & t[l - 1]) > 0)) {
                    dp[i][mask] = 1;
                }
        }
    }
    for (int mask = 0; mask < 256; ++mask)
        revdp[0][mask] = dp[0][mask];
    for (int i = 1; i < n; ++i) {
        for (int mask = 0; mask < 256; ++mask) {
            int nmask = (mask * 2) % 256 + 1 - dp[i][mask];
            revdp[i][mask] = revdp[i - 1][nmask];
        }
    }
    for (int i = 0; i < n; ++i) {
        if (revdp[i][0])
            cout << 1;
        else
            cout << 2;
    }

}

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(false); cin.tie(0);
    t[0] = 1;
    for (int i = 1; i < LogN; ++i)
        t[i] = t[i - 1] * 2;
    int test = 1;
    //cin >> test;
    while (test--) {
        solve1();
    }
}
