#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 2e9;
const ll MOD = 998244353;
const ld EPS = 1e-9;
const int M = 31;
const int N = 1e6 + 10;

map<pair<int, int>, bool> memo;

bool ok(int a, int b) {
  if (!a) return (b & (b + 1)) == 0;
  if (!b) return true;
  if (memo.count({a, b})) {
    return memo[pair<int, int>(a, b)];
  }

  bool fnd = false;
  for (int a1 = 0; a1 <= a - 1; ++a1) {
    for (int b1 = 0; b1 <= b; ++b1) {
      int a2 = a - 1 - a1;
      int b2 = b - b1;
      if (abs(a1 + 2 * b1 - a2 - 2 * b2) <= 1) {
        fnd |= (ok(a1, b1) && ok(a2, b2));
      }
    }
  }
  for (int a1 = 0; a1 <= a; ++a1) {
    for (int b1 = 0; b1 <= b - 1; ++b1) {
      int a2 = a - a1;
      int b2 = b - 1 - b1;
      if (abs(a1 + 2 * b1 - a2 - 2 * b2) <= 1) {
        fnd |= (ok(a1, b1) && ok(a2, b2));
      }
    }
  }
  return memo[pair<int, int>(a, b)] = fnd;
}

bool ok2(int a, int b) {
  if (!a) return (b & (b + 1)) == 0;
  if (!b) return true;

  bool fnd = false;
  b--;
  if (b % 2 == 0) {
    fnd |= (ok2(a / 2, b / 2) && ok2((a + 1) / 2, b / 2));
  } else {
    if (a % 2) {
      fnd |= (ok2(a / 2, (b + 1) / 2) && ok2((a + 1) / 2, b / 2));
    } else {
      fnd |= (ok2((a - 2) / 2, (b + 1) / 2) && ok2((a - 2) / 2 + 2, b / 2));
    }
  }
  return fnd;
}

int ans[N][3];
int ptr = 0;

void rec(int a, int b) {
  if (!a && !b) return;
  if (b) {
    b--;
    int id = ptr;
    ans[id][0] = 2;
    ptr++;
    if (b % 2 == 0) {
      if (a / 2 || b / 2) {
        ans[id][1] = ptr;
        rec(a / 2, b / 2);
      }
      if ((a + 1) / 2 || b / 2) {
        ans[id][2] = ptr;
        rec((a + 1) / 2, b / 2);
      }
    } else {
      if (a % 2) {
        if (a / 2 || (b + 1) / 2) {
          ans[id][1] = ptr;
          rec(a / 2, (b + 1) / 2);
        }
        if ((a + 1) / 2 || b / 2) {
          ans[id][2] = ptr;
          rec((a + 1) / 2, b / 2);
        }
      } else {
        if ((a - 2) / 2 || (b + 1) / 2) {
          ans[id][1] = ptr;
          rec((a - 2) / 2, (b + 1) / 2);
        }
        if ((a - 1) / 2 + 2 || b / 2) {
          ans[id][2] = ptr;
          rec((a - 1) / 2 + 2, b / 2);
        }
      }
    }
    return;
  }
  int id = ptr;
  ans[ptr][0] = 1;
  ptr++;
  a--;
  if (a / 2) {
    ans[id][1] = ptr;
    rec(a / 2, 0);
  }
  if ((a + 1) / 2) {
    ans[id][2] = ptr;
    rec((a + 1) / 2, 0);
  }
  return;
}

void solve() {
  int a, b;
  cin >> a >> b;

  if (!ok2(a, b)) {
    cout << "-1" << endl;
    return;
  }

 // assert(ptr == a + b);
  for (int i = 0; i < a + b; ++i) {
    ans[i][1] = ans[i][2] = -1;
  }
  rec(a, b);
  //cout << ptr << endl;
  for (int i = 0; i < a + b; ++i) {
    cout << ans[i][0] << " " << ans[i][1] + 1 << " " << ans[i][2] + 1 << "\n";
  }

  /*
  for (int a = 0; a <= 20; ++a) {
    for (int b = 0; b <= 20; ++b) {
      if (!a && !b) continue;
      bool c1 = ok(a, b);
      bool c2 = ok2(a, b);
      if (c1 != c2) {
        cout << a << " " << b << endl;
        cout << "ok: " << c1 << " ok2: " << c2 << endl;
        return;
      }
    }
  }
  */
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
}
