#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("popcnt")
//#pragma GCC target("-mpopcnt")

using namespace std;
//using namespace __gnu_pbds;

#define pb push_back
#define F first
#define S second
#define ll long long
#define ld double long
#define ull unsigned long long
#define endl '\n'


const ll N = 2e6 + 36;
const ll M = 1e1 + 64;
const ll INF = 1e9 + 7;
const ll MOD = 1e9 + 7;
const ll X[4] = {1, -1, 0, 0};
const ll Y[4] = {0, 0, 1, -1};
const ld PI = 3.14159265358979323846;
const ld EPS = 1e-12;

mt19937 gen(19937);

vector < int > g[M], ans[M], kek[M];

vector<string> generateGray(int n) {
    // Base case
    if (n <= 0)
        return {"0"};

    if (n == 1) {
        return {"0","1"};
    }

    //Recursive case
    vector<string> recAns=
        generateGray(n-1);
    vector<string> mainAns;

    // Append 0 to the first half
    for(int i=0; i<recAns.size(); i++) {
        string s=recAns[i];
        mainAns.push_back("0"+s);
    }

    // Append 1 to the second half
    for(int i=recAns.size()-1; i>=0; i--) {
        string s=recAns[i];
        mainAns.push_back("1"+s);
    }
    return mainAns;
}

// Function to generate the
// Gray code of N bits
void generateGrayarr(int n) {
    vector<string> arr;
    arr=generateGray(n);
    // print contents of arr
    for (int i = 0 ; i < arr.size() - 1; i++ ) {
        for (int j(0); j < n; ++j) {
            if (arr[i][j] != arr[i + 1][j]) {
                ans[n].pb(j);
                break;
            }
        }
    }
}

int f[M];
vector < int > otv;
    int cnt = 0;

void  dfs(int v, int l, int r) {
    int L = int(otv.size());
    l = otv.size();
    for (auto to:g[v]) {
        otv.pb(to);
        if (cnt == 1) {
            for (int j(l); j < r; ++j){
                otv.pb(otv[j]);
            }
        } else {
            for (int j(r - 1); j >= l; --j){
                otv.pb(otv[j]);
            }
        }
        cnt ^= 1;
        //cout << l << ' ' << r << endl;
        dfs(to, l, r);
        r = int(otv.size());
        L = int(otv.size());
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    for (int i(1); i < n; ++i) {
        int x;
        cin >> x;
        --x;
        g[x].pb(i);
        f[i] = 0;
    }

    dfs(0, 0, 0);
    cout << int(otv.size()) << endl;
    for (auto to:otv){
        cout << to + 1 << ' ';
    }
    return 0;
}
