#include <bits/stdc++.h>
using namespace std;

const int maxn = 3e5;
int masks[maxn];
int f[maxn][1<<8];
// f[i][mask] = who wins if we start at first pos and
// 8 rows starting from i have winning-ness of mask

void print(int mask) {
    cerr << bitset<8>(mask) << endl;
}

int dist(int a, int b) {
    int res = __builtin_popcount(masks[a] ^ masks[b]);
    //print(masks[a]);
    //print(masks[b]);
    //cerr << a << " "  << b << " " << res << endl;
    return res;
}

int main() {
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 8; j++) {
            char c;
            cin >> c;
            masks[i] |= (c == 'R') << j;
        }
        //print(masks[i]);
    }

    for (int i = 0; i < n; i++) {
        for (int mask = 0; mask < (1<<8); mask++) {
            if (i == 0) {
                f[i][mask] = (mask&1);
            } else {
                int new_mask = (mask & ((1<<7) - 1)) << 1;
                //cerr << "-" << endl;
                //print(mask);
                //print(new_mask);
                for (int k = 1; k <= 8; k++) {
                    if (i - 1 + k < n && dist(i - 1, i - 1 + k) <= (8 - k) && (mask>>(k-1)&1) == 0) {
                        new_mask |= 1;
                        break;
                    }
                }
                f[i][mask] = f[i - 1][new_mask];
            }
        }
        if (i > 0) {
            cout << 2 - f[i][(1<<8) - 1]; 
        }
    }

    cout << 1 << endl;

    return 0;
}
