#include <iostream>
#include <map>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <random>
#include <time.h>
#include <string>
#include <cstring>
#include <set>
#include <cmath>

using namespace std;


int main() {
#ifdef LOCAL_ENV
    freopen("a.in", "r", stdin);
#endif
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> dp(n);
    int res = 0;
    vector<int> prv(n, -1);
    for (int i = 0; i < n; ++i) {
        int cnt;
        cin >> cnt;
        dp[i] = 1;
        for (int j = 0; j < cnt; ++j) {
            int guy;
            cin >> guy;
            --guy;
            if (prv[guy] != -1) {
                dp[i] = max(dp[i], dp[prv[guy]] + 1);
            }
            prv[guy] = i;
        }
    }
    cout << *max_element(dp.begin(), dp.end());
    return 0;
}