#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<algorithm>
#include<cmath>
#include<unordered_map>
#include<unordered_set>
#include<bitset>
#include<sstream>
#include<numeric>
#include<queue>
#include<cstdio>
#include<iomanip>
#include<exception>
#include<iterator>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;
using ll = long long;
using ull = unsigned long long;
long double eps = 1e-7;

struct Vertex {
    int num = 0;
    int pos = 0;
    int weight = 0;
};
vector<vector<Vertex>> graph;
int now_pos = 1;
int now_1_count;
int now_2_count;

void calc(int pos, int start, int i, int step) {
    if (now_2_count) {
        graph[pos + 1][2 * (start + i) + step] = {2, ++now_pos};
        --now_2_count;
    } else if (now_1_count) {
        graph[pos + 1][2 * (start + i) + step] = {1, ++now_pos};
        --now_1_count;
    }
}

bool check() {
    return now_2_count + now_1_count > 0;
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int A, B;
    cin >> A >> B;

    const int N = 20;

    int now_size = 1;
    for (int i = 0; i < N; ++i) {
        graph.emplace_back(now_size);
        now_size *= 2;
    }
    // если B четное и A == 0 -> -1
    now_1_count = A;
    now_2_count = B;
    if (B % 2 == 0 && now_1_count != 0) {
        graph[0][0] = {1, 1 };
        --now_1_count;
    } else {
        graph[0][0] = {2, 1};
        --now_2_count;
    }

    for (int pos = 0; pos < N - 1 && check(); ++pos) {
        for (int step = 0; step < 2 && check(); ++step) {
            if (pos == 0) {
                if (now_2_count) {
                    graph[pos + 1][2 * (0) + step] = {2, ++now_pos};
                    --now_2_count;
                } else if (now_1_count) {
                    graph[pos + 1][2 * (0) + step] = {1, ++now_pos};
                    --now_1_count;
                }
                continue;
            }
            int l = 0, r = graph[pos].size();
            queue<pair<int, int>> q;
            q.push({l, (l + r) / 2});
            q.push({(l + r) / 2, r});
            while (!q.empty()) {
                int now_l = q.front().first;
                int now_r = q.front().second;
                q.pop();
                if (graph[pos + 1][2 * now_l + step].num == 0) {
                    if (now_2_count) {
                        graph[pos + 1][2 * now_l + step] = {2, ++now_pos};
                        --now_2_count;
                    } else if (now_1_count) {
                        graph[pos + 1][2 * now_l + step] = {1, ++now_pos};
                        --now_1_count;
                    }
                }
                if ((now_r + now_l) / 2 - now_l >= 1) {
                    q.push({now_l, (now_r + now_l) / 2});
                    q.push({(now_r + now_l) / 2, now_r});
                }
            }
        }
    }

    struct Kek {
        int w;
        int left;
        int right;
    };
    map<int, Kek> ans;
    for (int pos = N - 2; pos >= 0; --pos) {
        for (int i = 0; i < graph[pos].size(); ++i) {
            if (abs(graph[pos + 1][2 * i].weight - graph[pos + 1][2 * i + 1].weight) > 1) {
                cout << -1 << endl;
                return 0;
            }
            if (graph[pos][i].num != 0) {
                graph[pos][i].weight = graph[pos][i].num + graph[pos + 1][2 * i].weight + graph[pos + 1][2 * i + 1].weight;
                ans[graph[pos][i].pos] = {graph[pos][i].num, graph[pos + 1][2 * i].pos,graph[pos + 1][2 * i + 1].pos};
            }
        }
    }

    for (const auto& [key, val] : ans) {
        cout << val.w << " " << val.left << " " << val.right << '\n';
    }

    cout << endl;

    return 0;

}
