#include <iostream>
#include <iomanip>
#include <stack>
#include <vector>
#include <map>
#include <queue>
#include <math.h>
#include <iomanip>
#include <set>
#include <string>
#include <stdlib.h>
#include <time.h> 
#include <algorithm>
#define ll long long
#define ui unsigned int
#define ld long double
#define p(x,y) make_pair(x, y)
#define TASK "railroad"
using namespace std;
const ll MAXN = 200001;
const double eps = 1e-8;
void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
}

int ans[100009];

vector<int> g[100009], reg[100009], topsortans;

int wasdfs[100009];

int was[100009];

int n;

void dfs (int v)
{
	wasdfs[v] = 1;
	for (int i = 0; i < g[v].size(); i++)
	{
		if (!wasdfs[g[v][i]])
			dfs(g[v][i]);
	}
	topsortans.push_back(v);
}
 
void topsort() {
	for (int i = 0; i < n; i++)
		if (!wasdfs[i])
			dfs(i);
	reverse(topsortans.begin(), topsortans.end());
}

int main()
{
	fastIO();
	int k, a;
	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		cin >> k;
		for (int j =0; j < k; j++)
		{
			cin >> a;
			g[was[a]].push_back(i);
			reg[i].push_back(was[a]);
			was[a] = i;
		}
	}
	n++;
	topsort();
	int realans = 0;
	for (int i = 1; i < n; i++)
	{
		int v = topsortans[i];
		for (int j = 0; j < reg[v].size(); j++)
			ans[v] = max(ans[reg[v][j]], ans[v]);
		ans[v]++;
		realans = max(ans[v], realans);
	}
	cout << realans;
	return 0;
}

//#include <iostream>
//#include <iomanip>
//#include <stack>
//#include <vector>
//#include <map>
//#include <queue>
//#include <math.h>
//#include <iomanip>
//#include <set>
//#include <string>
//#include <stdlib.h>
//#include <time.h> 
//#include <algorithm>
//#define ll long long
//#define ui unsigned int
//#define ld long double
//#define p(x,y) make_pair(x, y)
//#define TASK "railroad"
//using namespace std;
//const ll MAXN = 200001;
//const double eps = 1e-8;
//void fastIO() {
//	ios_base::sync_with_stdio(0);
//	cin.tie(0);
//	cout.tie(0);
//	//freopen("input.txt", "r", stdin);
//	//freopen("output.txt", "w", stdout);
//}
//
//vector <vector<int>> arrs;
//int locans[10];
//
//void gen (int cnt, int maxcnt)
//{
//	if (cnt != 0 && maxcnt - cnt + 1 > locans[cnt - 1])
//		return;
//	for (int i = (cnt == 0)? 0 : locans[cnt - 1]; i < 10; i++)
//	{
//		locans[cnt] = i;
//		if (cnt != maxcnt)
//			gen(cnt + 1, maxcnt);
//		else
//		{
//			arrs.resize(arrs.size() + 1);
//			for (int j = 1; j <= maxcnt; j++)
//				arrs.back().push_back(locans[j]);
//		}
//	}
//}
//
//int main()
//{
//	fastIO();
//	string a, b, c;
//	set <char> dic;
//	cin >> a >> b;
//	for (int i = 0; i < a.size(); i++)
//		dic.insert(a[i]);
//	for (int i = 0; i < b.size(); i++)
//		dic.insert(a[i]);
//	if (dic.size() > 10)
//	{
//		cout << 0;
//		return 0;
//	}
//	gen(1, dic.size());
//	map <string, int> ans;
//	map <int, char> letters;
//	for (int z = 0; z < arrs.size(); z++)
//	{
//		while(next_permutation(arrs[z].begin(), arrs[z].end()))
//		{
//			if (arrs[z][a[0])
//			for (int i = 0; i < a.size; i++)
//
//
//		}
//	}
//	int n;
//	return 0;
//}